SystemOrganization addCategory: #Deli!
SystemOrganization addCategory: #'Deli-models'!
SystemOrganization addCategory: #'Deli-configuration'!
SystemOrganization addCategory: #'Deli-frontend'!
SystemOrganization addCategory: #'Deli-announcements'!
SystemOrganization addCategory: #'Deli-tutorial'!
SystemOrganization addCategory: #'Deli-util'!
SystemOrganization addCategory: #'Deli-tests'!

HPISession subclass: #DLSession
	instanceVariableNames: 'user announcer activeMenuEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLSession methodsFor: 'accessing' stamp: 'cr 7/23/2009 19:09'!
activeMenuEntry

	^ activeMenuEntry! !

!DLSession methodsFor: 'accessing' stamp: 'cr 7/23/2009 19:09'!
activeMenuEntry: anObject

	activeMenuEntry := anObject.! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:04'!
announcer
	^ announcer ifNil: [ announcer := Announcer new. ].! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:03'!
charSet
	^ 'iso-8859-1'! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 7/19/2009 22:58'!
fullname
	(self firstname notNil) & (self lastname notNil) ifTrue: [^ (self firstname,' ',self lastname)].
	^ nil.! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 7/19/2009 23:00'!
login: aUsername
	super login: aUsername.
	self user: (DLUser getOrCreateFrom: {#userName -> self username} withDefaultValues: {#realName->self fullname. #email->self email}).! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 6/10/2009 18:10'!
logout
	self expire.
	self user: nil.
	super logout.! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 7/14/2009 13:25'!
user
	^ user.! !

!DLSession methodsFor: 'accessing' stamp: 'Marik 5/20/2009 17:08'!
user: anObject

	user := anObject.! !

MATextInputComponent subclass: #DLMALinkComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMALinkComponent class methodsFor: 'accessing' stamp: 'cr 7/13/2009 14:41'!
isAbstract
	^false! !

!DLMALinkComponent methodsFor: 'rendering' stamp: 'sebh 7/14/2009 23:19'!
renderViewerOn: html
	html anchor url: self value; with: '[Beschreibung]'.! !

DLMALinkComponent subclass: #DLMAMailLinkComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAMailLinkComponent methodsFor: 'as yet unclassified' stamp: 'MG 7/24/2009 17:34'!
renderViewerOn: html
	html anchor url: 'mailto:',self value; with: [html image url: DLFileLibrary/#emailPng].! !

MAComponentRenderer subclass: #DLCssRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 7/19/2009 20:55'!
collectErrors
	| errorList |
	errorList := Set new.
	[component doValidate]
		on: MAError
		do: [:error | errorList add: error messageText. ].
	^ errorList.! !

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 7/19/2009 20:21'!
collectErrors: aDescription
	| current |
	errors ifNotNil: [ ^ errors includes: aDescription ].
	errors := IdentitySet new.
	current := component.
	[ current notNil ] whileTrue: [
		current isMagritteContainer ifTrue: [
			current errors do: [ :each |
				errors add: (each tag isDescription
					ifTrue: [ each tag ]
					ifFalse: [ current description ]) ] ].
		current := current parent ].
	^ self hasError: aDescription! !

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 6/8/2009 00:21'!
renderContainer: aDescription 
	html definitionList
		class: (self classFor: aDescription);
		with: [ super renderContainer: aDescription ]! !

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 7/19/2009 20:41'!
renderControl: aDescription
	html definitionData
		class: (self classFor: aDescription);
		with: [ 
				  super renderControl: aDescription.
				  html div class:'helptext'; with: aDescription comment.
				  (self hasError: aDescription) ifTrue: 
						[
							html unorderedList
								class: 'errors';
								list: self collectErrors;
								with: nil.
						].
			]! !

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 6/8/2009 00:21'!
renderGroup: aDescription
	super renderGroup: aDescription.
	group isNil ifTrue: [ ^ self ].
	html definitionTerm
		class: 'group';
		with: group! !

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 6/8/2009 00:21'!
renderLabel: aDescription
	html definitionTerm
		title: aDescription comment;
		class: (self classFor: aDescription);
		with: [ super renderLabel: aDescription ]! !

MAExternalFileModel subclass: #DLMAExternalFileModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAExternalFileModel methodsFor: 'accessing' stamp: 'sebh 6/14/2009 01:33'!
calcFilesize
	filesize := self contents size.! !

!DLMAExternalFileModel methodsFor: 'accessing' stamp: 'sebh 6/14/2009 01:35'!
filesize: aFilesize
	"Allow to manually set filesize so we can save it somewhere else."
	filesize := aFilesize.! !

!DLMAExternalFileModel methodsFor: 'accessing' stamp: 'sebh 6/14/2009 01:30'!
isEmpty
	^ location isEmpty! !

!DLMAExternalFileModel methodsFor: 'accessing' stamp: 'Marik 7/20/2009 15:53'!
location: aLocation
	| directory |
	location := aLocation.
	directory := self baseDirectory.
	directory assureExistence.
	aLocation do: [:each |
		directory := directory directoryNamed: each.
		directory assureExistence.
	]! !

!MADateInputComponent methodsFor: '*deli-actions' stamp: 'sebh 7/24/2009 14:26'!
chooser: aComponent
	self chooser: aComponent titled: self description label, ' auswhlen'! !

HPIAuthMain subclass: #DLAuthMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLAuthMain methodsFor: 'requestHandling' stamp: 'sebh 6/9/2009 23:33'!
createRoot
	^ super createRoot
		addDecoration: DLAuthentication new;
		yourself! !

HPIAuthentication subclass: #DLAuthentication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLAuthentication methodsFor: 'permission' stamp: 'sebh 6/10/2009 13:12'!
verifyPassword: password forUser: username
	^ self session isLoggedIn or: [
			(username = 'jack') | (username = 'john')
			ifTrue: [self session login: username]
			ifFalse:[super verifyPassword: password forUser: username].
			self session isLoggedIn]! !

Announcement subclass: #DLLogoutAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-announcements'!

Announcement subclass: #DLViewCompReplacement
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-announcements'!

!DLViewCompReplacement class methodsFor: 'accessing' stamp: 'sebh 6/3/2009 17:57'!
forComponent: aComponent
	^ self new
		component: aComponent;
		yourself.! !

!DLViewCompReplacement methodsFor: 'accessing' stamp: 'sebh 6/3/2009 17:55'!
component

	^ component! !

!DLViewCompReplacement methodsFor: 'accessing' stamp: 'sebh 6/3/2009 17:55'!
component: anObject

	component := anObject.! !

WAComponent subclass: #DLComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLComponent subclass: #DLAdminConfirmDeleteComp
	instanceVariableNames: 'deleteElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminConfirmDeleteComp class methodsFor: 'initialize' stamp: 'sebh 6/15/2009 11:04'!
for: anElement
	^ self new
		deleteElement: anElement;
		yourself.! !

!DLAdminConfirmDeleteComp methodsFor: 'accessing' stamp: 'sebh 6/15/2009 11:12'!
deleteElement

	^ deleteElement! !

!DLAdminConfirmDeleteComp methodsFor: 'accessing' stamp: 'sebh 6/15/2009 11:12'!
deleteElement: anObject

	deleteElement := anObject.! !

!DLAdminConfirmDeleteComp methodsFor: 'permission' stamp: 'sebh 6/15/2009 11:14'!
permissionCheck
	^ self session user isAdmin! !

!DLAdminConfirmDeleteComp methodsFor: 'rendering' stamp: 'martin 7/24/2009 17:23'!
renderContent: html
	
	self renderDeletionConfirmation: html.
	self renderDependencies: html.
	html break.
	self renderDeletionConfirmation: html.! !

!DLAdminConfirmDeleteComp methodsFor: 'rendering' stamp: 'martin 7/24/2009 17:21'!
renderDeletionConfirmation: html

	html text: 'Mchten sie "', self deleteElement asString, '" wirklich lschen?'; break.
	
	html anchor 
				callback: [self answer: true];
				text: 'Ja'.
	html text: ' | '.
	html anchor
				callback: [self answer: false];
				text: 'Nein'.
	html break.
	html break.
	! !

!DLAdminConfirmDeleteComp methodsFor: 'rendering' stamp: 'martin 7/24/2009 17:09'!
renderDependencies: html
	|dependencies lastDependency|
	lastDependency := ''.
	dependencies := self deleteElement collectDependencies.
	html paragraph: 'Folgende Element werden durch bestehende Abhngigkeiten ebenfalls gelscht'.
	html unorderedList:
		[
			dependencies do: [:aDependency | 
				html listItem: [
					lastDependency = (aDependency class metaName) ifFalse: [
						html div class: 'deletionDescription'; with: 
							aDependency class metaName, ':'.].
						
					lastDependency = (aDependency class metaName) ifTrue: [
						html div class: 'deletionDescription'; with: [
							html text: '-'].].
						
					html anchor
						callback: [self call: (DLAdminDetailComp for: aDependency)];
						with: [
							html div class: 'deletionItem'; with: [
								html text: aDependency canonicalName
							]
						].
					html div class: 'clearFloat'.
					lastDependency := aDependency class metaName.
				]	
			]
		] ! !

DLComponent subclass: #DLChartComp
	instanceVariableNames: 'count max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLChartComp class methodsFor: 'accessing' stamp: 'Marik 7/1/2009 12:10'!
count: aCount of: aMaxValue

	^self new
		count: aCount;
		max: aMaxValue;
		yourself.! !

!DLChartComp methodsFor: 'accessing' stamp: 'Marik 7/1/2009 12:06'!
count

	^ count! !

!DLChartComp methodsFor: 'accessing' stamp: 'Marik 7/1/2009 12:06'!
count: anObject

	count := anObject.! !

!DLChartComp methodsFor: 'accessing' stamp: 'Marik 7/1/2009 12:06'!
max

	^ max! !

!DLChartComp methodsFor: 'accessing' stamp: 'Marik 7/1/2009 12:06'!
max: anObject

	max := anObject.! !

!DLChartComp methodsFor: 'permission' stamp: 'Marik 7/1/2009 12:14'!
permissionCheck
	^ self session isLoggedIn.! !

!DLChartComp methodsFor: 'rendering' stamp: 'Marik 7/24/2009 16:47'!
renderContent: html
	| perCent perCentString |
	(self max isZero)
		ifTrue:[
			perCent := 0]
		ifFalse:[
			perCent := ((self count / self max) asFloat * 100) rounded].
	perCentString := perCent asString, '%'.
	html text: 'Fortschritt: ';
		  text: self count asString, '/', self max asString, ' Abgaben sind komplett.'.
	html div class:'graph';	  with: [html strong class:'bar'; style:'width: ', perCent asString,'%;'; 
												with: [html text: perCentString]].! !

!DLComponent methodsFor: 'accessing' stamp: 'cr 7/23/2009 19:39'!
initialize
	super initialize.! !

!DLComponent methodsFor: 'accessing' stamp: 'cr 7/23/2009 19:29'!
menuItem
	^nil.! !

!DLComponent methodsFor: 'permission' stamp: 'MG 6/5/2009 15:29'!
permissionCheck

	^ false.! !

!DLComponent methodsFor: 'rendering' stamp: 'MG 6/5/2009 15:29'!
renderContent: html

	self subclassResponsibility! !

!DLComponent methodsFor: 'rendering' stamp: 'cr 7/23/2009 19:39'!
renderContentOn: html
	html div class: 'component'; with:[
	self permissionCheck 
		ifTrue: [self renderContent: html.]
		ifFalse:[html heading: 'Permission denied' level:3]].
	self menuItem ifNotNil: [
		self session activeMenuEntry: self menuItem.
	].! !

DLComponent subclass: #DLDetailComp
	instanceVariableNames: 'detailElement additionalComps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLDetailComp subclass: #DLAdminDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminDetailComp methodsFor: 'permission' stamp: 'Marik 6/4/2009 21:21'!
permissionCheck

	^ self session user isAdmin! !

!DLDetailComp class methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:28'!
for: anDetailElement

	^self new
		detailElement: anDetailElement;
		yourself.! !

!DLDetailComp class methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:16'!
for: anDetailElement additionalComp: aComponent
	^self for: anDetailElement additionalComps: {aComponent}! !

!DLDetailComp class methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:15'!
for: anDetailElement additionalComps: aComponentList

	|new|
	new := self new
		detailElement: anDetailElement.
	new additionalComps addAll: aComponentList.
	^ new.! !

!DLDetailComp methodsFor: 'accessing' stamp: 'sebh 6/6/2009 16:39'!
additionalComps
	^ additionalComps! !

!DLDetailComp methodsFor: 'accessing' stamp: 'sebh 6/6/2009 16:39'!
additionalComps: anObject 
	additionalComps := anObject! !

!DLDetailComp methodsFor: 'initialize' stamp: 'sebh 6/6/2009 16:44'!
children
	^ self additionalComps asArray.! !

!DLDetailComp methodsFor: 'accessing' stamp: 'Marik 6/4/2009 21:09'!
detailElement

	^ detailElement! !

!DLDetailComp methodsFor: 'accessing' stamp: 'Marik 6/4/2009 21:09'!
detailElement: anObject

	detailElement := anObject.! !

!DLDetailComp methodsFor: 'initialize' stamp: 'sebh 6/6/2009 16:44'!
initialize

	super initialize.
	self additionalComps: OrderedCollection new.! !

!DLDetailComp methodsFor: 'permission' stamp: 'Marik 6/4/2009 21:14'!
permissionCheck
	
	^ self session isLoggedIn! !

!DLDetailComp methodsFor: 'rendering' stamp: 'MG 7/23/2009 19:54'!
renderActions: html
	html div class: 'actions'; with: [
		(self detailElement rightUpdate: self session user) ifTrue: [
			html anchor
				callback: [| answer |
					answer := self call: (self detailElement descriptionUpdate asComponentOn: self detailElement) addForm.
					answer ifNotNil: [self detailElement save]];
				with: [html image url: DLFileLibrary / #editPng].
			html text: ' '.
			].
		self detailElement trackChangeVariables ifNotEmpty: [
			html anchor
				callback: [ self call: (DLListComp for: DLLogEntry 
					 										  with: {#klassName->self detailElement className. #objectId->self detailElement oid}
			 	  )];
				with: [html image url: DLFileLibrary / #logPng].
			html text: ' '.
			].
		html anchor
			callback: [self answer: true];
			with: [html image url: DLFileLibrary / #backPng]
		].
	
! !

!DLDetailComp methodsFor: 'rendering' stamp: 'MG 7/24/2009 17:38'!
renderContent: html
	| descriptionCopy |
	
	html heading: (self detailElement class metaName,': ',self detailElement canonicalName) level: 2.
	self renderActions: html.
	descriptionCopy := self detailElement descriptionDetail collect:[:desc|desc copy beReadonly; yourself.].
	html render: (descriptionCopy asComponentOn: self detailElement).
	self additionalComps do: [:each | 
		html render: each.
	].! !

DLDetailComp subclass: #DLUserDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLUserDetailComp subclass: #DLUserDeliveryDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserDeliveryDetailComp class methodsFor: 'accessing' stamp: 'MG 7/23/2009 17:23'!
for: aDeadline user: aUser
	| group delivery deliverables |
	
	group := aUser groupForLecture: aDeadline lecture.
	group ifNotNil:[
		delivery := DLDelivery getOrCreateFrom: {#group -> group. #deadline -> aDeadline.}.
		deliverables := OrderedCollection new.
		delivery deliverables do: [:aDeliverable | deliverables add: (aDeliverable descriptionUpdate asComponentOn: 		aDeliverable) addForm].
		^ self for: delivery additionalComps: deliverables]
	ifNil: [^ self for: (DLDelivery getOrCreateFrom: {#deadline -> aDeadline.}) additionalComps: OrderedCollection new].! !

!DLUserDeliveryDetailComp methodsFor: 'permission' stamp: 'MG 7/23/2009 17:32'!
permissionCheck
	
	^ self session isLoggedIn! !

!DLUserDeliveryDetailComp methodsFor: 'rendering' stamp: 'MG 7/23/2009 17:37'!
renderContent: html
	self renderActions: html.
	html definitionList with: [
		self detailElement descriptionDetail do: [:desc |
			html definitionTerm: desc label.
			html definitionData: (desc accessor read: (self detailElement))
		]
	].
	(self detailElement deadline isNotExpired) 
		ifTrue: [additionalComps do: [:each | 
			html div with: each.
			html break; break]]
		ifFalse: [html div with: 'Abgabetermin ist ausgelaufen.'].
	self additionalComps ifEmpty: [html text: 'Bitte trete erst einer Gruppe bei.']! !

!DLUserDetailComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 19:17'!
renderActions: html
	! !

DLUserDetailComp subclass: #DLUserLectureDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserLectureDetailComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 21:04'!
renderActions: html
	html div class: 'actions'; with: [
		html anchor
			callback: [|answer group|
					group := DLGroup newFrom: {#lecture->self detailElement}.
					answer := self call: (group descriptionUpdate asComponentOn: group) addForm.
					answer ifNotNil: [group save]];
			text: 'Gruppe anlegen'.
		].! !

DLUserDetailComp subclass: #DLUserProfileDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserProfileDetailComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 21:04'!
renderActions: html
	"Duplicate from DLDetailComp"
	html div class: 'actions'; with: [
		(self detailElement rightUpdate: self session user) ifTrue: [
			html anchor
				callback: [|answer|
					answer := self call: (self detailElement descriptionUserUpdate asComponentOn: self detailElement) addForm.
					answer ifNotNil: [self detailElement save]];
				text: 'Bearbeiten'.
			].
		].! !

DLComponent subclass: #DLFrontPageComp
	instanceVariableNames: 'reportComps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLFrontPageComp methodsFor: 'initialize' stamp: 'cr 7/20/2009 17:29'!
children
	^ self reportComps asArray! !

!DLFrontPageComp methodsFor: 'initialize' stamp: 'cr 7/23/2009 19:23'!
initialize
	
	super initialize.
	self session activeMenuEntry: 'Startseite'.
	self reportComps: OrderedCollection new.
	
	self session user isAdmin ifTrue: [
		self initializeAdminView.
		]
	ifFalse: [
		self initializeUserView.
	].! !

!DLFrontPageComp methodsFor: 'initialize' stamp: 'cr 7/21/2009 15:04'!
initializeAdminView
	self reportComps add: DLAdminRelatedDeadLineListComp new;
		add: DLAdminCurrentLectureListComp new;
		add: DLAdminUpcomingLectureListComp new.! !

!DLFrontPageComp methodsFor: 'initialize' stamp: 'cr 7/21/2009 15:09'!
initializeUserView
	self reportComps add: (DLUserDeadlineListComp for: self session user);
		add: DLUserChosenLectureListComp new.! !

!DLFrontPageComp methodsFor: 'permission' stamp: 'cr 7/18/2009 22:11'!
permissionCheck
	^ self session isLoggedIn.! !

!DLFrontPageComp methodsFor: 'rendering' stamp: 'sebh 7/20/2009 18:37'!
renderContent: html
	html heading: 'Willkommen bei Deli' level: 1.
	
	self reportComps do: [ :aReport |
		html div with: aReport.
	].! !

!DLFrontPageComp methodsFor: 'accessing' stamp: 'cr 7/20/2009 17:30'!
reportComps

	^ reportComps! !

!DLFrontPageComp methodsFor: 'accessing' stamp: 'cr 7/20/2009 17:30'!
reportComps: anObject

	reportComps := anObject.! !

DLComponent subclass: #DLListComp
	instanceVariableNames: 'listClass magritteReport hiddenStart collectionFields valueFields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLListComp subclass: #DLAdminListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLAdminListComp subclass: #DLAdminDeadLineListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminDeadLineListComp methodsFor: 'rendering' stamp: 'Marik 7/24/2009 10:43'!
actions
	^ { 
		((self listClass rightCreate: self session user) -> (#add -> 
				[ | answer listElement |
				listElement := self listClass newFrom: self valueFields.
				answer := self lightbox: ((listElement descriptionCreateForLecture asComponentOn: listElement) addForm; yourself).
				answer ifNotNil: [ listElement save ].
				self refreshReport ]))
	 }! !

!DLAdminDeadLineListComp methodsFor: 'rendering' stamp: 'Marik 7/24/2009 16:35'!
columnDetail
^ (DLMACommandColumn new
	useImages: true;
			addCommand: [:listElement |
					self call: (
						DLAdminDetailComp for: listElement 
							additionalComps: {(DLChartComp count: listElement countDeliveriesComplete of: listElement deliveries size).(DLAdminDeliveryListComp with: {#deadline->listElement}).}
					)
			]
			text: #details;
			yourself).! !

!DLAdminDeadLineListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 22:29'!
listClass
	^ DLDeadline! !

!DLAdminDeadLineListComp methodsFor: 'rendering' stamp: 'cr 7/23/2009 19:31'!
menuItem

	^'Abgaben'! !

DLAdminDeadLineListComp subclass: #DLAdminRelatedDeadLineListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminRelatedDeadLineListComp methodsFor: 'rendering' stamp: 'cr 7/20/2009 19:39'!
actions

	^{}! !

!DLAdminRelatedDeadLineListComp methodsFor: 'as yet unclassified' stamp: 'Marik 7/24/2009 16:50'!
columnDetail
^ (DLMACommandColumn new
	useImages: true;
			addCommand: [:listElement |
					self session announcer announce: ((DLViewCompReplacement) forComponent:  (
						DLAdminDetailComp for: listElement 
							additionalComps: {(DLChartComp count: listElement countDeliveriesComplete of: listElement deliveries size).(DLAdminDeliveryListComp with: {#deadline->listElement}).}
					))
			]
			text: #details;
			yourself).! !

!DLAdminRelatedDeadLineListComp methodsFor: 'rendering' stamp: 'cr 7/23/2009 16:48'!
listObjects
	
	^(SqsSearch for: DLDeadline) findAll
		select: [ :aDeadline |
		((aDeadline lecture teacher = self session user)
		| (aDeadline lecture assistants includes: self session user)
		| (aDeadline lecture studentAssistants includes: self session user))
		& (aDeadline date < (Date today addDays: 14))
		].! !

!DLAdminRelatedDeadLineListComp methodsFor: 'rendering' stamp: 'cr 7/20/2009 20:02'!
reportTitle
	
	^'Abgabetermine der nchsten 14 Tage'! !

DLAdminListComp subclass: #DLAdminDeliveryListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminDeliveryListComp methodsFor: 'rendering' stamp: 'Marik 7/20/2009 16:58'!
columnDetail
| detailBlock |
detailBlock := [:listElement | 
					self call: (
						DLAdminDetailComp for: listElement 
							additionalComps: {(DLAdminListComp for: DLDeliverable with: {#delivery->listElement}).}
					)].
^ (DLMAConditionalCommandColumn new
			addCommand: detailBlock
			condition: [:listElement| listElement isComplete]
			text: 'Komplett';
			addCommand: detailBlock
			condition: [:listElement| listElement isComplete not]
			text: 'Nicht komplett';
			yourself).! !

!DLAdminDeliveryListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 22:36'!
listClass
	^ DLDelivery! !

!DLAdminDeliveryListComp methodsFor: 'rendering' stamp: 'Marik 7/1/2009 15:30'!
listObjects
	"Precreate all Deliveries for a given lecture"
	| deadline |
	deadline := self valueFieldsAt: #deadline.
	deadline ifNotNil: [ 
		| groups |
		groups := (SqsSearch for: DLGroup) select: [:aGroup | (aGroup lecture) = (deadline lecture)].
		groups do: [:aGroup | 
			DLDelivery getOrCreateFrom: {#deadline->deadline. #group->aGroup}.	
		]
	].
	^ super listObjects.
	! !

DLAdminListComp subclass: #DLAdminGroupListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminGroupListComp methodsFor: 'rendering' stamp: 'Marik 7/24/2009 11:01'!
columnDetail
	^ DLMACommandColumn new
		useImages: true;
		addCommand: 
				[ :listElement | 
				self call: (DLAdminDetailComp 
						for: listElement
						additionalComps: { 
								(DLAdminListComp 
									for: DLDeadline
									with: {  (#group -> listElement). (#lecture -> listElement lecture)  }).
							 }) ]
			text: #details;
		yourself! !

!DLAdminGroupListComp methodsFor: 'rendering' stamp: 'caro 7/15/2009 17:27'!
listClass
	^ DLGroup.! !

!DLAdminGroupListComp methodsFor: 'rendering' stamp: 'cr 7/23/2009 19:32'!
menuComp

	^'Gruppen'! !

!DLAdminGroupListComp methodsFor: 'rendering' stamp: 'cr 7/23/2009 19:40'!
menuItem

	^'Gruppen'! !

DLAdminListComp subclass: #DLAdminLectureListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLAdminLectureListComp subclass: #DLAdminCurrentLectureListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminCurrentLectureListComp methodsFor: 'rendering' stamp: 'cr 7/20/2009 19:31'!
actions
	^{}! !

!DLAdminCurrentLectureListComp methodsFor: 'rendering' stamp: 'cr 7/20/2009 19:31'!
additionalActions
	^{}! !

!DLAdminCurrentLectureListComp methodsFor: 'as yet unclassified' stamp: 'Marik 7/24/2009 13:02'!
columnDetail
	^ DLMACommandColumn new
		useImages: true;
		addCommand: 
				[ :listElement | 
				self session announcer announce: ((DLViewCompReplacement) forComponent: (DLAdminDetailComp 
						for: listElement
						additionalComps: { 
								(DLAdminListComp 
									for: DLDeadline
									with: {  (#lecture -> listElement)  }) startsHidden.
								(DLAdminListComp 
									for: DLTopic
									with: {  (#lecture -> listElement)  }) startsHidden.
								(DLAdminListComp 
									for: DLGroup
									with: {  (#lecture -> listElement)  }) startsHidden.
								(DLAdminGrouplessUserListComp for: listElement)
							 })) ]
			text: #details;
		yourself! !

!DLAdminCurrentLectureListComp methodsFor: 'rendering' stamp: 'cr 7/20/2009 17:30'!
listObjects
	
	| semester |
	semester := DLSemester getForDate: Date today.
	
	^(SqsSearch for: DLLecture) select: [:aLecture | aLecture semester = semester].! !

!DLAdminCurrentLectureListComp methodsFor: 'rendering' stamp: 'cr 7/20/2009 17:29'!
reportTitle

	^ 'Lehrveranstaltungen dieses Semesters'! !

DLAdminCurrentLectureListComp subclass: #DLAdminUpcomingLectureListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminUpcomingLectureListComp methodsFor: 'rendering' stamp: 'cr 7/20/2009 19:31'!
actions
	^{}! !

!DLAdminUpcomingLectureListComp methodsFor: 'rendering' stamp: 'cr 7/20/2009 19:30'!
additionalActions
	^{}! !

!DLAdminUpcomingLectureListComp methodsFor: 'rendering' stamp: 'cr 7/20/2009 19:30'!
listObjects
	
	| semester |
	semester := (DLSemester getForDate: Date today) nextSemester.
	
	^(SqsSearch for: DLLecture) select: [:aLecture | aLecture semester = semester].! !

!DLAdminUpcomingLectureListComp methodsFor: 'rendering' stamp: 'cr 7/20/2009 17:34'!
reportTitle

	^ 'Lehrveranstaltungen des nchsten Semesters'! !

!DLAdminLectureListComp methodsFor: 'rendering' stamp: 'Marik 7/24/2009 14:01'!
columnDetail
	^ DLMACommandColumn new
		useImages: true;
		addCommand: 
				[ :listElement | 
				self call: (DLAdminDetailComp 
						for: listElement
						additionalComps: { 
								(DLAdminListComp 
									for: DLDeadline
									with: {  (#lecture -> listElement)  }) startsHidden.
								(DLAdminListComp 
									for: DLTopic
									with: {  (#lecture -> listElement)  }) startsHidden.
								(DLAdminGroupListComp 
									for: DLGroup
									with: {  (#lecture -> listElement)  }) startsHidden.
								(DLAdminGrouplessUserListComp for: listElement)
							 }) ]
			text: #details;
		yourself! !

!DLAdminLectureListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 17:34'!
listClass
	^ DLLecture.! !

!DLAdminLectureListComp methodsFor: 'rendering' stamp: 'cr 7/23/2009 19:32'!
menuItem
	^'Lehrveranstaltungen'! !

!DLAdminListComp methodsFor: 'accessing' stamp: 'sebh 7/14/2009 00:18'!
deleteComponent
	^DLAdminConfirmDeleteComp! !

!DLAdminListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 19:25'!
detailComponent
	^DLAdminDetailComp! !

!DLAdminListComp methodsFor: 'description' stamp: 'sebh 6/13/2009 19:39'!
listDescription
	^ (self listClass) new descriptionAdminList! !

!DLAdminListComp methodsFor: 'permission' stamp: 'sebh 6/6/2009 17:01'!
permissionCheck
	^ self session user isAdmin! !

!DLAdminListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:31'!
reportEmptyMessage
	^ 'Es wurden noch keine ',self listClass metaNamePlural,' erstellt.'! !

DLAdminListComp subclass: #DLAdminTopicListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminTopicListComp methodsFor: 'rendering' stamp: 'MG 7/23/2009 19:51'!
columnDetail
	^ (DLMACommandColumn new
			useImages: true;
			addCommand: [:listElement |
					self call: (DLAdminDetailComp for: listElement )]
			text: #details;
			yourself).! !

!DLAdminTopicListComp methodsFor: 'rendering' stamp: 'caro 6/26/2009 01:08'!
listClass
	^ DLTopic.! !

!DLAdminTopicListComp methodsFor: 'rendering' stamp: 'cr 7/23/2009 19:35'!
menuItem

	^'Themen'! !

DLAdminListComp subclass: #DLAdminUserListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLAdminUserListComp subclass: #DLAdminGrouplessUserListComp
	instanceVariableNames: 'lecture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminGrouplessUserListComp class methodsFor: 'accessing' stamp: 'caro 7/12/2009 17:40'!
for: aLecture
	^ self new
		lecture: aLecture;
		yourself.! !

!DLAdminGrouplessUserListComp methodsFor: 'rendering' stamp: 'caro 7/24/2009 17:20'!
additionalColumns
	^ {(DLMACommandColumn new
			useImages: true;
			addCommand: [:listElement | 
				|answer|
				answer := self lightbox: (DLUserJoinGroupComp for: listElement lectures: {self lecture}).
				self refreshReport.
				]
			text: #group;
			yourself)} ! !

!DLAdminGrouplessUserListComp methodsFor: 'rendering' stamp: 'caro 7/16/2009 15:14'!
initializeReport
	super initializeReport.
	self magritteReport tableEmpty:  'Es gibt keine gruppenlosen Benutzer bei dieser Lehrveranstaltung.'! !

!DLAdminGrouplessUserListComp methodsFor: 'accessing' stamp: 'caro 7/12/2009 17:33'!
lecture

	^ lecture! !

!DLAdminGrouplessUserListComp methodsFor: 'accessing' stamp: 'caro 7/12/2009 17:33'!
lecture: anObject

	lecture := anObject.! !

!DLAdminGrouplessUserListComp methodsFor: 'rendering' stamp: 'MG 7/23/2009 19:50'!
listObjects
	|answer students|
	students := OrderedCollection new.
	answer := OrderedCollection new.
	students := (self lecture students).
	students do:[:anElement |
		(anElement groupForLecture: lecture) ifNil: [answer add: anElement]].
	^ answer! !

!DLAdminGrouplessUserListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:15'!
reportTitle
	^ 'Gruppenlose Nutzer'! !

!DLAdminUserListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 21:03'!
columnEmail
	^ (MACommandColumn new 
			addCommand: [:aListElement | 
				|answer mail receivers| 
				mail := DLMail new.
				mail sender: self session user email.
				receivers := OrderedCollection new.
				receivers add: aListElement email. 
				mail receiversAsCollection: receivers.
				answer := self call: (mail description asComponentOn: mail) addForm.
				answer ifNotNil: [answer sendMail].
				self refreshReport.]
			text: 'Email'
			yourself).! !

!DLAdminUserListComp methodsFor: 'rendering' stamp: 'martin 7/18/2009 13:34'!
listClass
	^ DLUser.! !

!DLAdminUserListComp methodsFor: 'rendering' stamp: 'cr 7/23/2009 19:40'!
menuItem
	^'Benutzer'! !

!DLListComp class methodsFor: 'accessing' stamp: 'sebh 6/6/2009 00:26'!
for: aListElement
	^ self new
		listClass: aListElement;
		yourself.! !

!DLListComp class methodsFor: 'accessing' stamp: 'Marik 7/24/2009 11:02'!
for: aClass with: anObjectDict
	"Given a dictionary of #fieldname to object, this method constructs a query."
	| newlist inspect |
	newlist := self new.
	newlist listClass: aClass.
	inspect := aClass new.
	anObjectDict do: [:pair | 
			(inspect perform: pair key) isCollection
			ifTrue: [ newlist collectionFields add: pair ]
			ifFalse:[ newlist valueFields add: pair ].
		].
	^ newlist.! !

!DLListComp class methodsFor: 'accessing' stamp: 'sebh 6/13/2009 22:50'!
with: anObjectDict
	| newlist inspect |
	newlist := self new.
	inspect := newlist listClass new.
	anObjectDict do: [:pair | 
			(inspect perform: pair key) isCollection
			ifTrue: [ newlist collectionFields add: pair ]
			ifFalse:[ newlist valueFields add: pair ].
		].
	^ newlist.! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 7/23/2009 17:18'!
actions
	^ { 
		((self listClass rightCreate: self session user) -> (#add -> 
				[ | answer listElement |
				listElement := self listClass newFrom: self valueFields.
				answer := self lightbox: ((listElement descriptionCreate asComponentOn: listElement) addForm; yourself).
				answer ifNotNil: [ listElement save ].
				self refreshReport ]))
	 }! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 6/18/2009 14:42'!
additionalActions
	^ {}! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 14:47'!
additionalColumns
	^ {}! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 6/18/2009 21:57'!
call: someComponent
	"Refresh list after a call to another component, values might have changed."
	| result |
	result := super call: someComponent.
	self refreshReport.
	^ result! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:26'!
children

	^ Array with: self magritteReport.! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 17:41'!
collectionFields

	^ collectionFields! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 17:41'!
collectionFields: anObject

	collectionFields := anObject.! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 7/24/2009 15:10'!
columnDelete
	^ (DLMACommandColumn new
		useImages: true;
			addCommand: [:listElement | |answer| 
				answer := self call: (self deleteComponent for: listElement).
				answer ifTrue: [listElement collectDependencies do: [:element| element destroy]].
				self refreshReport.
				]  
			text: #delete; 
			yourself).	! !

!DLListComp methodsFor: 'rendering' stamp: 'MG 7/23/2009 19:52'!
columnDetail
	^ (DLMACommandColumn new 
			useImages: true;
			addCommand: [:listElement | self call: (self detailComponent for: listElement)]  
			text:#details; 
			yourself).	! !

!DLListComp methodsFor: 'rendering' stamp: 'MG 7/23/2009 19:52'!
columnUpdate
	^ (DLMACommandColumn new
			useImages: true;
			addCommand: [:listElement | 
				|answer| 
				answer := self lightbox: ((listElement descriptionUpdate asComponentOn: listElement) addForm; yourself).
				answer ifNotNil: [listElement save].
				self refreshReport.
				]
			text: #edit;
			yourself) ! !

!DLListComp methodsFor: 'rendering' stamp: 'caro 7/14/2009 12:17'!
columns
	| cols |
	cols := OrderedCollection new.
	(self listClass rightDetail: self session user) ifTrue: [ cols add: self columnDetail. ].
	(self listClass rightUpdate: self session user) ifTrue: [ cols add: self columnUpdate. ].
	(self listClass rightDelete: self session user) ifTrue: [ cols add: self columnDelete. ].
	cols addAll: self additionalColumns.
	^ cols select: [:aColumn | aColumn ~= nil ] ! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 7/13/2009 23:30'!
deleteComponent
	^DLAdminConfirmDeleteComp ! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 19:21'!
detailComponent
	^DLDetailComp! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 7/23/2009 19:49'!
hiddenStart

	^ hiddenStart! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 7/23/2009 19:49'!
hiddenStart: anObject

	hiddenStart := anObject.! !

!DLListComp methodsFor: 'initialize' stamp: 'sebh 6/13/2009 21:18'!
initialize
	super initialize.
	self valueFields: OrderedCollection new.
	self collectionFields: OrderedCollection new.! !

!DLListComp methodsFor: 'initialize' stamp: 'sebh 7/23/2009 20:09'!
initializeReport

	self magritteReport: (self reportClass rows: self listObjects
							 	  description: self listDescription).
	self magritteReport 
	   batchSize: 50;
 		tableEmpty: self reportEmptyMessage.
	
	self hiddenStart ifNotNil: [
		self magritteReport cssStyle: 'display:none'.
	].
		
	self columns do: [:each | self magritteReport addColumn: each].! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:33'!
listClass

	^ listClass! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:33'!
listClass: anObject

	listClass := anObject.! !

!DLListComp methodsFor: 'description' stamp: 'cr 6/6/2009 17:26'!
listDescription

	^ (self listClass) new descriptionList! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 23:27'!
listObjects
	| allElements |
	allElements := ((SqsSearch for: self listClass) select: self listSelectBlock).
	allElements := allElements select: [:anObject |
		"Get all objects that have been selected by for:with:"
		|truth|
		truth := true.
	   self collectionFields do: 
			[:field | ((anObject perform: field key) includes: (field value)) ifFalse: [truth := false] ].
		self valueFields do:
			[:field | ((anObject perform: field key) = (field value)) ifFalse: [truth := false]].
		truth.
	].
	^allElements.! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 18:40'!
listSelectBlock
	^[:anObject | ]
	! !

!DLListComp methodsFor: 'accessing' stamp: 'Marik 6/18/2009 17:48'!
magritteReport
	"Lazily initialize report"
	magritteReport ifNil: [self initializeReport].
	^ magritteReport! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:23'!
magritteReport: anObject

	magritteReport := anObject.! !

!DLListComp methodsFor: 'permission' stamp: 'sebh 6/6/2009 17:00'!
permissionCheck
	^ self session isLoggedIn.! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 23:29'!
refreshReport
	self magritteReport rows: self listObjects.! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 7/23/2009 17:48'!
renderActions: html
	html div class: 'actions'; with: [
		(self actions, self additionalActions) do: [:each |
			| permission actionName callback |
			permission := each key. actionName := each value key. callback := each value value.
			permission ifTrue: [
				html anchor
					callback: callback;
					with: [
						html image url: (DLFileLibrary / (actionName, 'Png' asSymbol)). html text: (self labelForSelector: actionName).]
				]
			] separatedBy: [html space.]
		].! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 7/23/2009 19:52'!
renderContent: html
	self renderTitle: html.
	self renderActions: html.
	html render: self magritteReport.! !

!DLListComp methodsFor: 'rendering' stamp: 'MG 7/23/2009 20:31'!
renderTitle: html
	html heading: [
	html text: self reportTitle.
	self hiddenStart ifNotNil: [
		html anchor onClick: '$(this).up().next(''table'').toggle()';
			with: [html image url: DLFileLibrary / #togglePng].
		]
	] level: 3.! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 7/23/2009 19:32'!
reportClass
	^ DLMAReport! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:28'!
reportEmptyMessage
	^ 'Es sind keine ',self listClass metaNamePlural,' vorhanden, die angezeigt werden knnen'.! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:27'!
reportTitle
	^ self listClass metaNamePlural.! !

!DLListComp methodsFor: 'initialize' stamp: 'sebh 7/23/2009 19:50'!
startsHidden
	self hiddenStart: true.! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 17:41'!
valueFields

	^ valueFields! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 17:41'!
valueFields: anObject

	valueFields := anObject.! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 22:57'!
valueFieldsAt: aKey
	| temp |
	temp := valueFields select: [:each | each key = aKey ].
	^ temp first value.! !

DLListComp subclass: #DLUserListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLUserListComp subclass: #DLUserDeadlineListComp
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserDeadlineListComp class methodsFor: 'accessing' stamp: 'sebh 6/13/2009 23:24'!
for: aUser
	^ self new
		user: aUser;
		yourself.! !

!DLUserDeadlineListComp class methodsFor: 'accessing' stamp: 'Marik 6/9/2009 13:59'!
for: aListElement user: aUser
	^ self new
		listClass: aListElement;
		user: aUser;
		yourself.! !

!DLUserDeadlineListComp methodsFor: 'rendering' stamp: 'MG 7/23/2009 19:50'!
additionalColumns
	"Checks whether a Deadline already is run out"
	| detailBlock |
	detailBlock := [:listElement | self call: (DLUserDeliveryDetailComp 
							for: listElement
							user: self session user) ].
	^ {(DLMAConditionalCommandColumn new
			useImages: true;
			addCommand: detailBlock
			condition:  [:listElement | listElement isNotCritical]
			text: #disk;
			
			addCommand: detailBlock
			condition:  [:listElement | listElement isCritical]
			text: #diskCritical;
			
			addCommand: detailBlock
			condition:  [:listElement | listElement isExpired]
			text: #diskOver
			yourself).}! !

!DLUserDeadlineListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 23:22'!
listClass
	^ DLDeadline! !

!DLUserDeadlineListComp methodsFor: 'rendering' stamp: 'martin 7/24/2009 15:13'!
listObjects
	
	| result lectures groups |
	result := OrderedCollection new.
	lectures  := (SqsSearch for: DLLecture) select: [:aLecture  | aLecture students includes: self user].
	groups 	 := (SqsSearch for: DLGroup)   select: [:aGroup    | aGroup students includes: self user].

	result    := ((SqsSearch for: DLDeadline) findAll) 
						select: [:aDeadline | 
							| truth |
							truth := false.
							aDeadline group = nil ifTrue: [
								groups   do: [:aGroup   | aGroup lecture = aDeadline lecture ifTrue: [truth:=true]]].
							aDeadline group = nil ifFalse: [
								groups do: [:aGroup | aGroup = aDeadline group ifTrue: [truth:=true]]].
							truth].
	^result! !

!DLUserDeadlineListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:16'!
reportTitle
	^ 'Meine Abgaben'! !

!DLUserDeadlineListComp methodsFor: 'accessing' stamp: 'Marik 6/9/2009 13:59'!
user

	^ user! !

!DLUserDeadlineListComp methodsFor: 'accessing' stamp: 'Marik 6/9/2009 13:59'!
user: anObject

	user := anObject.! !

DLUserListComp subclass: #DLUserGroupListComp
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserGroupListComp class methodsFor: 'accessing' stamp: 'sebh 6/13/2009 15:31'!
for: aUser
	^ self new
		user: aUser;
		yourself.! !

!DLUserGroupListComp methodsFor: 'rendering' stamp: 'caro 7/24/2009 15:58'!
additionalActions
	^ {
		true -> (#group ->[
			self call: (DLUserJoinGroupComp for: self user lectures: self user lectures).
			self refreshReport.
			])
	}! !

!DLUserGroupListComp methodsFor: 'rendering' stamp: 'MG 7/23/2009 19:49'!
additionalColumns
	^ {(DLMAConditionalCommandColumn new
			useImages: true;
			addCommand:
					[ :listElement | |answer|
					answer := self call: (DLUserConfirmLeaveComp for: listElement).
					answer ifTrue: [listElement removeStudent: self user].
					self refreshReport.
					]
			condition: 
					[ :listElement | listElement lecture groupingPhaseActive ]
			text: #leave;
			yourself)
		}! !

!DLUserGroupListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 18:12'!
listClass
	^ DLGroup! !

!DLUserGroupListComp methodsFor: 'rendering' stamp: 'caro 7/12/2009 17:31'!
listSelectBlock
	^ [:aGroup | (aGroup students) includes: (self session user)]! !

!DLUserGroupListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:34'!
reportEmptyMessage
	^ 'Noch keiner Gruppe beigetreten.'! !

!DLUserGroupListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:16'!
reportTitle
	^ 'Meine Gruppen'! !

!DLUserGroupListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 15:27'!
user

	^ user! !

!DLUserGroupListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 15:27'!
user: anObject

	user := anObject.! !

DLUserListComp subclass: #DLUserJoinGroupComp
	instanceVariableNames: 'user lectures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserJoinGroupComp class methodsFor: 'accessing' stamp: 'caro 7/14/2009 13:02'!
for: aUser
	^ self new
		user: aUser;
		yourself.! !

!DLUserJoinGroupComp class methodsFor: 'accessing' stamp: 'caro 7/24/2009 16:23'!
for: aUser lectures: aLecture
	^ self new
		user: aUser;
		lectures: aLecture;
		yourself.! !

!DLUserJoinGroupComp methodsFor: 'as yet unclassified' stamp: 'Marik 7/24/2009 12:20'!
additionalActions
	^ {
		true -> (#add -> 
			[ | answer newGroup |
			newGroup := DLGroup new.
			answer := self lightbox: ((newGroup descriptionCreate asComponentOn: newGroup) addForm; yourself).
			answer ifNotNil: [ newGroup save ].
			self refreshReport])
	}! !

!DLUserJoinGroupComp methodsFor: 'rendering' stamp: 'caro 7/24/2009 17:26'!
additionalColumns
	^ { 
		(DLMAConditionalCommandColumn new
			useImages: true;
			addCommand: 
				[:listElement | |answer|
					answer := self call: (DLUserConfirmJoinComp for: self user group: listElement).
					answer ifTrue: [listElement addStudent: self user].
					self answer: true.
				]
			condition: 
					[ :listElement | listElement lecture groupingPhaseActive | (self session user isAdmin)]
			text: #choose;
			yourself)
	 }.! !

!DLUserJoinGroupComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:36'!
initializeReport
	super initializeReport.
	self magritteReport groupField: #lecture.
! !

!DLUserJoinGroupComp methodsFor: 'accessing' stamp: 'caro 7/24/2009 11:57'!
lectures

	^ lectures! !

!DLUserJoinGroupComp methodsFor: 'accessing' stamp: 'caro 7/24/2009 11:57'!
lectures: anObject

	lectures := anObject.! !

!DLUserJoinGroupComp methodsFor: 'rendering' stamp: 'caro 6/18/2009 21:50'!
listClass
	^ DLGroup! !

!DLUserJoinGroupComp methodsFor: 'rendering' stamp: 'caro 7/24/2009 17:04'!
listObjects
	|someLectures answer|
	someLectures := self lectures.
	someLectures do: [:aLecture | (self user groupForLecture: aLecture) ifNotNil:[someLectures remove: aLecture]].
	answer :=(SqsSearch for: DLGroup) findAll select: [:aGroup | someLectures includes: aGroup lecture].
	^ answer! !

!DLUserJoinGroupComp methodsFor: 'rendering' stamp: 'sebh 6/21/2009 00:29'!
reportClass
	^ DLMAGroupedReport ! !

!DLUserJoinGroupComp methodsFor: 'rendering' stamp: 'caro 7/24/2009 16:04'!
reportEmptyMessage
	^ 'Es wurde noch keine Lehrveranstaltung belegt, fr die man sich momentan in Gruppen eintragen kann.'! !

!DLUserJoinGroupComp methodsFor: 'accessing' stamp: 'caro 6/18/2009 19:04'!
user

	^ user! !

!DLUserJoinGroupComp methodsFor: 'accessing' stamp: 'caro 6/18/2009 19:04'!
user: anObject

	user := anObject.! !

DLUserListComp subclass: #DLUserLectureListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLUserLectureListComp subclass: #DLUserChosenLectureListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserChosenLectureListComp methodsFor: 'rendering' stamp: 'caro 7/16/2009 15:41'!
listObjects
	^ ((SqsSearch for: DLLecture) select: [:aLecture  | aLecture students includes: self session user])! !

!DLUserChosenLectureListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:24'!
listSelectBlock
	^ [:aLecture | aLecture students includes: self session user]! !

!DLUserChosenLectureListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:38'!
reportEmptyMessage
	^ 'Du hast noch keine Lehrveranstaltung gewhlt!!'! !

!DLUserChosenLectureListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:19'!
reportTitle
	^ 'Meine Lehrveranstaltungen'! !

!DLUserLectureListComp methodsFor: 'rendering' stamp: 'caro 7/24/2009 16:28'!
additionalColumns
	^ {(DLMAConditionalCommandColumn new
			useImages: true;
			additionalText: true;
			addCommand: [:listElement | listElement addStudent: self session user. self call: (DLUserChosenLectureListComp with: {#students->self session user})]
			condition:  [:listElement | (listElement students includes: self session user) ~= true]
			text: #choose;
			addCommand: [:listElement | listElement removeStudent: self session user. self refreshReport.]
			condition:  [:listElement | (listElement students includes: self session user)]
			text: #leave;
			yourself).}! !

!DLUserLectureListComp methodsFor: 'rendering' stamp: 'MG 7/23/2009 19:49'!
columnDetail
	^ (DLMACommandColumn new
			useImages: true;
			addCommand: [:listElement |
					self call: (
						DLUserDetailComp for: listElement 
							additionalComps: {(DLUserListComp for: DLDeadline with: {#lecture->listElement. #group->nil}) startsHidden. 
													(DLUserListComp for: DLGroup 	with:   {#lecture->listElement}) startsHidden.
													(DLUserListComp for: DLTopic 	with:   {#lecture->listElement}) startsHidden.}
					)
			]
			text: #details;
			yourself).! !

!DLUserLectureListComp methodsFor: 'accessing' stamp: 'sebh 6/18/2009 14:54'!
detailComponent
	^ DLUserLectureDetailComp! !

!DLUserLectureListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 18:11'!
listClass
	^ DLLecture! !

!DLUserLectureListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:39'!
listSelectBlock
	^ [:aLecture  | aLecture visible = true]! !

!DLUserLectureListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:22'!
reportTitle
	^ 'Aktuelle Lehrveranstaltungen'! !

!DLUserListComp methodsFor: 'rendering' stamp: 'sebh 6/23/2009 18:01'!
actions 
	^ {}! !

!DLUserListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 19:12'!
columnDelete
	^ nil! !

!DLUserListComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 19:15'!
columnUpdate
	^ nil! !

!DLUserListComp methodsFor: 'accessing' stamp: 'sebh 7/2/2009 23:13'!
detailComponent
	^ DLUserDetailComp! !

!DLUserListComp methodsFor: 'description' stamp: 'sebh 6/23/2009 18:00'!
listDescription
	^ (self listClass) new descriptionUserList! !

!DLUserListComp methodsFor: 'rendering' stamp: 'cr 7/23/2009 19:41'!
menuItem
	^self reportTitle! !

!DLUserListComp methodsFor: 'rendering' stamp: 'sebh 7/19/2009 19:33'!
reportEmptyMessage
	^ 'Noch keine ', self listClass metaNamePlural, ' vorhanden.'! !

DLUserListComp subclass: #DLUserTopicListComp
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserTopicListComp class methodsFor: 'accessing' stamp: 'caro 7/3/2009 22:04'!
for: aUser
	^ self new
		user: aUser;
		yourself.! !

!DLUserTopicListComp methodsFor: 'as yet unclassified' stamp: 'Marik 7/24/2009 12:59'!
additionalActions
	^ {
		true -> (#add -> 
			[ | answer newTopic |
			newTopic := DLTopic new.
			answer := self lightbox: ((newTopic descriptionCreate asComponentOn: newTopic) addForm; yourself).
			answer ifNotNil: [ newTopic save ].
			self refreshReport])
	}! !

!DLUserTopicListComp methodsFor: 'rendering' stamp: 'MG 7/23/2009 19:48'!
additionalColumns
	^ {(DLMAConditionalCommandColumn new
			useImages: true;
			addCommand: [:listElement | listElement addStudent: self session user. self call: (DLUserTopicListComp with: {#students->self session user})]
			condition:  [:listElement | (listElement students includes: self session user) ~= true]
			text: #choose;
			addCommand: [:listElement | listElement removeStudent: self session user]
			condition:  [:listElement | (listElement students includes: self session user)]
			text: #edit;
			yourself).}! !

!DLUserTopicListComp methodsFor: 'rendering' stamp: 'caro 6/25/2009 17:24'!
listClass
	^ DLTopic! !

!DLUserTopicListComp methodsFor: 'rendering' stamp: 'caro 7/24/2009 16:23'!
listObjects

	| lectures topics |
	lectures := (SqsSearch for: DLLecture) findAll select: [:aLecture | (aLecture topicPhaseActive = true) & (aLecture students includes: self session user)].
	lectures := lectures select: [:aLecture |
			"Can we do this nicer?"
			| truth |
			truth := false.
			(self session user topicForLecture: aLecture) ifNil: [truth := true].
			truth
		].
	topics := (SqsSearch for: DLTopic) findAll select: [:aTopic | lectures includes: aTopic lecture].
	^ topics.! !

!DLUserTopicListComp methodsFor: 'accessing' stamp: 'caro 7/3/2009 22:04'!
user

	^ user! !

!DLUserTopicListComp methodsFor: 'accessing' stamp: 'caro 7/3/2009 22:04'!
user: anObject

	user := anObject.! !

DLComponent subclass: #DLPermissionDeniedComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLPermissionDeniedComp methodsFor: 'rendering' stamp: 'caro 7/16/2009 15:39'!
initializeReport
	super initializeReport.
	self magritteReport tableEmpty:  'Noch keiner ', self listClass metaName, ' beigetreten.'! !

!DLPermissionDeniedComp methodsFor: 'permission' stamp: 'sebh 6/3/2009 17:02'!
permissionCheck
	"Always allow anyone to see permission denied"
	^ true! !

!DLPermissionDeniedComp methodsFor: 'rendering' stamp: 'sebh 6/3/2009 17:24'!
renderContent: html
	html heading: 'Permission denied';
		  paragraph: 'You have insufficient rights to open this page.'! !

DLComponent subclass: #DLUserConfirmJoinComp
	instanceVariableNames: 'group user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserConfirmJoinComp class methodsFor: 'initialize' stamp: 'caro 7/24/2009 16:04'!
for: aUser group: aGroup
	^ self new
		user: aUser;
		group: aGroup;
		yourself.! !

!DLUserConfirmJoinComp methodsFor: 'accessing' stamp: 'caro 6/19/2009 14:32'!
group

	^ group! !

!DLUserConfirmJoinComp methodsFor: 'accessing' stamp: 'caro 6/19/2009 14:32'!
group: anObject

	group := anObject.! !

!DLUserConfirmJoinComp methodsFor: 'accessing' stamp: 'caro 6/19/2009 21:32'!
isNotInGroup
	|answer|
	answer := (SqsSearch for: DLGroup) select: [:aGroup | (aGroup students) includes: (self session user)].
	"es entsteht immer eine leere orderedCollection"
	answer ifEmpty: [^true].
	^false! !

!DLUserConfirmJoinComp methodsFor: 'permission' stamp: 'caro 7/16/2009 00:59'!
permissionCheck
	|answer groupSize|
	groupSize := self group lecture groupSize.
	groupSize 	ifNil: [answer := (self session isLoggedIn)]
					ifNotNil: [answer := ((self session isLoggedIn)
												&(self group students size < groupSize))].
	^ answer! !

!DLUserConfirmJoinComp methodsFor: 'rendering' stamp: 'martin 7/24/2009 18:06'!
renderContent: html
	(self user groupForLecture: self group lecture)
	ifNil:[
			html text: 'Die Gruppe "', (self group groupName) asString, '" wirklich whlen?'; break.
			html anchor 
				callback: [self answer: true];
				text: 'Ja'.
			html text: ' | '.
			html anchor
				callback: [self answer: false];
				text: 'Nein'.
		]
	ifNotNil: [
			html text:'Sie sind fr die Lehrveranstaltung ',self group lecture canonicalName,
				' schon in einer Gruppe eingetragen!!'.
		]

! !

!DLUserConfirmJoinComp methodsFor: 'rendering' stamp: 'caro 7/16/2009 01:02'!
renderContentOn: html
	self permissionCheck 
		ifTrue: [self renderContent: html.]
		ifFalse:[html div with: 'Mglicherweise hat diese Gruppe schon die maximale Gruppengre erreicht.']! !

!DLUserConfirmJoinComp methodsFor: 'accessing' stamp: 'caro 7/12/2009 19:17'!
user

	^ user! !

!DLUserConfirmJoinComp methodsFor: 'accessing' stamp: 'caro 7/12/2009 19:17'!
user: anObject

	user := anObject.! !

DLComponent subclass: #DLUserConfirmLeaveComp
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserConfirmLeaveComp class methodsFor: 'initialize' stamp: 'caro 6/19/2009 20:08'!
for: aGroup
	^ self new
		group: aGroup;
		yourself.! !

!DLUserConfirmLeaveComp methodsFor: 'accessing' stamp: 'caro 6/19/2009 20:07'!
group

	^ group! !

!DLUserConfirmLeaveComp methodsFor: 'accessing' stamp: 'caro 6/19/2009 20:07'!
group: anObject

	group := anObject.! !

!DLUserConfirmLeaveComp methodsFor: 'permission' stamp: 'caro 6/19/2009 20:17'!
permissionCheck
	^ true.! !

!DLUserConfirmLeaveComp methodsFor: 'rendering' stamp: 'martin 7/24/2009 17:25'!
renderContent: html
	html text: 'Mchten sie die Gruppe "', self group groupName, '" wirklich verlassen?'; break.
	html anchor 
		callback: [self answer: true];
		text: 'Ja'.
	html text: ' | '.
	html anchor
		callback: [self answer: false];
		text: 'Nein'.! !

WAComponent subclass: #DLMenuComp
	instanceVariableNames: 'entries content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLMenuComp methodsFor: 'rendering' stamp: 'cr 7/21/2009 15:02'!
addEntries
	"If an inheriting method has defined this method, we use it to automagically insert entries"
	self entries
		add: ('Andere Aktionen' -> [:aUser | true ]) -> { 
			DLMenuEntry forTitle: 'Startseite' block: [self showComponent: (DLFrontPageComp new)].
			DLLogOutEntry new}.! !

!DLMenuComp methodsFor: 'seaside' stamp: 'sebh 7/14/2009 13:37'!
children
	| catElements |
	catElements := OrderedCollection new.
	self entries do: [:category | catElements addAll: category value ].
	^ catElements asArray.! !

!DLMenuComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 19:00'!
entries

	^ entries ifNil: [self entries: OrderedCollection new. self addEntries. ^ entries]! !

!DLMenuComp methodsFor: 'accessing' stamp: 'sebh 5/26/2009 17:08'!
entries: anObject

	entries := anObject.! !

!DLMenuComp methodsFor: 'rendering' stamp: 'cr 7/23/2009 19:19'!
renderContentOn: html
	self entries
		do: [:entry | self renderEntry: entry on: html. ].
	"self session activeMenuEntry: nil."! !

!DLMenuComp methodsFor: 'rendering' stamp: 'sebh 7/14/2009 13:48'!
renderEntry: anEntry on: html
	(anEntry key value value: self session user) ifTrue:[
		anEntry value isCollection
		ifTrue: [ 
			html unorderedList class: anEntry key key; with: [
				anEntry value do: [:entry | html render: entry.].
			]
		]
	]! !

!DLMenuComp methodsFor: 'rendering' stamp: 'sebh 6/13/2009 13:42'!
showComponent: aComponent
	self session announcer announce: ((self signal) forComponent: aComponent)! !

!DLMenuComp methodsFor: 'rendering' stamp: 'sebh 6/3/2009 17:55'!
signal
	^ DLViewCompReplacement! !

DLMenuComp subclass: #DLUserMenuComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLUserMenuComp subclass: #DLAdminMenuComp
	instanceVariableNames: 'lectureListComp formComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminMenuComp methodsFor: 'rendering' stamp: 'caro 7/24/2009 16:49'!
addEntries
	self entries
		add: ('Admin' -> [:aUser | aUser isAdmin ]) -> {
			DLMenuEntry forTitle: 'Lehrveranstaltungen' block: [self showComponent: (DLAdminLectureListComp new)].
			DLMenuEntry forTitle: 'Gruppen' block: 	[self showComponent: (DLAdminGroupListComp new)].
			DLMenuEntry forTitle: 'Abgaben' block: 	[self showComponent: (DLAdminDeadLineListComp new)].
			DLMenuEntry forTitle: 'Themen' block: 		[self showComponent: (DLAdminTopicListComp new)].
			DLMenuEntry forTitle: 'Benutzer' block: 	[self showComponent: (DLAdminUserListComp new)].
			DLMenuEntry forTitle: 'Dateitypen' block: [self showComponent: (DLAdminListComp for: DLFileType)].
		}.
	super addEntries.
		! !

!DLUserMenuComp methodsFor: 'rendering' stamp: 'Marik 7/17/2009 11:09'!
addEntries
	self entries
		add: ('Benutzer'->[:aUser | true ]) -> {
			DLMenuEntry forTitle: 'Aktuelle Lehrveranstaltungen' block: [self showComponent: (DLUserLectureListComp new)].
			DLMenuEntry forTitle: 'Aktuelle Themen' block: 	[self showComponent: (DLUserTopicListComp new)].
			DLMenuEntry forTitle: 'Meine Lehrveranstaltungen' block: [self showComponent: (DLUserChosenLectureListComp new)].
			DLMenuEntry forTitle: 'Meine Gruppen' block: 	[self showComponent: (DLUserGroupListComp for: self session user)].
			DLMenuEntry forTitle: 'Meine Abgaben' block: 	[self showComponent: (DLUserDeadlineListComp for: self session user)].
			DLMenuEntry forTitle: 'Mein Profil' block: 		[self showComponent: (DLUserProfileDetailComp for: self session user)].
		}.
	super addEntries! !

WAComponent subclass: #DLMenuEntry
	instanceVariableNames: 'title active block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLMenuEntry subclass: #DLLogOutEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLLogOutEntry methodsFor: 'rendering' stamp: 'cr 7/23/2009 20:33'!
renderContentOn: html

	html listItem with:[
		html anchor
			callback: [self session logout];
			with: self session user userName, ' ausloggen'.
		]! !

!DLMenuEntry class methodsFor: 'initialize' stamp: 'sebh 7/14/2009 11:42'!
forTitle: aTitle block: aBlock
	^ self new
		block: aBlock;
		title: aTitle;
		yourself.! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
block

	^ block! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
block: anObject

	block := anObject.! !

!DLMenuEntry methodsFor: 'rendering' stamp: 'Marik 7/24/2009 11:47'!
renderContentOn: html
	| cssClass |
	cssClass:= ''.
	Transcript show: (self session activeMenuEntry).
	self session activeMenuEntry = self title
	ifTrue: [cssClass := 'active'].
	
	html listItem class: cssClass; with:[
		html anchor
			callback: [self session activeMenuEntry: self title. self block value];
			with: self title.
		]! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 7/14/2009 11:43'!
title

	^ title! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 7/14/2009 11:43'!
title: anObject

	title := anObject.! !

WAComponent subclass: #DLRootComponent
	instanceVariableNames: 'menuComp viewComp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLRootComponent class methodsFor: 'seaside' stamp: 'cr 7/23/2009 20:36'!
canBeRoot
	^true! !

!DLRootComponent methodsFor: 'seaside' stamp: 'sebh 6/3/2009 12:00'!
children
	^ Array with: self viewComp with: self menuComp! !

!DLRootComponent methodsFor: 'initialization' stamp: 'sebh 7/20/2009 18:43'!
initialize
	super initialize.
	self session announcer on: DLViewCompReplacement do: [:announcement | self viewComp: announcement component ].
	self session announcer on: DLLogoutAnnouncement  do: [:announcement | self answer: true. ]! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 7/20/2009 18:53'!
menuComp
	^ menuComp ifNil: [ 
			self session user ifNotNil: [^ menuComp := DLAdminMenuComp new.].
			^ nil.
		]! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:10'!
menuComp: anObject

	menuComp := anObject.! !

!DLRootComponent methodsFor: 'rendering' stamp: 'sebh 7/20/2009 18:46'!
renderContentOn: html

	html div class:'header';  with: [
		html anchor callback: [self viewComp: DLFrontPageComp new];
			with: [html image url: 'http://upload.devdojo.de/deli.png'].
		html div class:'menu';	  with: self menuComp.
		].
	html div class:'content'; with: self viewComp.
	html div class:'footer';  with: [html text: 'Deli. A product.']
! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 7/20/2009 18:53'!
viewComp

	^ viewComp ifNil: [ 
			"Only include this component if the user is in the session."
			self session user ifNotNil: [^ viewComp:= DLFrontPageComp new.].
			^ nil.
		]! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:10'!
viewComp: anObject

	viewComp := anObject.! !

!MAOneToManyComponent methodsFor: '*deli-actions' stamp: 'sebh 7/23/2009 22:26'!
add
	| result |
	result := self selected new.
	result := self root call: (result asComponent
		addForm;
		yourself).
	result isNil
		ifFalse: [ self value: (self value copyWith: result); refresh ]! !

!MAOneToManyComponent methodsFor: '*deli-rendering' stamp: 'sebh 7/23/2009 18:25'!
renderEditorOn: html
	self description isDefinitive
		ifFalse: [ self renderSelectListOn: html ].
	self renderViewerOn: html.
! !

MADescribedColumn subclass: #DLMAChangesColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAChangesColumn methodsFor: 'rendering' stamp: 'sebh 7/19/2009 16:46'!
renderCellContent: anObject on: html
	|  changes |
	changes := (self valueFor: anObject).
	html definitionList: [
		changes do: [:aChange | 
			html definitionTerm: aChange attributeName.
			html definitionData: [
				html text: aChange attributeValue.
				html space.
				((aChange klass) includesBehavior: DLModel) ifTrue:[
					html anchor
						callback: [self report call: (DLAdminDetailComp for: ((aChange klass) getFrom: {#oid->aChange objectId}))];
						text: '[Details]'.
				]
			]
		] 
	]! !

MADescribedColumn subclass: #DLMAFileColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAFileColumn methodsFor: 'rendering' stamp: 'Marik 7/23/2009 20:58'!
renderCellContent: anObject on: html

	| fileModel separatedPath filename delimiter path |
	anObject filePath isEmpty ifTrue: [^ nil].
	delimiter := (FileDirectory default pathNameDelimiter).
	separatedPath := anObject filePath tokensBasedOn: delimiter.
	path := separatedPath allButLast.
	filename := separatedPath last.
	fileModel := DLMAExternalFileModel new 
				location: path;
				filename: filename;
				filesize: anObject fileSize;
				yourself.
				
	html anchor
		url:  (fileModel urlOn: html);
		with: filename.! !

MADescribedColumn subclass: #DLMAKeyValueColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAKeyValueColumn methodsFor: 'rendering' stamp: 'sebh 7/1/2009 00:59'!
renderCellContent: anObject on: html
	|  kv |
	kv := (self valueFor: anObject).
	html definitionList: [
		kv do: [:aPair | 
			html definitionTerm: aPair key.
			html definitionData: aPair value.
		] 
	]! !

MADescribedColumn subclass: #DLMALinkColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMALinkColumn methodsFor: 'rendering' stamp: 'sebh 7/14/2009 23:05'!
renderCellContent: anObject on: html
	html anchor url: anObject lectureHomepage; with: '[Beschreibung]'.! !

DLMALinkColumn subclass: #DLMAMailLinkColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAMailLinkColumn methodsFor: 'rendering' stamp: 'Marik 7/20/2009 16:51'!
renderCellContent: anObject on: html

	anObject mail isNil
		ifFalse: [html anchor url: anObject mail; with: [html image url: DLFileLibrary / #emailPng]]
! !

MADescribedColumn subclass: #DLMATruncatedStringColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMATruncatedStringColumn methodsFor: 'rendering' stamp: 'sebh 7/2/2009 23:41'!
renderCellContent: anObject on: html
	html render: ((self description toString: (self valueFor: anObject)) truncateWithElipsisTo: 100).! !

!MAFormDecoration methodsFor: '*deli-rendering' stamp: 'sebh 7/19/2009 21:14'!
renderContentOn: html
	next contents memento model oid 
		ifNil: 
			[html heading: next contents memento model class metaName, ' anlegen' level:3.] 
		ifNotNil: 
			[html heading: next contents memento model class metaName, ' bearbeiten' level:3.].
	super renderContentOn: html. ! !

MACommandColumn subclass: #DLMACommandColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMACommandColumn methodsFor: 'accessing' stamp: 'MG 7/23/2009 19:11'!
additionalText
	^ self propertyAt: #additionalText ifAbsent: [ self defaultAdditionalText ]! !

!DLMACommandColumn methodsFor: 'accessing' stamp: 'MG 7/23/2009 19:00'!
additionalText: aBoolean

	self propertyAt: #additionalText put: aBoolean.
	self useLinks: false.! !

!DLMACommandColumn methodsFor: 'default' stamp: 'MG 7/23/2009 18:59'!
defaultAdditionalText
	^ false! !

!DLMACommandColumn methodsFor: 'default' stamp: 'caro 7/20/2009 14:17'!
defaultUseImages
	^ true! !

!DLMACommandColumn methodsFor: 'rendering' stamp: 'MG 7/23/2009 19:06'!
renderCellContent: anObject on: html
	self useLinks
		ifTrue: [ self renderCellLinkContent: anObject on: html ]
		ifFalse: [ 
			self useImages 
				ifTrue: [
					self additionalText
						ifTrue: [self renderCellImageAndTextContent: anObject on: html]
						ifFalse: [self renderCellImageContent: anObject on: html]]
				ifFalse: [self renderCellFormContent: anObject on: html ]]! !

!DLMACommandColumn methodsFor: 'rendering' stamp: 'martin 7/24/2009 16:23'!
renderCellImageAndTextContent: anObject on: html
	self commands
		do: [ :each |
			| actionName |
			actionName := each value asString.
			html anchor
				callback: [ each key value: anObject ];
				with: [html div class: 'iconpic'; with: [html image url: (DLFileLibrary / (actionName,'Png' asSymbol))].
					html div class: 'iconstring'; with: [html text: (self labelForSelector: actionName)].]]
		separatedBy: [ html space ]! !

!DLMACommandColumn methodsFor: 'rendering' stamp: 'martin 7/24/2009 16:23'!
renderCellImageContent: anObject on: html
	self commands
		do: [ :each |
			html anchor
				callback: [ each key value: anObject ];
				with: [html div class: 'iconpic'; with: [html image url: (DLFileLibrary / (each value,'Png' asSymbol))].] ]
		separatedBy: [ html space ]! !

!DLMACommandColumn methodsFor: 'accessing' stamp: 'caro 7/20/2009 14:17'!
useImages
	^ self propertyAt: #useImages ifAbsent: [ self defaultUseImages ]! !

!DLMACommandColumn methodsFor: 'accessing' stamp: 'MG 7/23/2009 19:00'!
useImages: aBoolean

	self propertyAt: #useImages put: aBoolean.
	self useLinks: false.! !

DLMACommandColumn subclass: #DLMAConditionalCommandColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAConditionalCommandColumn methodsFor: 'saving' stamp: 'MG 7/1/2009 15:48'!
addCommand: aCommand condition: aCondition text: aText
	self commands add: aCondition -> (aCommand -> (aText -> nil)).! !

!DLMAConditionalCommandColumn methodsFor: 'saving' stamp: 'sebh 7/1/2009 16:18'!
addCommand: aCommand condition: aCondition text: aText classed: aClass
	self commands add: aCondition -> (aCommand -> (aText -> aClass)).! !

!DLMAConditionalCommandColumn methodsFor: 'saving' stamp: 'MG 7/1/2009 15:51'!
addCondition: aCondition text: aText
	self commands add: aCondition -> (nil -> (aText -> nil)).! !

!DLMAConditionalCommandColumn methodsFor: 'rendering' stamp: 'martin 7/24/2009 16:20'!
renderCellImageAndTextContent: anObject on: html
	self commands
		do: [ :each |
			| condition block actionName |
			condition := each key. block := each value key. actionName := each value value key.
			(condition value: anObject)
				ifTrue: [
					html anchor
						callback: [ block value: anObject ];
						with: [html div class: 'iconpic'; with: [html image url: (DLFileLibrary / (actionName,'Png' asSymbol))].
							html div class: 'iconstring'; with: [html text: (self labelForSelector: actionName)].]]]
		separatedBy: [ html space ].
! !

!DLMAConditionalCommandColumn methodsFor: 'rendering' stamp: 'martin 7/24/2009 16:21'!
renderCellImageContent: anObject on: html

		self commands
		do: [ :each |
			| condition block fileName |
			condition := each key. block := each value key. fileName := each value value key.
			(condition value: anObject)
			ifTrue:[ html anchor
							callback: [ block value: anObject ];
							with: [html div class: 'iconpic'; with: [html image url: (DLFileLibrary / (fileName,'Png' asSymbol))]]
					]]
		! !

!DLMAConditionalCommandColumn methodsFor: 'rendering' stamp: 'sebh 7/2/2009 17:43'!
renderCellLinkContent: anObject on: html
	self commands
		do: [ :each |
			| condition block text cssClass |
			condition := each key. block := each value key. text := each value value key. cssClass := each value value value.
			(condition value: anObject)
			ifTrue:[
				(block isNil)
				ifTrue:  [ html text: text. ]
				ifFalse: [ 
					html div class: cssClass; with: [
								html anchor
								callback: [ block value: anObject ];
								with: text]
					].
			]]
		! !

Object subclass: #DLModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

DLModel subclass: #DLDeadline
	instanceVariableNames: 'deadlineName deadlineDescription group lecture date time requirements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLDeadline class methodsFor: 'description' stamp: 'sebh 7/19/2009 19:13'!
descriptionDeadlineDescription
	^ MAMemoDescription new
		accessor: #deadlineDescription; 
		label: 'Beschreibung'; 
		priority: 30;
		beRequired;
		yourself.! !

!DLDeadline class methodsFor: 'description' stamp: 'sebh 7/19/2009 19:13'!
descriptionDeadlineName
	^ MAStringDescription new
		accessor: #deadlineName;
	 	label: 'Titel';
		priority: 20;
		beRequired;
		yourself.
! !

!DLDeadline class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:35'!
descriptionTime
	^ MATimeDescription new
		accessor: #time; 
		label: 'Uhrzeit'; 
		priority: 50;
		default: '23:59:59';
		beRequired;
		yourself.
! !

!DLDeadline class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:33'!
metaName
	^ 'Abgabetermin'! !

!DLDeadline class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:01'!
metaNamePlural
	^ 'Abgabetermine'! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDate
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'date';
		 sqlType: #date;
		 objectClass: #Date;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'date';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDeadlineDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'deadline_description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'deadlineDescription';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDeadlineName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'deadline_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'deadlineName';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroup
	^ SqsColumn new associatedClass: #DLGroup;
		 manuallyMaintained: false;
		 columnName: 'group_id';
		 sqlType: #integer;
		 objectClass: #DLGroup;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'group';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLecture
	^ SqsColumn new associatedClass: #DLLecture;
		 manuallyMaintained: false;
		 columnName: 'lecture_id';
		 sqlType: #integer;
		 objectClass: #DLLecture;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lecture';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrRequirements
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_deadlines_requirements';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_deadline_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_deadlines';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_deadline_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'requirements_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_requirements';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'requirements_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLRequirement;
		 linkedVariable: 'requirements';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTime
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'time';
		 sqlType: #time;
		 objectClass: #Time;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'time';
		 yourself! !

!DLDeadline methodsFor: 'description' stamp: 'Marik 7/14/2009 12:10'!
additionalDescriptions
	^ {self descriptionGroup.self descriptionLecture.self descriptionRequirements.self descriptionDate}! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 6/9/2009 17:48'!
canonicalName
	^ self deadlineName! !

!DLDeadline methodsFor: 'description' stamp: 'sebh 7/19/2009 16:49'!
collectDependentObjects
	| dependentDeliveries dependentRequirement dependentParent |
	dependentParent := super collectDependentObjects.
	dependentDeliveries := (SqsSearch for: DLDelivery)    select: [:aDelivery   | aDelivery    deadline = self].
	dependentRequirement:= self requirements.
	^ dependentParent, dependentDeliveries, dependentDeliveries! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 7/1/2009 11:22'!
countDeliveriesComplete

	| completedDeliveries |
	completedDeliveries := 0.
	self deliveries do: [:aDelivery | (aDelivery isComplete) ifTrue: [completedDeliveries := completedDeliveries + 1]].
	^ completedDeliveries.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
date

	^ date! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
date: anObject

	date := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 7/14/2009 23:57'!
dateAndTime
	
	^ DateAndTime date: self date time: self time! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 20:57'!
deadlineDescription

	^ deadlineDescription! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 20:57'!
deadlineDescription: anObject

	deadlineDescription := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
deadlineName

	^ deadlineName! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
deadlineName: anObject

	deadlineName := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 7/1/2009 11:16'!
deliveries

	^(SqsSearch for: DLDelivery) select: [:aDelivery | aDelivery deadline = self].! !

!DLDeadline methodsFor: 'description' stamp: 'Marik 7/24/2009 10:40'!
descriptionCreateForLecture
 ^ super description select: [:each | #(lecture deadlineName deadlineDescription date time requirements) includes: each accessor selector]! !

!DLDeadline methodsFor: 'description' stamp: 'sebh 7/17/2009 20:32'!
descriptionDate
	^ MADateDescription new
		accessor: #date;
		label: 'Datum'; 
		priority: 40;
		default: (Date today);
		beRequired;
		yourself.
! !

!DLDeadline methodsFor: 'description' stamp: 'sebh 7/17/2009 20:32'!
descriptionGroup
	^ MASingleOptionDescription new
		accessor: #group; 
		label: 'Gruppe';
		priority: 25;
		optionsAndLabels: (DLGroup getKeyValueSelect: [:aGroup | aGroup lecture = self lecture]);
		comment: 'Gruppenspezifischen Termin festlegen durch Auswahl.'
		yourself.! !

!DLDeadline methodsFor: 'description' stamp: 'Marik 7/24/2009 11:10'!
descriptionLecture
	| description |
	description :=  MASingleOptionDescription new
		accessor: #lecture; 
		label: 'Vorlesung';
		priority: 10;
		optionsAndLabels: (DLLecture getKeyValueSelect: [:aLecture | ]);
		beRequired;
		yourself.
	self lecture ifNotNil: [description beReadonly].
	^ description
! !

!DLDeadline methodsFor: 'description' stamp: 'sebh 6/8/2009 00:22'!
descriptionList
 ^ super description select: [:each | #(deadlineDescription deadlineName date time requirements) includes: each accessor selector]! !

!DLDeadline methodsFor: 'description' stamp: 'sebh 7/17/2009 20:33'!
descriptionRequirements
	^ MAToManyRelationDescription new
		accessor: #requirements; 
		label:'Abgaben'; 
		priority:60;
		classes: (Array with: DLRequirement);
		default: Array new;
		yourself.! !

!DLDeadline methodsFor: 'description' stamp: 'sebh 7/2/2009 22:45'!
descriptionUpdate
 ^ super description select: [:each | #(lecture group deadlineName deadlineDescription date time requirements) includes: each accessor selector]! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/16/2009 00:54'!
group

	^ group! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/16/2009 00:54'!
group: anObject

	group := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/8/2009 23:14'!
initialize
	super initialize.
	self requirements: OrderedCollection new.! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 7/9/2009 13:43'!
isCritical
	
	| timeDifference panicTime |
	panicTime := Duration days: 1.
	timeDifference := self dateAndTime - (DateAndTime date: (Date today) time: (Time now)).
		((Duration new < timeDifference) & (timeDifference < panicTime))
		ifTrue: [^ true].
	^false
	! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 7/9/2009 13:35'!
isExpired

	^ self dateAndTime < (DateAndTime date: (Date today) time: (Time now)).! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 7/9/2009 13:44'!
isNotCritical

	^ ((self isExpired not) & (self isCritical not))! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 7/9/2009 13:35'!
isNotExpired

	^ self isExpired not.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 22:03'!
lecture

	^ lecture! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 22:03'!
lecture: anObject

	lecture := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/18/2009 15:56'!
requirements

	^ requirements! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 7/14/2009 23:56'!
requirements: anObject
	self genericCollectionAccessor: 'requirements' withArgument: anObject! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:32'!
time

	^ time! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:32'!
time: anObject

	time := anObject.! !

!DLDeadline methodsFor: 'saving' stamp: 'sebh 7/15/2009 16:41'!
trackChangeVariables
	^ {'deadlineName'.'deadlineDescription'.'group'.'lecture'.'requirements'. 'date'. 'time'.}! !

DLModel subclass: #DLDeliverable
	instanceVariableNames: 'delivery deliverableRequirement filePath fileSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLDeliverable class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:35'!
descriptionDeliverableRequirement
	^ MAStringDescription new
		accessor: #deliverableRequirement;
		label: 'Requirement';
		priority: 20;
		beReadonly;
		yourself.
! !

!DLDeliverable class methodsFor: 'description' stamp: 'Marik 7/23/2009 16:16'!
descriptionDelivery
	^ MAStringDescription new 
		accessor: #delivery;
		label: 'Delivery';
		priority: 10;
		beHidden;
		beRequired;
		yourself.
! !

!DLDeliverable class methodsFor: 'accessing' stamp: 'Marik 6/24/2009 15:22'!
metaName
	^ 'Abgabedatei'! !

!DLDeliverable class methodsFor: 'accessing' stamp: 'sebh 7/3/2009 00:02'!
metaNamePlural
	^ 'Abgabedateien'! !

!DLDeliverable class methodsFor: 'permission' stamp: 'sebh 7/14/2009 00:16'!
rightCreate: aUser
	^ false.! !

!DLDeliverable class methodsFor: 'permission' stamp: 'sebh 7/14/2009 00:16'!
rightDelete: aUser
	^ false.! !

!DLDeliverable class methodsFor: 'permission' stamp: 'sebh 7/14/2009 00:17'!
rightUpdate: aUser
	^ false.! !

!DLDeliverable class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDeliverableRequirement
	^ SqsColumn new associatedClass: #DLRequirement;
		 manuallyMaintained: false;
		 columnName: 'deliverable_requirement_id';
		 sqlType: #integer;
		 objectClass: #DLRequirement;
		 tableName: 'dl_deliverables';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'deliverableRequirement';
		 yourself! !

!DLDeliverable class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDelivery
	^ SqsColumn new associatedClass: #DLDelivery;
		 manuallyMaintained: false;
		 columnName: 'delivery_id';
		 sqlType: #integer;
		 objectClass: #DLDelivery;
		 tableName: 'dl_deliverables';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'delivery';
		 yourself! !

!DLDeliverable class methodsFor: 'persistence-description' stamp: ''!
sqsDescrFilePath
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'file_path';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_deliverables';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'filePath';
		 yourself! !

!DLDeliverable class methodsFor: 'persistence-description' stamp: ''!
sqsDescrFileSize
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'file_size';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'dl_deliverables';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'fileSize';
		 yourself! !

!DLDeliverable methodsFor: 'description' stamp: 'Marik 7/1/2009 10:33'!
additionalDescriptions
	^ {self descriptionFileModel}.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'Marik 7/23/2009 18:12'!
canonicalName
	^ self delivery canonicalName! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/9/2009 13:48'!
deliverableRequirement

	^ deliverableRequirement! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/9/2009 13:48'!
deliverableRequirement: anObject

	deliverableRequirement := anObject.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/18/2009 15:58'!
delivery

	^ delivery! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/18/2009 15:58'!
delivery: anObject

	delivery := anObject.! !

!DLDeliverable methodsFor: 'description' stamp: 'Marik 7/23/2009 20:32'!
descriptionFileModel
	| extensionsText extensions |
	self deliverableRequirement ifNotNilDo: [:aRequirement |
		extensions := aRequirement filetype extensions.
		extensionsText := aRequirement filetype extensionsText.
		] ifNil:	[
		extensions := {}.
		extensionsText := ''.
		].
	^ MAFileDescription new
		accessor: #fileModel;
		label: 'Datei';
		priority: 80;
		beRequired;
		componentClass: DLMADeliverableFileUploadComponent;
		kind: DLMAExternalFileModel;
		reportColumnClass: DLMAFileColumn;
	   addCondition: [:anUploadedFile | extensions includes: '.' , anUploadedFile extension]
		labelled: 'Dateityp muss einer der folgenden Endungen entsprechen: ' , extensionsText;
		addCondition: [:anUploadedFile | self delivery ifNotNilDo: [:aDelivery | aDelivery deadline isNotExpired]]
		labelled: 'Die Abgabefrist ist leider bereits ausgelaufen.';
		comment: 'Nur Dateien mit Endung(en) ', extensionsText ,' erlaubt.';
		yourself.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/17/2009 12:12'!
fileModel

	| separatedPath filename delimiter path |
	self filePath isEmpty ifTrue: [^ nil].
	delimiter := (FileDirectory default pathNameDelimiter).
	separatedPath := self filePath tokensBasedOn: delimiter.
	path := separatedPath allButLast.
	filename := separatedPath last.
	^ DLMAExternalFileModel new 
				location: path;
				filename: filename;
				filesize: self fileSize;
				yourself.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'Marik 7/14/2009 14:09'!
fileModel: aFileModel
	| delimiter |
	delimiter := (FileDirectory default pathNameDelimiter) asString.
	self filePath: (aFileModel location join: delimiter),delimiter, aFileModel filename.
	self fileSize: aFileModel filesize.
	self sendNotification: aFileModel filename.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 00:21'!
filePath

	^ filePath! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 00:24'!
filePath: anObject

	filePath := anObject.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 01:36'!
fileSize

	^ fileSize! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 01:37'!
fileSize: anObject

	fileSize := anObject.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'Marik 6/10/2009 17:22'!
initialize 

	super initialize.
	self filePath: ''.! !

!DLDeliverable methodsFor: 'deprecated' stamp: 'Marik 7/14/2009 14:23'!
sendNotification: aFilename
	| receivers mailNotification deadlineCompleted |
	(self delivery isComplete)
		ifTrue: [deadlineCompleted := 'Damit sind alle erforderlichen Dateien zu dieser Deadline eingereicht worden.']
		ifFalse: [deadlineCompleted := 'Ihnen fehlen noch einige Dateien, um diese Deadline zu vervollstndigen.'].
	receivers := OrderedCollection new.
	self delivery group students do: [:aStudent | receivers add: aStudent email].
	mailNotification := DLMail new.
	mailNotification sender: 'Deli@system.de';
		receiversAsCollection: receivers;
		subject: self delivery group groupName, ' - Eine Datei wurde hochgeladen';
		text: 'Liebes Gruppenmitglied von "',self delivery group groupName,'",

es wurde gerade die Datei ', aFilename,' hochgeladen.

Betreffende Deadline: ',self delivery deadline deadlineName,'
',deadlineCompleted,'

Mit freundlichen Gren 
Deli - dein Abgabesystem';
		sendMail.! !

!DLDeliverable methodsFor: 'saving' stamp: 'sebh 7/15/2009 16:46'!
trackChangeVariables
	^ {'filePath'.'fileSize'}! !

DLModel subclass: #DLDelivery
	instanceVariableNames: 'group deadline'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLDelivery class methodsFor: 'persistence-description' stamp: 'sebh 6/18/2009 15:52'!
getOrCreateFrom: anArray
 	| result |
	result := super getOrCreateFrom: anArray.
	result deadline requirements do: [:aRequirement |
		DLDeliverable getOrCreateFrom: {#delivery->result. #deliverableRequirement->aRequirement}.
		].
	^ result.! !

!DLDelivery class methodsFor: 'accessing' stamp: 'sebh 6/13/2009 22:31'!
metaName
	^ 'Abgabe'! !

!DLDelivery class methodsFor: 'accessing' stamp: 'sebh 7/3/2009 00:02'!
metaNamePlural
	^ 'Abgaben'! !

!DLDelivery class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:21'!
rightCreate: aUser
	^ false! !

!DLDelivery class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:22'!
rightDelete: aUser
	^ false! !

!DLDelivery class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:22'!
rightUpdate: aUser
	^ false! !

!DLDelivery class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDeadline
	^ SqsColumn new associatedClass: #DLDeadline;
		 manuallyMaintained: false;
		 columnName: 'deadline_id';
		 sqlType: #integer;
		 objectClass: #DLDeadline;
		 tableName: 'dl_deliverys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'deadline';
		 yourself! !

!DLDelivery class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroup
	^ SqsColumn new associatedClass: #DLGroup;
		 manuallyMaintained: false;
		 columnName: 'group_id';
		 sqlType: #integer;
		 objectClass: #DLGroup;
		 tableName: 'dl_deliverys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'group';
		 yourself! !

!DLDelivery methodsFor: 'description' stamp: 'Marik 7/12/2009 14:16'!
additionalDescriptions
	^ {self descriptionGroup.self descriptionDeadline}! !

!DLDelivery methodsFor: 'accessing' stamp: 'Marik 7/1/2009 15:32'!
canonicalName
	^ self deadline canonicalName, ' ', self group canonicalName! !

!DLDelivery methodsFor: 'description' stamp: 'sebh 7/19/2009 16:49'!
collectDependentObjects
	| dependentDeliverables dependentParent |
	dependentParent := super collectDependentObjects.
	dependentDeliverables := (SqsSearch for: DLDeliverable) select: [:aDeliverable | aDeliverable delivery = self].
	^ dependentParent, dependentDeliverables! !

!DLDelivery methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:52'!
deadline

	^ deadline! !

!DLDelivery methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:52'!
deadline: anObject

	deadline := anObject.! !

!DLDelivery methodsFor: 'description' stamp: 'sebh 6/18/2009 22:57'!
deliverables
	^ (SqsSearch for: DLDeliverable) select: [:aDeliverable | aDeliverable delivery = self]! !

!DLDelivery methodsFor: 'description' stamp: 'sebh 7/17/2009 20:37'!
descriptionDeadline
	^ MASingleOptionDescription new 
		accessor: #deadline;
		label: 'Deadline';
	   priority: 10;
		optionsAndLabels: (DLDeadline getKeyValueSelect: [:aDeadline | ]);
		beRequired;
		yourself.! !

!DLDelivery methodsFor: 'description' stamp: 'sebh 7/17/2009 20:38'!
descriptionGroup
	^ MASingleOptionDescription new
		accessor: #group;
		label: 'Gruppe';
		priority: 20;
		optionsAndLabels: (DLGroup getKeyValueSelect: [:aGroup | ]);
		beRequired;
		yourself.! !

!DLDelivery methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:52'!
group

	^ group! !

!DLDelivery methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:52'!
group: anObject

	group := anObject.! !

!DLDelivery methodsFor: 'accessing' stamp: 'sebh 7/14/2009 23:54'!
isComplete
	^ self deliverables allSatisfy: [:aDelivery | aDelivery filePath ~= ''].
	! !

DLModel subclass: #DLFileType
	instanceVariableNames: 'filetypeName extensions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLFileType class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:39'!
descriptionExtensions
	^ MAMemoDescription new 
		accessor: #extensionsText; 
		label: 'Dateiendungen'; 
		priority: 20;
		comment: 'Eine komma-separierte Liste der Dateiendungen z.B. ".pdf,.ppt"';
		yourself.
! !

!DLFileType class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:40'!
descriptionFiletypeName
	^ MAStringDescription new 
		accessor: #filetypeName;
		label: 'Name'; 
		priority: 10;
		beRequired;
		yourself.
! !

!DLFileType class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:02'!
metaName
	^ 'Abgabetyp'! !

!DLFileType class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:02'!
metaNamePlural
	^ 'Abgabetypen'! !

!DLFileType class methodsFor: 'persistence-description' stamp: ''!
sqsDescrExtensions
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_file_types_extensions';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_file_type_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_file_types';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_file_type_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'value';
			 instVarAt: 4 put: #string;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: nil;
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: true;
		 indexType: #integer;
		 referencedClass: #ByteString;
		 linkedVariable: 'extensions';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLFileType class methodsFor: 'persistence-description' stamp: ''!
sqsDescrFileExtensions
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_file_types_file_extensions';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_file_type_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_file_types';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_file_type_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'value';
			 instVarAt: 4 put: #string;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: nil;
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: true;
		 indexType: #integer;
		 referencedClass: #ByteString;
		 linkedVariable: 'fileExtensions';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLFileType class methodsFor: 'persistence-description' stamp: ''!
sqsDescrFiletypeName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'filetype_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_file_types';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'filetypeName';
		 yourself! !

!DLFileType class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTypeName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'type_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_file_types';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'typeName';
		 yourself! !

!DLFileType methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:43'!
canonicalName
	^ self filetypeName,' <',self extensionsText,'>'! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:44'!
extensions

	^ extensions! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:44'!
extensions: anObject

	extensions := anObject.! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:44'!
extensionsText
	^ self extensions join: ', '! !

!DLFileType methodsFor: 'accessing' stamp: 'martin 7/24/2009 14:44'!
extensionsText: aText
	"Converts the comma-separated string into an OrderedCollection and checks whether the extension starts with a dot."
	aText = nil ifFalse: [
		^ self extensions: (OrderedCollection newFrom: (((aText reject: [:char | char = $ .]) splitBy: ',') select: [:each | each first = $.]))
	].
	aText = nil ifTrue: [
		^ self extensions: OrderedCollection new
	]! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:43'!
filetypeName

	^ filetypeName! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:43'!
filetypeName: anObject

	filetypeName := anObject.! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:45'!
initialize

	super initialize.
	self extensions: OrderedCollection new.! !

DLModel subclass: #DLGroup
	instanceVariableNames: 'groupName groupDescription lecture students groupNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLGroup class methodsFor: 'persistence-description' stamp: 'sebh 7/17/2009 20:43'!
descriptionGroupDescription
	^ MAStringDescription new
		accessor: #groupDescription; 
		label: 'Beschreibung';
		priority: 20;
		beRequired;
		yourself.! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'sebh 7/17/2009 20:42'!
descriptionGroupName
	^ MAStringDescription new
		accessor: #groupName; 
		label: 'Gruppenname';
		priority: 10;
		beRequired;
		yourself.! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'sebh 7/17/2009 20:43'!
descriptionGroupNumber
	^ MAStringDescription new
		accessor: #groupNumber; 
		label: 'Gruppennummer';
		priority: 15;
		beReadonly;
		yourself.! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'MG 7/24/2009 17:36'!
descriptionMail
	^ DLMAMailDescription new
		accessor: #mail;
		label: '';
		priority: 100;
		reportColumnClass: DLMAMailLinkColumn;
		componentClass: DLMALinkComponent;
		yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:34'!
metaName
	^ 'Gruppe'! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:02'!
metaNamePlural
	^ 'Gruppen'! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_groups';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'description';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroupDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'group_description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_groups';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'groupDescription';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroupName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'group_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_groups';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'groupName';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroupNumber
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'group_number';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_groups';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'groupNumber';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLecture
	^ SqsColumn new associatedClass: #DLLecture;
		 manuallyMaintained: false;
		 columnName: 'lecture_id';
		 sqlType: #integer;
		 objectClass: #DLLecture;
		 tableName: 'dl_groups';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lecture';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrStudents
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_groups_students';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_group_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_groups';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_group_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'students_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'students_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'students';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrUsers
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_groups_users';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_group_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_groups';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_group_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'users_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'users_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'users';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLGroup methodsFor: 'saving' stamp: 'sebh 7/14/2009 23:47'!
addStudent: aUser
	self students addIfNotPresent: aUser.
	self save.! !

!DLGroup methodsFor: 'description' stamp: 'Marik 7/14/2009 15:19'!
additionalDescriptions
	^ {self descriptionStudents.self descriptionLecture}! !

!DLGroup methodsFor: 'accessing' stamp: 'Marik 7/14/2009 16:08'!
canonicalName
	^ self groupNumber, ' - ', self groupName! !

!DLGroup methodsFor: 'description' stamp: 'sebh 7/19/2009 16:52'!
collectDependentObjects
	| dependentDeadlines dependentDeliveries dependentParent |
	dependentParent := super collectDependentObjects.
	dependentDeadlines := (SqsSearch for: DLDeadline) select: [:aDeadline | aDeadline group = self].
	dependentDeliveries:= (SqsSearch for: DLDelivery) select: [:aDelivery | aDelivery group = self].
	^ dependentParent, dependentDeadlines, dependentDeliveries ! !

!DLGroup methodsFor: 'saving' stamp: 'Marik 7/15/2009 10:15'!
createGroupNumber

	(self groupNumber isNil) 
		ifTrue: [| groups number result | groups := (SqsSearch for: DLGroup) select: [:aGroup | aGroup lecture = self lecture].
					number := groups size + 1.					
					groupNumber := 'group', (number printStringLength: 3 padded: true)]! !

!DLGroup methodsFor: 'description' stamp: 'Marik 7/13/2009 15:13'!
description
 ^ super description select: [:each | #(groupName students lecture mail) includes: each accessor selector]! !

!DLGroup methodsFor: 'description' stamp: 'sebh 7/23/2009 20:39'!
descriptionCreate
 ^ super description select: [:each | #(groupName lecture groupDescription) includes: each accessor selector]! !

!DLGroup methodsFor: 'description' stamp: 'Marik 7/14/2009 15:41'!
descriptionDetail
 ^ super description select: [:each | #(groupName students lecture groupNumber) includes: each accessor selector]! !

!DLGroup methodsFor: 'description' stamp: 'sebh 7/17/2009 20:45'!
descriptionLecture
	^ MASingleOptionDescription new
		accessor: #lecture;
		label: 'Vorlesung';
		priority: 15;
		optionsAndLabels: (DLLecture getKeyValueSelect: [:aLecture |]);
		beRequired;
		yourself.! !

!DLGroup methodsFor: 'description' stamp: 'Marik 7/14/2009 15:41'!
descriptionList
 ^ super description select: [:each | #(groupName students lecture mail groupNumber) includes: each accessor selector]! !

!DLGroup methodsFor: 'description' stamp: 'sebh 7/17/2009 20:44'!
descriptionStudents
	^ MAMultipleOptionDescription new
		accessor: #students;
		label: 'Studenten';
		priority: 30;
		optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | ]);
		yourself.
! !

!DLGroup methodsFor: 'description' stamp: 'caro 7/24/2009 17:29'!
descriptionUpdate
 ^ super description select: [:each | #(groupName students lecture groupDescription) includes: each accessor selector]! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/27/2009 16:27'!
groupDescription

	^ groupDescription! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/27/2009 16:27'!
groupDescription: anObject

	groupDescription := anObject.! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:54'!
groupName

	^ groupName! !

!DLGroup methodsFor: 'accessing' stamp: 'Marik 7/14/2009 15:53'!
groupName: anObject

	groupName := anObject.! !

!DLGroup methodsFor: 'accessing' stamp: 'Marik 7/14/2009 15:10'!
groupNumber

	^ groupNumber! !

!DLGroup methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:32'!
initialize
	super initialize.
	self students: OrderedCollection new.! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/26/2009 11:19'!
lecture

	^ lecture! !

!DLGroup methodsFor: 'accessing' stamp: 'Marik 7/14/2009 15:55'!
lecture: anObject

	lecture := anObject.
	self createGroupNumber.! !

!DLGroup methodsFor: 'accessing' stamp: 'mg 7/24/2009 18:23'!
mail

	| linkCollection |
	linkCollection := OrderedCollection new.
	self students do:[:each| linkCollection add: (each email)].
	linkCollection isEmpty
		ifTrue: [^nil]
		ifFalse:[^ 'mailto:',(linkCollection join: ',').].! !

!DLGroup methodsFor: 'saving' stamp: 'sebh 7/14/2009 23:51'!
removeStudent: aUser
	self students remove: aUser ifAbsent: ["User is not present anymore, let's not bother with details"].
	self save.
	! !

!DLGroup methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:23'!
students
	^ students! !

!DLGroup methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:31'!
students: anObject

	students := anObject.! !

!DLGroup methodsFor: 'saving' stamp: 'sebh 7/15/2009 16:44'!
trackChangeVariables
	^ {'groupName'.'groupDescription'.'lecture'.'students'.'groupNumber'}! !

DLModel subclass: #DLLecture
	instanceVariableNames: 'lectureName lectureHomepage mailingList semester teacher assistants studentAssistants students visible groupSize groupingPhase topicPhase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'martin 7/15/2009 22:46'!
createLectureName: aLectureName semester: aSemester
		^ self new
		lectureName: aLectureName;
		semester: aSemester;
		save;
		yourself.! !

!DLLecture class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:26'!
descriptionGroupSize
	^ MANumberDescription new
		accessor: #groupSize; 
		label: 'Gruppengre'; 
		priority: 70;
		comment: 'Maximale Gruppengre';
		yourself.
! !

!DLLecture class methodsFor: 'description' stamp: 'MG 7/18/2009 17:50'!
descriptionLectureHomepage
	^ MAStringDescription new
		accessor: #prepareLectureHomepage; 
		label: 'Webseite'; 
		priority: 25;
		reportColumnClass: DLMALinkColumn;
		componentClass: DLMALinkComponent;
		yourself.
! !

!DLLecture class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:26'!
descriptionLectureName
	^ MAStringDescription new
		accessor: #lectureName; 
		label: 'Lehrveranstaltung'; 
		priority: 10;
		beRequired;
		yourself.
! !

!DLLecture class methodsFor: 'description' stamp: 'MG 7/24/2009 17:34'!
descriptionMailingList
	^ MAStringDescription new 
		accessor: #mailingList; 
		label: 'E-Mail Verteiler';
		priority: 27;
		reportColumnClass: DLMALinkColumn;
		componentClass: DLMAMailLinkComponent;
		yourself.
! !

!DLLecture class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:28'!
descriptionVisible
	^ MABooleanDescription new 
		accessor: #visible; 
		label: 'Sichtbar'; 
		priority: 70;
		checkboxLabel: '';
		default: true;
		trueString: 'Sichtbar';
		falseString:'Nicht sichtbar';
		yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'martin 7/15/2009 22:48'!
getOrCreateUserName: aLectureName semester: aSemester

	| lecture |
	lecture := (SqsSearch for: self) detect: [:aLecture | 
		(aLecture lectureName = aLectureName) & (aLecture semester = aSemester)]
	                                 ifNone: [nil].
	lecture ifNotNil: [ ^ lecture ].
	^ self createLectureName: aLectureName semester: aSemester.
! !

!DLLecture class methodsFor: 'accessing' stamp: 'sebh 7/3/2009 00:03'!
metaName
	^ 'Lehrveranstaltung'! !

!DLLecture class methodsFor: 'accessing' stamp: 'sebh 7/3/2009 00:03'!
metaNamePlural
	^ 'Lehrveranstaltungen'! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrAssistants
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_lectures_assistants';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_lecture_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_lectures';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_lecture_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'assistants_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'assistants_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'assistants';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroupSize
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'group_size';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'groupSize';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroupingPhase
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'grouping_phase';
		 sqlType: #date;
		 objectClass: #Date;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'groupingPhase';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLectureHomepage
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'lecture_homepage';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lectureHomepage';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLectureName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'lecture_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lectureName';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrMail
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'mail';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'mail';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrMailingList
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'mailing_list';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'mailingList';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrSemester
	^ SqsColumn new associatedClass: #DLSemester;
		 manuallyMaintained: false;
		 columnName: 'semester_id';
		 sqlType: #integer;
		 objectClass: #DLSemester;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'semester';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrStudentAssistants
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_lectures_student_assistants';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_lecture_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_lectures';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_lecture_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'student_assistants_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'student_assistants_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'studentAssistants';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrStudents
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_lectures_students';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_lecture_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_lectures';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_lecture_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'students_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'students_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'students';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTeacher
	^ SqsColumn new associatedClass: #DLUser;
		 manuallyMaintained: false;
		 columnName: 'teacher_id';
		 sqlType: #integer;
		 objectClass: #DLUser;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'teacher';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTopicPhase
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'topic_phase';
		 sqlType: #date;
		 objectClass: #Date;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'topicPhase';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrVisible
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'visible';
		 sqlType: #boolean;
		 objectClass: #True;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'visible';
		 yourself! !

!DLLecture methodsFor: 'saving' stamp: 'sebh 6/20/2009 23:04'!
addStudent: aUser
	self students addIfNotPresent: aUser.
	self save.
! !

!DLLecture methodsFor: 'description' stamp: 'MG 7/18/2009 11:53'!
additionalDescriptions
	^ {
		self descriptionAssistants.
		self descriptionSemester.
		self descriptionStudents.
		self descriptionStudentAssistants.
		self descriptionTeacher.
		self descriptionGroupingPhase.
		self descriptionTopicPhase.
		self descriptionMail.
	}! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
assistants

	^ assistants! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 7/15/2009 16:48'!
assistants: anObject
	self genericCollectionAccessor: 'assistants' withArgument: anObject! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 19:13'!
canonicalName
	^ self lectureName, ' ', self semester canonicalName! !

!DLLecture methodsFor: 'description' stamp: 'sebh 7/19/2009 16:52'!
collectDependentObjects
	| dependentDeadlines dependentGroups dependentTopics dependentParent |
	dependentParent    := super collectDependentObjects.
	dependentDeadlines := (SqsSearch for: DLDeadline) select: [:aDeadline | aDeadline lecture = self].
	dependentGroups 	 := (SqsSearch for: DLGroup)    select: [:aGroup 	 | aGroup 	 lecture = self].
	dependentTopics 	 := (SqsSearch for: DLTopic)    select: [:aTopic 	 | aTopic 	 lecture = self].
	^ dependentParent, dependentDeadlines, dependentGroups, dependentTopics.! !

!DLLecture methodsFor: 'description' stamp: 'sebh 7/17/2009 20:31'!
descriptionAssistants
	^ MAMultipleOptionDescription new
		accessor: #assistants;
		label: 'Assistent'; 
		priority: 35;
		optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | aUser isAssistant]);
		componentClass: MACheckboxGroupComponent;
		yourself.
! !

!DLLecture methodsFor: 'description' stamp: 'MG 7/17/2009 19:18'!
descriptionCreate
 ^ self description select: [:each | #(lectureName semester prepareLectureHomepage mailingList teacher assistants studentAssistants visible groupingPhase topicPhase groupSize) includes: each accessor selector]! !

!DLLecture methodsFor: 'description' stamp: 'MG 7/18/2009 17:43'!
descriptionDetail

 ^ self description select: [:each | #(lectureName semester prepareLectureHomepage mailingList teacher assistants studentAssistants visible groupingPhase topicPhase groupSize) includes: each accessor selector]! !

!DLLecture methodsFor: 'description' stamp: 'sebh 7/17/2009 20:29'!
descriptionGroupingPhase
	^ MADateDescription new 
		accessor: #groupingPhase; 
		label: 'Gruppenwahl bis';
		priority: 80;
		default: (Date today);
		beRequired;
		comment: 'Ist dieses Datum noch nicht erreicht, knnen Studenten neue Gruppen erstellen, beitreten oder verlassen.';
		yourself.
! !

!DLLecture methodsFor: 'description' stamp: 'MG 7/18/2009 17:43'!
descriptionList
 ^ self description select: [:each | #(lectureName prepareLectureHomepage mail teacher semester) includes: each accessor selector]! !

!DLLecture methodsFor: 'description' stamp: 'MG 7/24/2009 17:36'!
descriptionMail
	^ DLMAMailDescription new
		accessor: #mail;
		label: '';
		priority: 140;
		reportColumnClass: DLMAMailLinkColumn;
		componentClass: DLMALinkComponent;
		yourself! !

!DLLecture methodsFor: 'description' stamp: 'sebh 7/17/2009 20:30'!
descriptionSemester
	^ MASingleOptionDescription new
		accessor: #semester; 
		label: 'Semester'; 
		priority: 50;
		optionsAndLabels: (DLSemester getKeyValueSelect: [:aSemester | aSemester year >= Date today year]);
		beRequired;
		reference: MAStringDescription new;
		yourself.! !

!DLLecture methodsFor: 'description' stamp: 'sebh 7/17/2009 20:30'!
descriptionStudentAssistants
	^ MAMultipleOptionDescription new
		accessor: #studentAssistants;
	 	label: 'Studentische Assistenten';
		priority: 40;
		componentClass: MACheckboxGroupComponent;
		optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | aUser isStudentAssistant ]);
		yourself.
! !

!DLLecture methodsFor: 'description' stamp: 'sebh 7/17/2009 20:30'!
descriptionStudents
	^ MAMultipleOptionDescription new
		accessor: #students;
		label: 'Studenten';
		priority: 60;
		optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | ]);
		yourself.
! !

!DLLecture methodsFor: 'description' stamp: 'sebh 7/17/2009 20:30'!
descriptionTeacher
	^ MASingleOptionDescription new
		accessor: #teacher; 
		label: 'Dozent'; 
		priority: 30;
		optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | aUser isTeacher]);
		beRequired;
		yourself.
! !

!DLLecture methodsFor: 'description' stamp: 'sebh 7/17/2009 20:32'!
descriptionTopicPhase
	^ MADateDescription new
		accessor: #topicPhase; 
		label: 'Themenwahl bis'; 
		priority: 90;
		default: (Date today);
		beRequired;
		comment: 'Ist dieses Datum noch nicht erreicht, knnen Studenten Themen whlen und auch abwhlen.';
		yourself.! !

!DLLecture methodsFor: 'description' stamp: 'Marik 7/13/2009 16:23'!
descriptionUpdate
 ^ self descriptionCreate! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 5/31/2009 16:02'!
groupSize

	^ groupSize! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 5/31/2009 16:02'!
groupSize: anObject

	groupSize := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 7/8/2009 15:37'!
groupingPhase

	^groupingPhase! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/20/2009 22:26'!
groupingPhase: anObject

	groupingPhase := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'caro 7/24/2009 17:17'!
groupingPhaseActive
"returns true if groupingPhase is active"
	self groupingPhase ifNotNilDo: [:aGroupingPhase | ^ (aGroupingPhase  > (DateAndTime now))] ifNil: [^ true]! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/14/2009 17:09'!
initialize
	super initialize.
	self assistants: OrderedCollection new;
		  students: OrderedCollection new;
		  studentAssistants: OrderedCollection new.
	self visible: true.! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/9/2009 13:59'!
lectureHomepage

	^ lectureHomepage! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/9/2009 13:59'!
lectureHomepage: anObject

	lectureHomepage := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
lectureName

	^ lectureName! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
lectureName: anObject

	lectureName := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'MG 7/18/2009 11:30'!
mail

	self mailingList isNil
		ifTrue: [^ nil]
		ifFalse: [^'mailto:', self mailingList].! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/13/2009 16:13'!
mailingList

	^ mailingList! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/13/2009 16:13'!
mailingList: anObject

	mailingList := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'MG 7/17/2009 19:24'!
prepareLectureHomepage
	^ self lectureHomepage! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/18/2009 12:57'!
prepareLectureHomepage: aString

	aString ifNotNil:[
		(aString beginsWithEmpty: 'http://' caseSensitive: false)
			ifTrue: [self lectureHomepage: aString]
			ifFalse: [self lectureHomepage: 'http://',aString]]
		! !

!DLLecture methodsFor: 'saving' stamp: 'sebh 6/20/2009 23:08'!
removeStudent: aUser
	self students remove: aUser ifAbsent: ["Somehow the user was removed. Result is the same."].
	self save.
! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
semester

	^ semester! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
semester: anObject

	semester := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/9/2009 14:00'!
studentAssistants

	^ studentAssistants! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 7/15/2009 16:47'!
studentAssistants: anObject
	self genericCollectionAccessor: 'studentAssistants' withArgument: anObject! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
students

	^ students! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
students: anObject

	students := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
teacher

	^ teacher! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
teacher: anObject

	teacher := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 7/8/2009 15:47'!
topicPhase

	^ topicPhase! !

!DLLecture methodsFor: 'accessing' stamp: 'caro 6/28/2009 16:39'!
topicPhase: anObject

	topicPhase := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 7/15/2009 13:32'!
topicPhaseActive
"returns true if topicPhase is active"
	^ self topicPhase ifNotNilDo: [:aTopicPhase | ^ aTopicPhase < (DateAndTime now)] ifNil: [^ true].! !

!DLLecture methodsFor: 'saving' stamp: 'martin 7/15/2009 23:18'!
trackChangeVariables
	^ {'lectureName'.
	'lectureHomepage'.
	'mailingList'.
	'semester'.
	'teacher'.
	'assistants'.
	'studentAssistants'.
	'visible'.
	'groupSize'.
	'groupingPhase'.
	'topicPhase'}! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
visible

	^ visible! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
visible: anObject

	visible := anObject.! !

DLModel subclass: #DLLogEntry
	instanceVariableNames: 'klassName objectId objectCanonicalName activity changes user created'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 7/17/2009 20:46'!
descriptionChanges
	^ MAStringDescription new
		accessor: #changes;
		label: 'Vernderungen';
		priority: 10;
		reportColumnClass: DLMAChangesColumn;
		yourself.! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 7/17/2009 20:46'!
descriptionCreated
	^ MATimeStampDescription new 
		accessor: #created;
		label: 'Erzeugt';
		priority: 10.
	! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 7/17/2009 20:47'!
descriptionUser
	^ MAToOneRelationDescription new 
		accessor: #user; 
		label: 'Benutzer'; 
		priority: 20;
		classes: {DLUser};
		undefined: 'System';
		yourself.
	! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 7/12/2009 03:16'!
metaName
	^ 'Logbucheintrag'! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 7/12/2009 03:17'!
metaNamePlural
	^ 'Logbucheintrge'! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 6/30/2009 22:15'!
rightCreate: aUser
	^ false! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 6/30/2009 22:16'!
rightDelete: aUser
	^ false! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 6/30/2009 22:16'!
rightDetail: aUser
	^ false! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 6/30/2009 22:20'!
rightUpdate: aUser
	^ false.! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: ''!
sqsDescrActivity
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'activity';
		 sqlType: #string;
		 objectClass: #ByteSymbol;
		 tableName: 'dl_log_entrys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'activity';
		 yourself! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: ''!
sqsDescrChanges
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_log_entrys_changes';
		 ownerColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'dl_log_entry_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_log_entrys';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_log_entry_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'changes_id';
			 sqlType: #integer;
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLLogEntryChange;
		 linkedVariable: 'changes';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: ''!
sqsDescrCreated
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'created';
		 sqlType: #dateAndTime;
		 objectClass: #DateAndTime;
		 tableName: 'dl_log_entrys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'created';
		 yourself! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: ''!
sqsDescrKlass
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'klass';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_log_entrys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'klass';
		 yourself! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: ''!
sqsDescrKlassName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'klass_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_log_entrys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'klassName';
		 yourself! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: ''!
sqsDescrObjectCanonicalName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'object_canonical_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_log_entrys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'objectCanonicalName';
		 yourself! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: ''!
sqsDescrObjectId
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'object_id';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'dl_log_entrys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'objectId';
		 yourself! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: ''!
sqsDescrUser
	^ SqsColumn new associatedClass: #DLUser;
		 manuallyMaintained: false;
		 columnName: 'user_id';
		 sqlType: #integer;
		 objectClass: #DLUser;
		 tableName: 'dl_log_entrys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'user';
		 yourself! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/24/2009 15:22'!
activity

	^ activity! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/24/2009 15:22'!
activity: anObject

	activity := anObject.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/19/2009 23:20'!
canonicalName
	^ self klassName,' ',self objectId asString.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/11/2009 13:29'!
changes

	^ changes! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/11/2009 13:29'!
changes: anObject

	changes := anObject.! !

!DLLogEntry methodsFor: 'description' stamp: 'sebh 7/19/2009 16:55'!
collectDependentObjects
	| dependentLogEntryChanges dependentNotifications dependentParent |
	dependentParent    := super collectDependentObjects.
	dependentLogEntryChanges := self changes.
	dependentNotifications := (SqsSearch for: DLNotification) select: [:aNotification | aNotification logEntry = self].
	^ dependentParent, dependentLogEntryChanges, dependentNotifications.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 22:21'!
created

	^ created! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 22:21'!
created: anObject

	created := anObject.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/11/2009 13:27'!
initialize
	super initialize.
	self created: DateAndTime now.
	self changes: OrderedCollection new.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/12/2009 02:49'!
klass
	^ Smalltalk classNamed: self klassName.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/12/2009 02:48'!
klassName

	^ klassName! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/12/2009 02:48'!
klassName: anObject

	klassName := anObject.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/17/2009 22:21'!
object
	^ (SqsSearch for: (Smalltalk classNamed: self klassName)) detect: [:anObject | anObject oid = self objectId].! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/24/2009 15:51'!
objectCanonicalName

	^ objectCanonicalName! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/24/2009 15:51'!
objectCanonicalName: anObject

	objectCanonicalName := anObject.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 14:13'!
objectId

	^ objectId! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 14:13'!
objectId: anObject

	objectId := anObject.! !

!DLLogEntry methodsFor: 'permission' stamp: 'sebh 6/30/2009 22:17'!
rightUpdate: aUser
	^ false.! !

!DLLogEntry methodsFor: 'saving' stamp: 'sebh 7/1/2009 00:44'!
trackChangeVariables
	"DON'T even think about it"
	^ {}! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 22:43'!
user

	^ user! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 22:43'!
user: anObject

	user := anObject.! !

DLModel subclass: #DLLogEntryChange
	instanceVariableNames: 'attributeName activity attributeValue objectCanonicalName klassName objectId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: 'sebh 7/12/2009 03:16'!
metaName
	^ 'nderung'! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: 'sebh 7/12/2009 03:16'!
metaNamePlural
	^ 'nderungen'! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:30'!
rightCreate: aUser
	^ false! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:30'!
rightDelete: aUser
	^ false! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:30'!
rightUpdate: aUser
	^ false! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: ''!
sqsDescrActivity
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'activity';
		 sqlType: #string;
		 objectClass: #ByteSymbol;
		 tableName: 'dl_log_entry_changes';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'activity';
		 yourself! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: ''!
sqsDescrAttributeName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'attribute_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_log_entry_changes';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'attributeName';
		 yourself! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: ''!
sqsDescrAttributeValue
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'attribute_value';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_log_entry_changes';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'attributeValue';
		 yourself! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: ''!
sqsDescrKlass
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'klass';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_log_entry_changes';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'klass';
		 yourself! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: ''!
sqsDescrKlassName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'klass_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_log_entry_changes';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'klassName';
		 yourself! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: ''!
sqsDescrObjectCanonicalName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'object_canonical_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_log_entry_changes';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'objectCanonicalName';
		 yourself! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: ''!
sqsDescrObjectId
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'object_id';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'dl_log_entry_changes';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'objectId';
		 yourself! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/12/2009 01:35'!
activity

	^ activity! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/12/2009 01:35'!
activity: anObject

	activity := anObject.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 14:30'!
attributeName

	^ attributeName! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 14:30'!
attributeName: anObject

	attributeName := anObject.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 14:30'!
attributeValue

	^ attributeValue! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 14:30'!
attributeValue: anObject

	attributeValue := anObject.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/19/2009 23:20'!
canonicalName
	^ self attributeName,' ',self activity asString,' ',self attributeValue.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/19/2009 16:41'!
klass
	^ Smalltalk classNamed: self klassName.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/12/2009 02:48'!
klassName

	^ klassName! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/12/2009 02:48'!
klassName: anObject

	klassName := anObject.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/17/2009 22:25'!
object
 ^ (SqsSearch for: (Smalltalk classNamed: self klassName)) detect: [:anObject | anObject oid = self objectId].! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/24/2009 16:03'!
objectCanonicalName

	^ objectCanonicalName! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/24/2009 16:03'!
objectCanonicalName: anObject

	objectCanonicalName := anObject.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 13:29'!
objectId

	^ objectId! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 13:30'!
objectId: anObject

	objectId := anObject.! !

DLModel subclass: #DLMail
	instanceVariableNames: 'subject text sender receivers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLMail class methodsFor: 'default' stamp: 'cr 7/23/2009 17:01'!
defaultSender
	^'Deli Abgabesystem <christian.ress@student.hpi.uni-potsdam.de>'! !

!DLMail class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:50'!
descriptionReceivers
	^ MAStringDescription new accessor: #receivers;
		label: 'Empfnger';
		priority: 10;
		beRequired;
		yourself.
		
! !

!DLMail class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:51'!
descriptionSender
	^ MAStringDescription new 
		accessor: #sender;
		label: 'Absender';
		priority: 20;
		beRequired;
		yourself.! !

!DLMail class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:52'!
descriptionSubject
	^ MAStringDescription new 
		accessor: #subject;
		label: 'Betreff';
		priority: 30;
		beRequired;
		yourself.
		
! !

!DLMail class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:52'!
descriptionText
	^ MAStringDescription new 
		accessor: #text;
		label: 'Text';
		priority: 40;
		beRequired;
		yourself.
! !

!DLMail class methodsFor: 'accessing' stamp: 'sebh 7/11/2009 10:35'!
metaName
	^ 'Mail'! !

!DLMail class methodsFor: 'accessing' stamp: 'sebh 7/11/2009 10:35'!
metaNamePlural
	^ 'Mails'! !

!DLMail methodsFor: 'accessing' stamp: 'cr 7/23/2009 17:00'!
initialize
	super initialize.
	
	self sender: DLMail defaultSender.! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 15:32'!
receivers

	^ receivers join: ','.! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 15:34'!
receivers: someReceivers
	
	receivers := OrderedCollection newFrom: (someReceivers tokensBasedOn: $,).! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 15:40'!
receiversAsCollection
	
	^ receivers! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 15:36'!
receiversAsCollection: someReceivers
	
	receivers :=  someReceivers.! !

!DLMail methodsFor: 'accessing' stamp: 'cr 7/23/2009 17:19'!
sendMail

 | username password client |

	username := 'squeaky'.
	password := 'jflymcv98yM'.

	client := SMTPClient openOnHostNamed: 'darwin.yetisoft.net' port: 4400.
	client 	user: username;
			password: password;
			login;
			initiateSession.
	(self receiversAsCollection) do: [:anEmailAdress |  
	client mailFrom: self sender;
 			recipient: anEmailAdress;
 			data:	'Subject: ', self subject,' 
From: ', self sender,'
To: ', (self receivers convertToEncoding: 'UTF-8') ,'
Content-type: text/html;charset=UTF-8
', (self text convertToEncoding: 'UTF-8')].
	client quit.! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 14:18'!
sender

	^ sender! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 14:18'!
sender: anObject

	sender := anObject.! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 14:18'!
subject

	^ subject! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 14:18'!
subject: anObject

	subject := anObject.! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 14:19'!
text

	^ text! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 14:19'!
text: anObject

	text := anObject.! !

!DLModel class methodsFor: 'save' stamp: 'sebh 6/13/2009 20:55'!
createFrom: anArray
	"Create an object with the values given in anArray and use the standard getters/setters so nondefault get/set behaviour works"
	^ (self newFrom: anArray) save.
	! !

!DLModel class methodsFor: 'magritte' stamp: 'sebh 6/8/2009 00:22'!
descriptionContainer
	^ super descriptionContainer
		componentRenderer: DLCssRenderer;
		yourself! !

!DLModel class methodsFor: 'save' stamp: 'sebh 7/9/2009 14:29'!
getFrom: anAttributeArray 
	| keys values objects |
	keys := anAttributeArray collect: [ :anAttribute | anAttribute key ].
	values := anAttributeArray collect: [ :anAttribute | anAttribute value ].
	"We only contain objects that defined all their values"
	(values includes: nil) ifTrue: 
		[ DLNilValueException new
			messageText: 'A given value was nil';
			signal ].
	objects := (SqsSearch for: self) 
		searchBy: keys
		withValues: values
		limit: 2.
	objects isEmptyOrNil ifTrue: [
		DLNoResultException new
			messageText: 'No object was returned';
			signal.
		].
	objects size > 1 ifTrue: [ 
		DLMultipleResultsException new
			messageText: 'More than one element with similar default fields';
			signal.
		].
	"If there is really only one object, return it!!"
	^ objects first.! !

!DLModel class methodsFor: 'save' stamp: 'Marik 6/9/2009 17:49'!
getKeyValueSelect: aBlock
	| objects kv |
	objects := (SqsSearch for: self) select: aBlock.
	kv := OrderedCollection new.
	objects do: [:object | kv add: (object -> object canonicalName)].
	^ kv
! !

!DLModel class methodsFor: 'save' stamp: 'sebh 7/19/2009 22:52'!
getOrCreateFrom: anAttributeArray 
	"Get an object from a given attribute array, create one if it doesn't exist yet.'"
	^ self getOrCreateFrom: anAttributeArray withDefaultValues: {}.! !

!DLModel class methodsFor: 'save' stamp: 'sebh 7/19/2009 22:51'!
getOrCreateFrom: anAttributeArray withDefaultValues: aDefaultValueList
	"Get an object from a given attribute array, create one if it doesn't exist yet.'"
	| object |
	[object := self getFrom: anAttributeArray.]
 	on: DLNoResultException 
 	do: [:exc | ^ self createFrom: anAttributeArray].
	object ifNil: [^ self createFrom: (anAttributeArray, aDefaultValueList)].
	^ object.! !

!DLModel class methodsFor: 'accessing' stamp: 'sebh 7/9/2009 15:27'!
metaName
	^ ''! !

!DLModel class methodsFor: 'accessing' stamp: 'sebh 7/9/2009 15:34'!
metaNamePlural
	^ ''! !

!DLModel class methodsFor: 'save' stamp: 'sebh 6/13/2009 21:09'!
newFrom: anArray
	"Create an object with the values given in anArray and use the standard getters/setters so nondefault get/set behaviour works"
	| newobject |
	newobject := self new.
	anArray do: [:element | newobject perform: ((element key, ':') asSymbol) with: element value ].
	^ newobject! !

!DLModel class methodsFor: 'permission' stamp: 'sebh 6/13/2009 14:08'!
rightCreate: aUser
	^ aUser isAdmin! !

!DLModel class methodsFor: 'permission' stamp: 'sebh 6/13/2009 14:09'!
rightDelete: aUser
	^ aUser isAdmin! !

!DLModel class methodsFor: 'permission' stamp: 'sebh 6/13/2009 19:28'!
rightDetail: aUser
	^ aUser notNil.! !

!DLModel class methodsFor: 'permission' stamp: 'sebh 6/13/2009 14:09'!
rightUpdate: aUser
	^ aUser isAdmin! !

!DLModel class methodsFor: 'squeaksave' stamp: 'sebh 5/28/2009 10:24'!
sqsAbstractBaseClass! !

!DLModel methodsFor: 'comparing' stamp: 'sebh 6/18/2009 22:20'!
= anotherObject
	"To circumvent crazy identity issues"
	^ (self class = anotherObject class) & (self oid = anotherObject oid).! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/26/2009 23:00'!
additionalDescriptions
	^ {}.! !

!DLModel methodsFor: 'printing' stamp: 'sebh 6/30/2009 12:05'!
canonicalName
	^ nil! !

!DLModel methodsFor: 'saving' stamp: 'sebh 7/24/2009 16:17'!
changesForField: aFieldName 
	"This method is overly complex and should be broken up into several parts.
	There might be a lot of ways to improve this method, especially with deeper insight into
	SqueakSave. Since we currently lag the time to dive deeper into SQS, further refactoring
	of this method should be deferrred.
	!!ObjectId will be added to all DLLogEntryChange objects after saving."
	| field changes collectionChanges fieldDescription change |
	"Initialize"
	changes := OrderedCollection new.
	field := self perform: aFieldName asSymbol.
	fieldDescription := (SqsStorage for: self) descriptionHandler sqsDescriptionForInstVar: aFieldName.
	(field isKindOf: OrderedCollection) ifTrue: [
		(field class includesBehavior: SqsCollectionProxy) 
		ifTrue: [ "This collection has proxied behaviour, lets work with that"
			collectionChanges := field sqsGetCollectionChangesNew.
			collectionChanges addedObjects, collectionChanges deletedObjects ifNotEmpty: [ "There are actual changes"
				collectionChanges addedObjects ifNotNilDo: [:addedObjects | 
					addedObjects do: [:map | "Changes are denoted as a tuple: (oid counter). 
						thus we need to retrieve the object that is about to be saved into this collection"
						| addedObject | 
						addedObject := (Smalltalk classNamed: (fieldDescription referencedClass asString)) getFrom: {#oid -> map first}.
						changes add: {
							#attributeName->aFieldName.
							#attributeValue->addedObject asString.
							#activity->#added.
							#klassName->(fieldDescription referencedClass asString).
							#objectId->(addedObject oid).
							#objectCanonicalName->(addedObject canonicalName)
							}.
					]].
				collectionChanges deletedObjects ifNotNilDo: [:deletedObjects | 
					deletedObjects do: [:map |
						| removedObject |
						removedObject := (Smalltalk classNamed: (fieldDescription referencedClass asString)) getFrom: {#oid -> map first}.
						changes add: {
							#attributeName->aFieldName.
							#attributeValue->removedObject asString.
							#activity->#removed.
							#klassName->(fieldDescription referencedClass asString).
							#objectId->(removedObject oid).
							#objectCanonicalName->(removedObject canonicalName)}.
					]]]
		]
		ifFalse: [ "A non-proxied collection, self has not been saved yet"
			field isEmpty ifFalse: [
				field do: [:entry | 
				changes add: {
					#attributeName->aFieldName.
					#attributeValue->entry asString.
					#activity->#added.
					#klassName->entry className.
					#objectId->entry oid.
					#objectCanonicalName->entry canonicalName.
					}.
			]]
		]
	]
	ifFalse: [ "No collection, not that big deal"
		((SqsStorage for: self) dirtyAttributes includes: aFieldName)
		ifTrue: [
			change := {
				#attributeName->aFieldName.
				#attributeValue->field asString.
				#activity->#changed.
				#klassName->field className.
				} asOrderedCollection.
			(field class includesBehavior: DLModel) ifTrue: [
				change addAll: { "For Foreign keys make sure to capture the info"
				#objectId->field oid.
				#objectCanonicalName->field canonicalName.
				}.
			].
			changes add: change.
		]
	].
	^ changes.! !

!DLModel methodsFor: 'dependencyTracking' stamp: 'sebh 6/16/2009 08:53'!
collectDependencies
	"Recursively collect all objects that depend on me or are transitively connected to this object"
	| dependencies |
	dependencies := Set with: self.
	self collectDependentObjects do: [:each | dependencies addAll: each collectDependencies].
	^ dependencies! !

!DLModel methodsFor: 'dependencyTracking' stamp: 'sebh 7/24/2009 15:15'!
collectDependentObjects
	"Return an iterable list that contains all objects that depend on this object, extend!! this method!!"
	| dependentLogEntries |
	dependentLogEntries := Set new.
	"dependentLogEntries := (SqsSearch for: DLLogEntry) select: [:aLogEntry | (aLogEntry klassName = self className) & (aLogEntry objectId = self oid)]."
	
	^ dependentLogEntries. ! !

!DLModel methodsFor: 'permission' stamp: 'sebh 6/30/2009 22:42'!
currentUser
	WACurrentSession value ifNil: [^ nil] ifNotNil: [^ WACurrentSession value user].! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/29/2009 18:33'!
description
	| tempDescription |
	tempDescription := super description copy.
	self additionalDescriptions do: [:aDescription | tempDescription add: aDescription . ].
	^ tempDescription! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionAdminCreate
	^ self descriptionCreate! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionAdminDetail
	^ self descriptionDetail! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionAdminList
	^ self descriptionList! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionAdminUpdate
	^ self descriptionUpdate! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/8/2009 17:32'!
descriptionCreate
	^ self description! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 15:48'!
descriptionDetail
	^ self description! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/3/2009 19:44'!
descriptionList
	^ self description! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/4/2009 22:47'!
descriptionUpdate
	^ self description! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionUserCreate
	^ self descriptionCreate! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionUserDetail
	^ self descriptionDetail! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionUserList
	^ self descriptionList! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionUserUpdate
	^ self descriptionUpdate! !

!DLModel methodsFor: 'saving' stamp: 'sebh 7/24/2009 16:46'!
destroy
	| result logEntry block notification|
	logEntry := DLLogEntry createFrom: {
			#klassName->self className. 
			#objectId->self oid. 
			#changes->nil.
			#user->self currentUser.
			#activity->#deleted.
			#objectCanonicalName-> self canonicalName.
		}.
		
	self trackMailChangeVariables do: [:aMailChange | 
		block := aMailChange key.
		((SqsSearch for: DLUser) select: block) do: [:aUser |
			notification := DLNotification getOrCreateFrom: {#user->aUser. #logEntry->logEntry}.
			notification save.
		].
	].
	
	result := super destroy.
	^ result.! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 7/10/2009 16:16'!
genericCollectionAccessor: varName withArgument: anObject
		"Prevent the list from being replaced so squeaksave can always determine changed objects"
   | removedObjects addedObjects instVar |
	instVar := self instVarNamed: varName.
	(anObject class includesBehavior: SqsCollectionProxy) 
	ifTrue: [ "This message comes from SqueakSave, we like that!!" ^ self instVarNamed: varName put: anObject.].
	instVar ifNil: [instVar := OrderedCollection new].
	removedObjects := instVar difference: anObject.
	addedObjects   := anObject difference: instVar.
	removedObjects do: [:obj | instVar remove: obj].
	addedObjects   do: [:obj | instVar add: obj].
	"Save all objects so that they will have oids for the change recognition".
	"instVar   do: [:obj | obj save.]."
	^ self instVarNamed: varName put: instVar.! !

!DLModel methodsFor: 'saving' stamp: 'sebh 7/14/2009 14:46'!
logChangesForField: aFieldName 
	^ (self changesForField: aFieldName) collect: [:aChange | DLLogEntryChange newFrom: aChange].! !

!DLModel methodsFor: 'saving' stamp: 'sebh 7/15/2009 14:53'!
mailChangesForField: aFieldName 
	
	^ (self changesForField: aFieldName) collect: [:aChangeset | |changeDict| 
		changeDict := Dictionary newFrom: aChangeset.
		DLNotification newFrom: {
			#attributeName->changeDict at: #attributeName.
			#activity->changeDict at: #activity.
			#attributeValue->changeDict at: #attributeValue.
		}].! !

!DLModel methodsFor: 'printing' stamp: 'sebh 6/8/2009 18:02'!
printString
	^ self canonicalName ifNil: [^ super printString]! !

!DLModel methodsFor: 'permission' stamp: 'sebh 6/13/2009 14:26'!
rightUpdate: aUser
	^ self class rightUpdate: aUser.! !

!DLModel methodsFor: 'saving' stamp: 'sebh 7/24/2009 16:36'!
save
	| result logChanges logEntry changeFields block activity |
	activity := self oid ifNil: [#created] ifNotNil: [#changed].
	logChanges := OrderedCollection new.
	self trackChangeVariables do: [:aFieldName |
		logChanges addAll: (self logChangesForField: aFieldName).
	].
	
	result := super save.
	
	logChanges ifNotEmpty: [
		"Has to happen after the actual save, because self oid is assigned afterwards and the save might fail for some reason"
		logEntry := DLLogEntry createFrom: {
			#klassName->self className. 
			#objectId->self oid. 
			#changes->logChanges.
			#user->self currentUser.
			#activity->activity.
			#objectCanonicalName-> self canonicalName.
		}.
		
		self trackMailChangeVariables do: [:aMailChange | 
		block := aMailChange key. changeFields := aMailChange value.
		((SqsSearch for: DLUser) select: block) do: [:aUser |
			| notification |
			notification := DLNotification getOrCreateFrom: {#user->aUser. #logEntry->logEntry}.
			notification fields: ((notification fields) asSet addAll: changeFields) asOrderedCollection.
			notification save.
	]]].	
	^ result.
! !

!DLModel methodsFor: 'saving' stamp: 'Marik 7/1/2009 10:03'!
trackChangeVariables
	^ {}.! !

!DLModel methodsFor: 'saving' stamp: 'sebh 7/14/2009 14:34'!
trackMailChangeVariables
	^ {}.! !

DLModel subclass: #DLNotification
	instanceVariableNames: 'user logEntry fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLNotification class methodsFor: 'persistence-description' stamp: 'sebh 7/18/2009 12:07'!
metaName
	^ 'Benachrichtigung'! !

!DLNotification class methodsFor: 'persistence-description' stamp: 'sebh 7/18/2009 12:07'!
metaNamePlural
	^ 'Benachrichtigungen'! !

!DLNotification class methodsFor: 'persistence-description' stamp: 'cr 7/23/2009 17:26'!
releaseMails
	| allNotifications usersNotifications |
	allNotifications := (SqsSearch for: DLNotification) findAll.
	usersNotifications := allNotifications 
		groupBy: [:aNotification | aNotification user] 
		having:  [:aNotification | true].
	usersNotifications keysAndValuesDo: [:user :notifications |
		| mailContent |
		mailContent := self renderMailForUser: user notifications: notifications.
		(DLMail newFrom: {
			#receivers -> user email.
			#text -> mailContent.
			#subject -> 'Neuigkeiten im Abgabesystem'
		}) sendMail.
	].
	allNotifications do: [:aNotification |
		aNotification destroy.
		]! !

!DLNotification class methodsFor: 'persistence-description' stamp: 'sebh 7/24/2009 15:30'!
renderAliveObject: html with: notification 
	html tableData: 
		[ html text: notification logEntry object class metaName , ' ' , notification logEntry object canonicalName ].
	html tableData: 
		[ notification logEntry changes 
			select: [ :aChange | notification fields includes: aChange attributeName ]
			thenDo: 
				[ :aChange | 
				html definitionList: 
					[ | description |
					description := notification logEntry object description 
						detect: [ :a | a accessor readSelector asString = aChange attributeName ]
						ifNone: [ aChange attributeName ].
					html definitionTerm: [ html text: description label , ' ' , aChange activity ].
					html definitionData: [ html text: aChange attributeValue ] ] ] ].
	html tableData: notification logEntry created.
	^ html tableData: notification logEntry user! !

!DLNotification class methodsFor: 'persistence-description' stamp: 'sebh 7/24/2009 16:32'!
renderDeadObject: html with: notification 
	notification logEntry activity = #deleted
		ifTrue: [
			html tableData: notification logEntry objectCanonicalName;
				  tableData: 'Gelscht';
			 	  tableData: notification logEntry created;
			     tableData: notification logEntry user
			]! !

!DLNotification class methodsFor: 'persistence-description' stamp: 'sebh 7/24/2009 16:33'!
renderDeletion: html with: notification 
	html tableData: notification logEntry objectCanonicalName;
	     tableData: 'Gelscht';
	     tableData: notification logEntry created;
	     tableData: notification logEntry user.! !

!DLNotification class methodsFor: 'persistence-description' stamp: 'sebh 7/24/2009 16:33'!
renderMailForUser: user notifications: notifications 
	| result |
	result := WARenderCanvas builder
		callbackOwner: self;
		render: [ :html | 
			html paragraph: 'Hallo ' , user canonicalName , ',';
			     paragraph: 'Folgende dich betreffende nderungen wurden im Abgabensystem vorgenommen:';
			     table: [ 
						self 
							renderTableHead: html;
							renderTableBody: html with: notifications 
					];
					paragraph: 'Bis zum nchsten Mal,';
					paragraph: 'Deli'.
			].
	^ result! !

!DLNotification class methodsFor: 'persistence-description' stamp: 'sebh 7/24/2009 15:34'!
renderTableBody: html with: notifications 
	^ html tableBody: 
		[ notifications do: 
			[ :notification | 
			html tableRow: 
				[ notification logEntry object 
					ifNotNil: 
						[self 
							renderAliveObject: html
							with: notification] 
				  ifNil: [
						self 
							renderDeadObject: html
							with: notification.
							]
				] ] ]! !

!DLNotification class methodsFor: 'persistence-description' stamp: 'sebh 7/24/2009 15:26'!
renderTableHead: html 
	html tableHead: 
		[ html
			tableData: [ html text: 'Objekt' ];
			tableData: [ html text: 'Vernderungen' ];
			tableData: [ html text: 'Wann' ];
			tableData: [ html text: 'Ausfhrender Benutzer' ] ]! !

!DLNotification class methodsFor: 'persistence-description' stamp: ''!
sqsDescrFields
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_notifications_fields';
		 ownerColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'dl_notification_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_notifications';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_notification_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'value';
			 sqlType: #string;
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: true;
		 indexType: #integer;
		 referencedClass: #ByteString;
		 linkedVariable: 'fields';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLNotification class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLogEntry
	^ SqsColumn new associatedClass: #DLLogEntry;
		 manuallyMaintained: false;
		 columnName: 'log_entry_id';
		 sqlType: #integer;
		 objectClass: #DLLogEntry;
		 tableName: 'dl_notifications';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'logEntry';
		 yourself! !

!DLNotification class methodsFor: 'persistence-description' stamp: ''!
sqsDescrUser
	^ SqsColumn new associatedClass: #DLUser;
		 manuallyMaintained: false;
		 columnName: 'user_id';
		 sqlType: #integer;
		 objectClass: #DLUser;
		 tableName: 'dl_notifications';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'user';
		 yourself! !

!DLNotification methodsFor: 'accessing' stamp: 'sebh 7/15/2009 15:16'!
fields

	^ fields! !

!DLNotification methodsFor: 'accessing' stamp: 'sebh 7/15/2009 15:16'!
fields: anObject

	fields := anObject.! !

!DLNotification methodsFor: 'accessing' stamp: 'sebh 7/15/2009 15:57'!
initialize
	super initialize.
	self fields: OrderedCollection new.! !

!DLNotification methodsFor: 'accessing' stamp: 'sebh 7/15/2009 15:17'!
logEntry

	^ logEntry! !

!DLNotification methodsFor: 'accessing' stamp: 'sebh 7/15/2009 15:16'!
logEntry: anObject

	logEntry := anObject.! !

!DLNotification methodsFor: 'accessing' stamp: 'sebh 7/15/2009 15:52'!
user

	^ user! !

!DLNotification methodsFor: 'accessing' stamp: 'sebh 7/15/2009 15:52'!
user: anObject

	user := anObject.! !

DLModel subclass: #DLRequirement
	instanceVariableNames: 'requirementName requirementDescription filetype'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLRequirement class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:54'!
descriptionRequirementDescription
	^ MAMemoDescription new 
		accessor: #requirementDescription;
		label:'Beschreibung';
		priority:20;
		beRequired;
		yourself.! !

!DLRequirement class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:54'!
descriptionRequirementName
	^ MAStringDescription new
		accessor: #requirementName; 
		label:'Title';
		priority:10;
		beRequired;
		yourself.! !

!DLRequirement class methodsFor: 'accessing' stamp: 'sebh 7/3/2009 00:03'!
metaName
	^ 'Anforderung'! !

!DLRequirement class methodsFor: 'accessing' stamp: 'sebh 7/3/2009 00:04'!
metaNamePlural
	^ 'Anforderungen'! !

!DLRequirement class methodsFor: 'persistence-description' stamp: ''!
sqsDescrFiletype
	^ SqsColumn new associatedClass: #DLFileType;
		 manuallyMaintained: false;
		 columnName: 'filetype_id';
		 sqlType: #integer;
		 objectClass: #DLFileType;
		 tableName: 'dl_requirements';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'filetype';
		 yourself! !

!DLRequirement class methodsFor: 'persistence-description' stamp: ''!
sqsDescrRequirementDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'requirement_description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_requirements';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'requirementDescription';
		 yourself! !

!DLRequirement class methodsFor: 'persistence-description' stamp: ''!
sqsDescrRequirementName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'requirement_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_requirements';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'requirementName';
		 yourself! !

!DLRequirement methodsFor: 'description' stamp: 'Marik 7/12/2009 14:22'!
additionalDescriptions
	^ {self descriptionFiletype}! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 01:00'!
canonicalName
	^ self requirementName! !

!DLRequirement methodsFor: 'description' stamp: 'sebh 7/17/2009 20:53'!
descriptionFiletype
	^ MASingleOptionDescription new 
		accessor: #filetype; 
		label:'Dateityp';
		priority:30;
		optionsAndLabels: (DLFileType getKeyValueSelect: [:aFile | ]);
		componentClass: (DLMASelectListComponent newElementClass: DLFileType);
		beRequired;
		yourself.! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
filetype

	^ filetype! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
filetype: anObject

	filetype := anObject.! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
requirementDescription

	^ requirementDescription! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
requirementDescription: anObject

	requirementDescription := anObject.! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
requirementName

	^ requirementName! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
requirementName: anObject

	requirementName := anObject.! !

!DLRequirement methodsFor: 'saving' stamp: 'sebh 7/15/2009 16:43'!
trackChangeVariables
	^ {'filetype'.'requirementName'.'requirementDescription'}! !

DLModel subclass: #DLSemester
	instanceVariableNames: 'semesterName year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLSemester class methodsFor: 'persistence-description' stamp: 'cr 7/20/2009 17:27'!
getForDate: aDate

	| summerStart winterStart lastWinterEnd |
	summerStart := Date year: aDate year month: 'April' day: 1.
	winterStart := Date year: aDate year month: 'October' day: 1.
	lastWinterEnd := Date year: aDate year month: 'March' day: 31.

	(aDate < lastWinterEnd) ifTrue: [
		^DLSemester getOrCreateFrom: { #year -> (aDate year - 1). #semesterName -> 'Winter' }.
		].

	(aDate > summerStart & aDate < winterStart) ifTrue: [
		^DLSemester getOrCreateFrom: { #year -> aDate year. #semesterName -> 'Sommer' }.
		].

	(aDate > winterStart) ifTrue: [
		^DLSemester getOrCreateFrom: { #year -> aDate year. #semesterName -> 'Winter' }.
		].! !

!DLSemester class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:35'!
metaName
	^ 'Semester'! !

!DLSemester class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:04'!
metaNamePlural
	^ 'Semester'! !

!DLSemester class methodsFor: 'persistence-description' stamp: ''!
sqsDescrSemesterName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'semester_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_semesters';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'semesterName';
		 yourself! !

!DLSemester class methodsFor: 'persistence-description' stamp: ''!
sqsDescrYear
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'year';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'dl_semesters';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'year';
		 yourself! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 6/19/2009 00:10'!
canonicalName
	^ self year asString, ' ', self semesterName.! !

!DLSemester methodsFor: 'description' stamp: 'sebh 6/16/2009 00:14'!
collectDependentObjects
	| dependentLectures |
	dependentLectures := (SqsSearch for: DLLecture) select: [:aLecture | aLecture semester = self].
	^ dependentLectures! !

!DLSemester methodsFor: 'accessing' stamp: 'cr 7/20/2009 17:27'!
nextSemester

	(semesterName = 'Sommer') ifTrue: [
		^DLSemester getOrCreateFrom: { #year -> self year. #semesterName -> 'Winter'}.
		]
	ifFalse: [
		^DLSemester getOrCreateFrom: { #year -> (self year + 1). #semesterName -> 'Sommer'}.
		].! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
semesterName

	^ semesterName! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
semesterName: anObject

	semesterName := anObject.! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
year

	^ year! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
year: anObject

	year := anObject.! !

DLModel subclass: #DLTestItemModel
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLTestItemModel class methodsFor: 'persistence-description' stamp: 'sebh 7/11/2009 10:37'!
metaName
	^ 'testItem'! !

!DLTestItemModel class methodsFor: 'persistence-description' stamp: 'sebh 7/11/2009 10:37'!
metaNamePlural
	^ 'testItems'! !

!DLTestItemModel class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTitle
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'title';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_test_item_models';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'title';
		 yourself! !

!DLTestItemModel methodsFor: 'accessing' stamp: 'sebh 7/9/2009 11:30'!
canonicalName
	^ self title.! !

!DLTestItemModel methodsFor: 'accessing' stamp: 'sebh 7/7/2009 22:53'!
title

	^ title! !

!DLTestItemModel methodsFor: 'accessing' stamp: 'sebh 7/7/2009 22:53'!
title: anObject

	title := anObject.! !

DLModel subclass: #DLTestModel
	instanceVariableNames: 'title body items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLTestModel class methodsFor: 'persistence-description' stamp: 'sebh 7/11/2009 10:36'!
metaName
	^ 'Testmodel'! !

!DLTestModel class methodsFor: 'persistence-description' stamp: 'sebh 7/11/2009 10:36'!
metaNamePlural
	^ 'Testmodels'! !

!DLTestModel class methodsFor: 'persistence-description' stamp: ''!
sqsDescrBody
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'body';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_test_models';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'body';
		 yourself! !

!DLTestModel class methodsFor: 'persistence-description' stamp: ''!
sqsDescrItems
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_test_models_items';
		 ownerColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'dl_test_model_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_test_models';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_test_model_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'items_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_test_item_models';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'items_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLTestItemModel;
		 linkedVariable: 'items';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLTestModel class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTitle
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'title';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_test_models';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'title';
		 yourself! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 19:11'!
body

	^ body! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 19:11'!
body: anObject

	body := anObject.! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 7/9/2009 11:30'!
canonicalName
	^ self title! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 18:37'!
initialize
	super initialize.
	self items: OrderedCollection new.! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 18:36'!
items

	^ items! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 7/10/2009 16:13'!
items: anObject
	^ self genericCollectionAccessor: 'items' withArgument: anObject.! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 18:36'!
title

	^ title! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 18:36'!
title: anObject

	title := anObject.! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 7/7/2009 23:01'!
trackChangeVariables
	^ {'title'. 'items'}.! !

DLModel subclass: #DLTopic
	instanceVariableNames: 'topicName topicDescription lecture students'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLTopic class methodsFor: 'persistence-description' stamp: 'mg 7/24/2009 18:20'!
descriptionMail
	^ DLMAMailDescription new
		accessor: #mail;
		label: '';
		priority: 140;
		reportColumnClass: DLMAMailLinkColumn;
		componentClass: DLMAMailLinkComponent;
		yourself! !

!DLTopic class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:56'!
descriptionTopicDescription
	^ MAMemoDescription new
		accessor: #topicDescription; 
		label: 'Beschreibung';
		priority: 20;
		yourself.
! !

!DLTopic class methodsFor: 'description' stamp: 'sebh 7/17/2009 20:57'!
descriptionTopicName
	^ MAStringDescription new
		accessor: #topicName;
		label: 'Thema';
		priority: 10;
		beRequired;
		yourself.
! !

!DLTopic class methodsFor: 'accessing' stamp: 'caro 6/25/2009 17:02'!
metaName
	^ 'Thema'! !

!DLTopic class methodsFor: 'accessing' stamp: 'sebh 7/3/2009 00:04'!
metaNamePlural
	^ 'Themen'! !

!DLTopic class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLecture
	^ SqsColumn new associatedClass: #DLLecture;
		 manuallyMaintained: false;
		 columnName: 'lecture_id';
		 sqlType: #integer;
		 objectClass: #DLLecture;
		 tableName: 'dl_topics';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lecture';
		 yourself! !

!DLTopic class methodsFor: 'persistence-description' stamp: ''!
sqsDescrMail
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'mail';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_topics';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'mail';
		 yourself! !

!DLTopic class methodsFor: 'persistence-description' stamp: ''!
sqsDescrStudents
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_topics_students';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_topic_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_topics';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_topic_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'students_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'students_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'students';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLTopic class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTopicDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'topic_description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_topics';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'topicDescription';
		 yourself! !

!DLTopic class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTopicName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'topic_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_topics';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'topicName';
		 yourself! !

!DLTopic class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTopicPhase
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'topic_phase';
		 sqlType: #boolean;
		 objectClass: #True;
		 tableName: 'dl_topics';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'topicPhase';
		 yourself! !

!DLTopic methodsFor: 'saving' stamp: 'caro 6/25/2009 16:51'!
addStudent: aUser
	self students addIfNotPresent: aUser.
	self save.! !

!DLTopic methodsFor: 'description' stamp: 'Marik 7/12/2009 14:24'!
additionalDescriptions
	^ {self descriptionStudents.self descriptionLecture}! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/26/2009 01:20'!
canonicalName
	^ self topicName! !

!DLTopic methodsFor: 'description' stamp: 'MG 7/13/2009 17:13'!
descriptionCreate
 ^ self description select: [:each | #(topicName topicDescription students lecture) includes: each accessor selector]! !

!DLTopic methodsFor: 'description' stamp: 'MG 7/13/2009 17:14'!
descriptionDetail
 ^ self descriptionCreate! !

!DLTopic methodsFor: 'description' stamp: 'sebh 7/17/2009 20:57'!
descriptionLecture
	^ MASingleOptionDescription new
		accessor: #lecture;
		label: 'Vorlesung';
		priority: 10;
		optionsAndLabels: (DLLecture getKeyValueSelect: [:aLecture |]);
		beRequired;
		yourself.! !

!DLTopic methodsFor: 'description' stamp: 'MG 7/13/2009 16:59'!
descriptionList
 ^ self description select: [:each | #(topicName topicDescription students lecture mail) includes: each accessor selector]! !

!DLTopic methodsFor: 'description' stamp: 'sebh 7/17/2009 20:58'!
descriptionStudents
	^ MAMultipleOptionDescription new
		accessor: #students;
		label: 'Studenten';
		priority: 30;
		optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | ]);
		yourself.
! !

!DLTopic methodsFor: 'description' stamp: 'MG 7/13/2009 17:13'!
descriptionUpdate
 ^ self descriptionCreate! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/28/2009 16:40'!
initialize
	super initialize.
	self students: OrderedCollection new.! !

!DLTopic methodsFor: 'accessing' stamp: 'sebh 7/14/2009 22:39'!
lecture 

	^ lecture! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
lecture: anObject

	lecture := anObject.! !

!DLTopic methodsFor: 'accessing' stamp: 'mg 7/24/2009 18:22'!
mail

	self students isEmpty
		ifTrue: [^nil]
		ifFalse: [^ 'mailto:',((self students collect:[:each|each email]) join: ',')].! !

!DLTopic methodsFor: 'saving' stamp: 'caro 6/25/2009 16:59'!
removeStudent: aUser
	self students remove: aUser ifAbsent: ["Somehow the user was removed. Result is the same."].
	self save.
! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
students

	^ students! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
students: anObject

	students := anObject.! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
topicDescription

	^ topicDescription! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
topicDescription: anObject

	topicDescription := anObject.! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
topicName

	^ topicName! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
topicName: anObject

	topicName := anObject.! !

DLModel subclass: #DLUser
	instanceVariableNames: 'userName realName email isAdmin isTeacher isAssistant isStudentAssistant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLUser class methodsFor: 'persistence-description' stamp: 'mg 7/24/2009 18:20'!
descriptionEmail
	^ MAStringDescription new
		accessor: #email;
		label: '';
		priority: 100;
		addCondition: 
				[ :anEmail | 
				anEmail matchesRegexIgnoringCase: '[A-Za-z0-9._-]+@([A-Za-z0-9._-]+\.)?hpi.uni-potsdam.de' ]
			labelled: 'Muss eine gltige HPI-E-Mail-Adresse sein.';
		comment: 'Eine gltige HPI-E-Mail-Adresse.';
		reportColumnClass: DLMAMailLinkColumn;
		componentClass: DLMAMailLinkComponent;
		beRequired;
		yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: 'martin 7/18/2009 14:05'!
descriptionIsAdmin
	^ MABooleanDescription new
		accessor: #isAdmin;
		label: 'Administrator';
		priority: 30;
		checkboxLabel: '';
		default: false;
		trueString: 'Ja';
		falseString: 'Nein';
		yourself.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'martin 7/18/2009 14:06'!
descriptionIsAssistant
	^ MABooleanDescription new
		accessor: #isAssistant;
		label: 'Assistent';
		priority: 40;
		checkboxLabel: '';
		default: false;
		trueString: 'Ja';
		falseString: 'Nein';
		yourself.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'martin 7/18/2009 14:06'!
descriptionIsStudentAssistant
	^ MABooleanDescription new
		accessor: #isStudentAssistant;
		label: 'Studentischer Assistent';
		priority: 40;
		checkboxLabel: '';
		default: false;
		trueString: 'Ja';
		falseString: 'Nein';
		yourself.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'martin 7/18/2009 14:06'!
descriptionIsTeacher
	^ MABooleanDescription new
		accessor: #isTeacher;
		label: 'Dozent';
		priority: 40;
		checkboxLabel: '';
		default: false;
		trueString: 'Ja';
		falseString: 'Nein';
		yourself.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 7/17/2009 21:04'!
descriptionRealName
	^ MAStringDescription new
		accessor: #realName;
		label: 'Name';
		priority: 20;
		beRequired;
		yourself.
		
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 7/17/2009 21:04'!
descriptionUserName
	^ MAStringDescription new
		accessor: #userName;
		label: 'Benutzername';
		priority: 10;
		beRequired;
		yourself.
		
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:35'!
metaName
	^ 'Benutzer'! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:04'!
metaNamePlural
	^ 'Benutzer'! !

!DLUser class methodsFor: 'persistence-description' stamp: 'Marik 5/27/2009 10:23'!
sqsDescrEmail
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'email';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'email';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrIsAdmin
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'is_admin';
		 sqlType: #boolean;
		 objectClass: #False;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'isAdmin';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrIsAssistant
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'is_assistant';
		 sqlType: #boolean;
		 objectClass: #True;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'isAssistant';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrIsStudentAssistant
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'is_student_assistant';
		 sqlType: #boolean;
		 objectClass: #False;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'isStudentAssistant';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrIsTeacher
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'is_teacher';
		 sqlType: #boolean;
		 objectClass: #True;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'isTeacher';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLecture
	^ SqsColumn new associatedClass: #DLLecture;
		 manuallyMaintained: false;
		 columnName: 'lecture_id';
		 sqlType: #integer;
		 objectClass: #DLLecture;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lecture';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrRealName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'real_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'realName';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: 'Marik 5/27/2009 10:24'!
sqsDescrUserName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'user_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'userName';
		 yourself! !

!DLUser methodsFor: 'description' stamp: 'sebh 7/15/2009 16:56'!
additionalDescriptions
	^ {}! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/8/2009 18:06'!
canonicalName
	^ self realName ifNil: [^ self userName]! !

!DLUser methodsFor: 'description' stamp: 'sebh 7/2/2009 23:07'!
descriptionCreate
 ^ self description select: [:each | #(userName realName email isAdmin isAssistant isStudentAssistant isTeacher) includes: each accessor selector]! !

!DLUser methodsFor: 'description' stamp: 'martin 7/18/2009 13:53'!
descriptionList
 ^ self description select: [:each | #(userName realName email isAdmin isTeacher isAssistant isStudentAssistant) includes: each accessor selector]! !

!DLUser methodsFor: 'description' stamp: 'sebh 6/13/2009 19:43'!
descriptionUserUpdate
 ^ self description select: [:each | #(userName realName email) includes: each accessor selector]! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 7/24/2009 16:54'!
destroy
	| userId |
	userId := self oid.
	self destroy.
	((SqsSearch for: DLNotification) searchBy: #(user)
		withValues: #(userId)
		limit: nil) do: [:aNotification | aNotification destroy].! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/27/2009 10:17'!
email

	^ email! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/27/2009 10:17'!
email: anObject

	email := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/17/2009 13:38'!
groupForLecture: aLecture
	^ (SqsSearch for: DLGroup) detect: [:aGroup | (aGroup students includes: self) & (aGroup lecture = aLecture)] ifNone: [nil].! !

!DLUser methodsFor: 'accessing' stamp: 'martin 7/18/2009 13:57'!
initialize
	super initialize.
	self isAdmin: false.
	self isAssistant: false.
	self isStudentAssistant: false.
	self isTeacher: false.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/3/2009 17:34'!
isAdmin
	^ isAdmin! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 5/27/2009 23:08'!
isAdmin: anObject

	isAdmin := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:36'!
isAssistant

	^ isAssistant! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:36'!
isAssistant: anObject

	isAssistant := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/9/2009 13:58'!
isStudentAssistant

	^ isStudentAssistant! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/9/2009 13:58'!
isStudentAssistant: anObject

	isStudentAssistant := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:35'!
isTeacher

	^ isTeacher! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:35'!
isTeacher: anObject

	isTeacher := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'caro 7/16/2009 15:11'!
lectures
	^((SqsSearch for: DLLecture) select: [:aLecture | aLecture students includes: self])! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 7/14/2009 14:35'!
lectures: aCollection
	| lecturesBefore lecturesRemove lecturesAdd |
	lecturesBefore := self lectures.
	lecturesRemove := lecturesBefore difference: aCollection.
	lecturesAdd    := aCollection difference: lecturesBefore.
	lecturesRemove do: [:aLecture | aLecture students remove: self. aLecture save.].
	lecturesAdd    do: [:aLecture | aLecture students add: self.    aLecture save.].! !

!DLUser methodsFor: 'accessing' stamp: 'mg 7/24/2009 18:18'!
mail

	self email isNil
		ifTrue: [^nil]
		ifFalse: [^ 'mailto:',self email].! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:37'!
realName

	^ realName! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:37'!
realName: anObject

	realName := anObject.! !

!DLUser methodsFor: 'permission' stamp: 'sebh 6/13/2009 14:30'!
rightUpdate: aUser
	^ (aUser = self) | (super rightUpdate: aUser)! !

!DLUser methodsFor: 'accessing' stamp: 'cr 7/8/2009 16:40'!
topicForLecture
 ^'foo'! !

!DLUser methodsFor: 'accessing' stamp: 'cr 7/8/2009 16:43'!
topicForLecture: aLoo
 ^nil! !

!DLUser methodsFor: 'saving' stamp: 'sebh 7/15/2009 15:49'!
trackChangeVariables
	^ {'isAdmin'.'isStudentAssistant'.'isTeacher'.'isAssistant'.'realName'.'email'}! !

!DLUser methodsFor: 'saving' stamp: 'sebh 7/15/2009 15:47'!
trackMailChangeVariables
	^ {[:aUser | aUser isAdmin] -> {'isAdmin'}.
		[:aUser | aUser = self ] -> {'isAdmin'. 'isAssistant'. 'isStudentAssistant'. 'isTeacher'. 'realName'. 'email'}}! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/26/2009 13:25'!
userName

	^ userName! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/26/2009 13:25'!
userName: anObject

	userName := anObject.! !

!Object methodsFor: '*deli-translation' stamp: 'sebh 7/19/2009 18:15'!
labelForSelector: aSymbol
	DLApplication translations at: aSymbol ifPresent: [:translation | ^ translation].
	^ aSymbol asCapitalizedPhrase! !

Object subclass: #Tutorials
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tutorial'!

!Tutorials methodsFor: 'tutorial' stamp: 'cr 7/23/2009 18:00'!
DatabaseFixture
	| semester lecture lecture2 deadline deadlineCoding user userJack userJohn userBehrens userGoetz group groupJack session userChr userAss1 userAss2 studentSet filetype filetypeCoding requirement requirementCoding requirementCoding2 userMichaelHaupt |
	
	session := SqsConnectionManager getInstance sessionForClass: DLUser.
	session resetDatabase.
	
	{2009. 2010. 2011} do: [:each | 
		DLSemester new
			semesterName: 'Sommer';
			year: each;
			save.
		DLSemester new
			semesterName: 'Winter';
			year: each;
			save.
	].

	semester := (SqsSearch for: DLSemester) detect: 
	[:aSemester |( aSemester semesterName = 'Sommer') & (aSemester year = 2009)].

	user := DLUser createFrom: {
		#userName->'Sebastian.Hillig'.
		#realName->'Sebastian Hillig'. 
		#email->'Sebastian.Hillig@student.hpi.uni-potsdam.de'}.
		
	userBehrens := DLUser createFrom: {
		#userName->'Markus.Behrens'.
		#realName->'Markus Behrens'. 
		#email->'Markus.Behrens@student.hpi.uni-potsdam.de'}.

	userGoetz := DLUser createFrom: {
		#userName->'Markus.Goetz'.
		#realName->'Markus Goetz'. 
		#email->'Markus.Goetz@student.hpi.uni-potsdam.de'}.		

	userChr := DLUser createFrom: {
		#userName->'christian.ress'. 
		#realName->'Christian Ress'. 
		#email->'christian.ress@student.hpi.uni-potsdam.de'}.
	
	userMichaelHaupt := DLUser createFrom: {
		#userName->'michael.haupt'.
		#realName->'Michael Haupt'.
		#email->'christian.ress@student.hpi.uni-potsdam.de'
	}.
	
	userJack := DLUser createFrom: {
		#userName->'jack'. 
		#realName->'Jack Johnson'. 
		#email->'jack@hpi.uni-potsdam.de'. 
		#isAdmin->true. 
		#isTeacher->true}.
		
	userJohn := DLUser createFrom: {
		#userName->'john'. 
		#email->'john@hpi.uni-potsdam.de'. 
		#isAssistant->true}.
		
	userAss1 := DLUser createFrom: {
		#userName->'assistent1'. 
		#email->'assistent1@hpi.uni-potsdam.de'.
		#isAssistant->true}.
		
	userAss2 := DLUser createFrom: {
		#userName->'assistent2'. 
		#email->'assistent2@hpi.uni-potsdam.de'. 
		#isAssistant->true}.
	
	studentSet := OrderedCollection new add: userChr; yourself.
	
	lecture := DLLecture new
		lectureName: 'Softwaretechnik I';
		lectureHomepage: 'http://www.hpi.uni-potsdam.de/studium/lehrangebot/veranstaltung/softwaretechnik_i-3.html';
		mailingList: 'swt@fakeurl.com';
		teacher: userJack;
		semester: semester;
		students: studentSet;
		save.
		
	lecture2 := DLLecture new
		lectureName: 'Softwarearchitektur';
		lectureHomepage: 'http://www.hpi.uni-potsdam.de/studium/lehrangebot/lehrangebotsarchiv/lehrangebotsarchiv_ws_0809/veranstaltung/softwarearchitektur-3.html';
		mailingList: 'fake@swafake.tv';
		semester: semester;
		students: studentSet copy;
		save.
		
	filetype := DLFileType createFrom: {
		#filetypeName->'Prsentation'. 		
		#extensionsText->'.pdf,.ppt,.pptx'}.
		
	filetypeCoding  := DLFileType createFrom: {
		#filetypeName->'Codedateien'. 		
		#extensionsText->'.sar, .cpp'}.
	
	requirement := DLRequirement createFrom:{
		#requirementName->'Prsentation'. 		
		#requirementDescription->'Auseinandersetzung mit Interteamrelationships in hyperaktiven Teams'. 
		#filetype->filetype}.
		
	requirementCoding := DLRequirement createFrom:{
		#requirementName->'Codeabgabe'. 		
		#requirementDescription->'Bitte gebt die .sar eures Projekts ab'. 
		#filetype->filetypeCoding}.
	
	requirementCoding2 := DLRequirement createFrom:{
		#requirementName->'Codedokumentation'. 		
		#requirementDescription->'Bitte gebt die Dokumentation des Projekts ab'. 
		#filetype->filetype}.
	
	group := DLGroup new
		lecture: lecture;
		groupName: 'SWT Crew 09';
		groupDescription: 'A SWT Group';
		students: ( {user} as: OrderedCollection );
		save.
	
	deadline := DLDeadline createFrom: {
		#lecture-> lecture.
		#group-> group.
		#deadlineName-> 'Vortragsfolien'. 
		#deadlineDescription-> 'Bitte gebt eure Folien fr euren Kurzvortrag ab'.
		#date->(Date today). 
		#time->(Time now addTime: (Time hour: 0 minute: 60 second: 0)). 		
		#requirements->(OrderedCollection with: requirement)}.

	deadlineCoding := DLDeadline createFrom: {
		#lecture-> lecture.
		#group-> nil.
		#deadlineName-> 'Projektabgabe'. 
		#deadlineDescription-> 'Bitte gebt alle Codedateien eures Projekts ab.'.
		#date->(Date year: 2009 month: 7 day: 30). 
		#time->(Time hour: 23 minute: 59 second:59). 		
		#requirements->(OrderedCollection with: requirementCoding with: requirementCoding2)}.
	
	{'DevChat #1'. 'DevChat #2'. 'Accounting System'. 'Submitting System #2'. 'FileBrowser on Steroids'. 'LiveChat'. 'iKuh Leveleditor'. 'Telefonbuch #1'} do: [:each |
		DLGroup createFrom: {
			#lecture->lecture.
			#groupName->each.
			#groupDescription->'SWT-Beispielgruppe'.
		}.
	].
	
	
	{'Connect!!'. 'DabbleDB'. 'SqueakSource Impro'. 'OODB!!'} do: [:each |
		DLGroup createFrom: {
			#lecture->lecture2.
			#groupName->each.
			#groupDescription->'SWA-Beispielgruppe'.
		}.
	].
	

		
	groupJack := DLGroup new
		lecture: lecture;
		groupName: 'Jacks SWT Group';
		groupDescription: 'Owner: Jack Johnson';
		students: ( OrderedCollection with: userJack with: userChr);
		save.! !

!Tutorials methodsFor: 'tutorial' stamp: 'sebh 6/2/2009 13:50'!
HowToResetYourDB

"session := SqsConnectionManager getInstance sessionForClass: DLUser.
session resetDatabase.
"! !

!Tutorials methodsFor: 'as yet unclassified' stamp: 'cr 7/24/2009 13:19'!
InstallDatabase
	| session semester |
	
	session := SqsConnectionManager getInstance sessionForClass: DLUser.
	session resetDatabase.
	
	{2009. 2010. 2011} do: [:each | 
		DLSemester new
			semesterName: 'Sommer';
			year: each;
			save.
		DLSemester new
			semesterName: 'Winter';
			year: each;
			save.
	].

	semester := (SqsSearch for: DLSemester) detect: 
	[:aSemester |( aSemester semesterName = 'Sommer') & (aSemester year = 2009)].


	DLUser createFrom: {
		#userName->'michael.haupt'. 
		#realName->'Michael Haupt'. 
		#email->'michael.haupt@hpi.uni-potsdam.de'. 
		#isAdmin->true.
	}.
	
	DLUser createFrom: {
		#userName->'michael.perscheid'. 
		#realName->'Michael Perscheid'. 
		#email->'michael.perscheid@hpi.uni-potsdam.de'. 
		#isAdmin->true.
	}.
	
	DLUser createFrom: {
		#userName->'marcel.taeumel'. 
		#realName->'Marcel Taeumel'. 
		#email->'marcel.taeumel@student.hpi.uni-potsdam.de'. 
		#isAdmin->true.
	}.
	
	DLUser createFrom: {
		#userName->'christian.ress'. 
		#realName->'Christian Ress'. 
		#email->'christian.ress@student.hpi.uni-potsdam.de'. 
		#isAdmin->true.
	}.! !

!Tutorials methodsFor: 'tutorial' stamp: 'MG 6/29/2009 00:29'!
SendingEMailsWithSqueak

"|username password sender receiver|

username:= 'smtp_user_name'.
password:='smtp_password'.

sender := sender@test.de.
receiver := receiver@test.de.

client := SMTPClient openOnHostNamed: '<smtp_host>' port: <smtp_port, default: 25>.
client 	user: username;
			password: password;
client   login;
			initiateSession.
client 	mailFrom: sender;
 			recipient: receiver;
 			data:	'Subject: <Betreff>
			From: <Sender-Label>
			To: <Empfaenger-Label>
			
			Kleiner E-Mail-Test'.
client quit.

--------------------------------------------------------
Kleines Beispiel mit Test-SMTP-Acc auf Christians SMTP
--------------------------------------------------------

username:= 'squeaky'.
password:='jflymcv98yM'.

client := SMTPClient openOnHostNamed: 'darwin.yetisoft.net' port: 25.
client user: username; password: password; login; initiateSession.
client mailFrom: 'squeaky@darwin.yetisoft.net';
 	recipient: 'markus.goetz@student.hpi.uni-potsdam.de';
 	data:	'Subject: Hello from SMTPClient!!
			From: squeaky@darwin.yetisoft.net
			To: murxman@web.de
			
			Kleiner E-Mail-Test'.
client quit."! !

!Tutorials methodsFor: 'tutorial' stamp: 'sebh 6/3/2009 22:57'!
WhatToInstall
"
Von SqueakMap: Magritte 1.1.1

Announcements
MCHttpRepository
	location: 'http://source.lukas-renggli.ch/announcements'
	user: ''
	password: ''

SqsSave im Monticello updaten.

DatabaseFixture aus den Tutorials ziehen und in einem Workspace ausfhren.

Im Seaside Admin:
	Add new entry
	'deli', Application
	RootComponent DLRootTask
	SessionComponent DLSession

Benutzer aus dem fixture und mit beliebigem passwort nutzbar:
	jack - admin
	john - user
"! !

MASelectListComponent subclass: #DLMASelectListComponent
	instanceVariableNames: ''
	classVariableNames: 'NewElementClass'
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMASelectListComponent class methodsFor: 'accessing' stamp: 'Marik 7/17/2009 10:47'!
newElementClass

	^ NewElementClass! !

!DLMASelectListComponent class methodsFor: 'accessing' stamp: 'Marik 7/17/2009 10:47'!
newElementClass: anObject

	NewElementClass := anObject.! !

!DLMASelectListComponent methodsFor: 'saving' stamp: 'sebh 7/19/2009 23:45'!
addNewElement

	| answer |
	answer := self root call: ((self class newElementClass new descriptionCreate asComponentOn: self class newElementClass new) addForm).
	answer ifNotNil: [
		answer save. 
		self value: answer.
		self description options add: answer.
		]! !

!DLMASelectListComponent methodsFor: 'rendering' stamp: 'Marik 7/16/2009 13:54'!
renderEditorOn: html
	self description isGrouped
		ifTrue: [ self renderEditorForGroupedOn: html ]
		ifFalse: [ self renderEditorForUngroupedOn: html ].
	html break.
	html submitButton on: #addNewElement of: self.! !

SqsConfig subclass: #DeliSqsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DeliSqsConfig class methodsFor: 'configuration' stamp: 'sebh 6/15/2009 23:04'!
configuration
	| config |
	config := super configuration.
	
	config
		warnOnAlteration: false.

	^ config.! !

!DeliSqsConfig class methodsFor: 'specification' stamp: 'cr 6/9/2009 14:41'!
connectionSpecification
	^ SqsMySQLConnectionSpecification 
		user: 'root'
		password: ''
		database: 'deli'
		port: 3306
		host: 'localhost'! !

Error subclass: #DLMultipleResultsException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

Error subclass: #DLNilValueException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

Error subclass: #DLNoResultException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

Error subclass: #MultipleResultsException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

WAApplication subclass: #DLApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

DLApplication class
	instanceVariableNames: 'scheduler'!

DLApplication class
	instanceVariableNames: 'scheduler'!

!DLApplication class methodsFor: 'description' stamp: 'test 6/14/2009 15:22'!
description
	^ 'DLApplication'! !

!DLApplication class methodsFor: 'cronjob' stamp: 'cr 7/24/2009 16:10'!
startNotificationSchedule
	scheduler := TaskScheduler new.
	scheduler start.
	scheduler do: [
		Transcript show: DateAndTime now asString; cr;
					  show: 'Running notification process'; cr.
		DLNotification releaseMails.
		Transcript show: 'Finished';cr.
		] every: 1200 seconds.! !

!DLApplication class methodsFor: 'cronjob' stamp: 'sebh 7/17/2009 23:55'!
stopNotificationSchedule
	scheduler stop.! !

!DLApplication class methodsFor: 'as yet unclassified' stamp: 'MG 7/23/2009 19:33'!
translations
	^ Dictionary new
		at: #save put: 'Speichern';
		at: #cancel put: 'Abbrechen';
		at: #choose put: 'Auswhlen';
		at: #add put: 'Hinzufgen';
		at: #remove put: 'Entfernen';
		at: #change put: 'Verndern';
		at: #edit put: 'ndern';
		at: #now put: 'Jetzt';
		at: #leave put: 'Verlassen';
		yourself.! !

!DLApplication methodsFor: 'initialize' stamp: 'sebh 7/17/2009 21:45'!
initialize
	super initialize.
	self addLibrary: DLFileLibrary.
	self addLibrary: SULibrary.
	self preferenceAt: #mainClass    	 put: DLAuthMain.
	self preferenceAt: #sessionClass 	 put: DLSession.
	self preferenceAt: #useSessionCookie put: true.
	self preferenceAt: #rootComponent    put: DLRootComponent.! !

TestCase subclass: #DLGenericModelTests
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 6/30/2009 11:53'!
session

	^ session! !

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 6/30/2009 11:53'!
session: anObject

	session := anObject.! !

!DLGenericModelTests methodsFor: 'as yet unclassified' stamp: 'sebh 6/30/2009 18:26'!
setUp
	| |
	super setUp.
	SqsConnectionManager reset.
	self session: (SqsConnectionManager getInstance sessionForClass: DLTestModel).
	self session resetDatabase.
	

	! !

!DLGenericModelTests methodsFor: 'as yet unclassified' stamp: 'sebh 6/30/2009 18:06'!
tearDown
	| |
	super tearDown.

	! !

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 7/12/2009 18:44'!
testCollectionLogging
	| model item |
	model := DLTestModel createFrom: {
		#title->'A nice title'. 
		#items->{
			DLTestItemModel createFrom:{#title->'Nummer 1'}.
			DLTestItemModel createFrom:{#title->'Nummer 2'}.
			} asOrderedCollection.
		}.
		
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 1] 
		  description: 'Saving a new item should result in a log entry'.
	self assert: [((SqsSearch for: DLLogEntry) select: [:anEntry | anEntry changes anySatisfy: [:aChange | aChange attributeName = 'title']]) size = 1]
		  description: 'Make sure the created changes include #title'.
		self assert: [((SqsSearch for: DLLogEntry) select: [:anEntry | anEntry changes anySatisfy: [:aChange | aChange attributeName = 'items']]) size = 1]
		  description: 'Make sure the created changes include #items'.
	self assert: [((SqsSearch for: DLLogEntry) select: [:aChange | aChange changes size = 3]) size = 1]
			description: '3 changes should have been recorded: Changed title + 2 added elements'.
	model := DLTestModel getOrCreateFrom: {#title->'A nice title'}.
	model save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 1]
		  description: 'Since nothing changed, no new log should be created'.
	item := DLTestItemModel createFrom:{#title->'Nummer 3'}.
	model items add: (item).
	model save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 2]
		  description: 'Collection changed, a new log entry should be created'.
	model items remove: item.
	model save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 3]
		  description: 'Collection changed, a new log entry should be created'.! !

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 7/10/2009 16:10'!
testCollectionProxyProtection
	| model item item2 |
	item := DLTestItemModel createFrom: {#title->'Test'}.
	model := DLTestModel newFrom: {
		#title->'A nice title'.
		#items->(OrderedCollection with: item)
	}.
	model save.
	self assert: [model items class includesBehavior: SqsProxy] 
	     description: 'After #save, collections should be proxied'.
	item2 := DLTestItemModel createFrom: {#title->'Test2'}.
	model items: (OrderedCollection with: item2).
	self assert: [model items class includesBehavior: SqsProxy] 
		  description: 'Trying to replace a proxied collection just adds and removes differences but does not replace the original list'.! !

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 7/9/2009 10:37'!
testCollectionProxying
	| model item |
	item := DLTestItemModel createFrom: {#title->'Test'}.
	model := DLTestModel newFrom: {
		#title->'A nice title'.
		#items->(OrderedCollection with: item)
	}.
	model save.
	self assert: (model items class includesBehavior: SqsProxy)! !

!DLGenericModelTests methodsFor: 'as yet unclassified' stamp: 'sebh 6/27/2009 18:59'!
testCreateFrom
	| model model2 |
	model := DLTestModel createFrom: {#title->'A nice title'}.
	self assert: [ model oid notNil ] description: 'CreateFrom saves an object to a database'.
	model2 := DLTestModel createFrom: {#title->'A nice title'}.
	self assert: [ model oid notNil ] description: 'CreateFrom saves another object to a database, doesnt care about identity'.
	self assert: [ model ~= model2 ] description: 'Objects should not be equal'.! !

!DLGenericModelTests methodsFor: 'as yet unclassified' stamp: 'sebh 6/27/2009 19:13'!
testGetOrCreateFrom
	| model model2 model3 |
	model := DLTestModel getOrCreateFrom: {#title->'A nice title'}.
	self assert: [ model oid notNil ] description: 'GetOrCreateFrom saves an object to a database, if it didnt exist before'.
	model2:= DLTestModel getOrCreateFrom: {#title->'A nice title'}.
	self assert: [model = model2] description: 'Same parameters lead to the same object.'.
	model3:= DLTestModel getOrCreateFrom: {#title->'A nice title'. #body->'Same title, but given text'}.
	self assert: [model2 ~= model3] description: 'Different parameters will create a new object'.	! !

!DLGenericModelTests methodsFor: 'as yet unclassified' stamp: 'sebh 6/30/2009 18:24'!
testGetOrCreateFromColisions
	| model1 model2 |
	model1 := DLTestModel getOrCreateFrom: {#title -> 'A nice title'. #body -> 'A body'}.
	model2 := DLTestModel getOrCreateFrom: {#title -> 'A nice title'. #body -> 'Another body'}.
	self assert: [ model1 ~= model2 ] description: 'Different parameters should create different objects'.
	self should: [ DLTestModel getOrCreateFrom: {  (#title -> 'A nice title')  } ]
		  raise: DLMultipleResultsException
		  description: '"A nice title" is set for two objects, thus it is not possible to return a single object that fits the array'! !

!DLGenericModelTests methodsFor: 'as yet unclassified' stamp: 'sebh 6/30/2009 18:21'!
testGetOrCreateNil
	self should: [ DLTestModel getOrCreateFrom: {#title -> 'A nice title'. #body -> nil} ]
		  raise: DLNilValueException
		  description: 'We do not retrieve objects for nil which is to be treated as uncertain value'! !

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 6/30/2009 18:25'!
testLogging
	| model logEntry |
	model := DLTestModel createFrom: {#title->'A nice title'}.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 1] 
		  description: 'A newly created model with tracked fields creates a log entry'.
	logEntry := (SqsSearch for: DLLogEntry) findAll first.
	self assert: [ (logEntry klassName = 'DLTestModel') & (logEntry oid = model oid) ] 
		  description: 'A new logentry with corresponding info was created'.
	model save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 1] 
	     description: 'Having changed nothing, we dont create a new log entry'.
	model title: 'Another title'; save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 2] 
	     description: 'Having changed a tracked instvar, we create a new log entry'.
	model body: 'Somebody!!'; save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 2] 
	     description: 'Having changed a nontracked instvar, we dont create a new log entry'.
	! !

!DLGenericModelTests methodsFor: 'as yet unclassified' stamp: 'sebh 7/10/2009 16:18'!
testNewFrom
	| model |
	model := DLTestModel newFrom: {#title->'A nice title'. #items->{'item 1'. 'item 2'}}.
	self assert: [ model title = 'A nice title'] description: 'Correct model title'.
	self assert: [ model items =(OrderedCollection newFrom:{'item 1'. 'item 2'})] description: 'Correct model item collection'.
	self assert: [ model oid isNil ] description: 'newFrom does not invoke a database save'.! !

TestCase subclass: #DLPolicyTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLPolicyTests methodsFor: 'as yet unclassified' stamp: 'sebh 7/9/2009 15:31'!
testCanonicalName
	Tutorials new DatabaseFixture.
	DLModel allInstancesDo: [:instance| 
		self assert: [instance perform: #canonicalName notNil]
			  description: instance className, ' does not properly implement #canonicalName (returns nil)'
		]
	! !

!DLPolicyTests methodsFor: 'as yet unclassified' stamp: 'sebh 7/9/2009 15:31'!
testMetaName
	DLModel allSubclassesDo: [:subclass| 
		self assert: [(subclass perform: #metaName) notEmpty]
			  description: subclass name, ' does not properly implement #metaName (is empty)'
		]! !

!DLPolicyTests methodsFor: 'as yet unclassified' stamp: 'sebh 7/9/2009 15:31'!
testMetaNamePlural
	DLModel allSubclassesDo: [:subclass| 
		self assert: [(subclass perform: #metaNamePlural) notEmpty]
			  description: subclass name, ' does not properly implement #metaNamePlural (is empty)'
		]! !

WAFileLibrary subclass: #DLFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLFileLibrary methodsFor: 'uploaded' stamp: ''!
addPng
	| cache |
	cache := #(nil) beMutable.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 111 73 68 65 84 56 203 165 147 235 75 147 97 24 135 253 91 182 47 5 131 164 134 89 40 168 41 37 88 40 111 217 108 138 138 78 219 150 115 107 138 206 246 110 46 157 186 205 3 45 157 19 15 21 181 161 219 104 164 59 56 15 195 3 102 226 212 210 69 234 235 80 162 141 34 8 106 195 175 191 222 21 77 71 203 136 30 248 125 121 224 186 158 231 190 185 239 36 0 73 255 147 223 46 116 211 117 204 14 143 132 108 117 137 168 230 9 65 88 254 162 58 220 240 188 130 146 90 203 72 209 104 49 243 68 129 110 90 74 180 79 74 66 207 214 123 177 26 90 132 255 243 6 214 63 173 96 50 96 135 210 83 3 190 137 19 226 61 185 78 36 20 252 132 197 145 233 61 59 14 190 237 97 246 131 11 38 106 16 143 119 12 176 239 155 176 244 113 14 218 5 25 74 71 242 35 220 193 60 34 78 160 157 146 50 104 56 232 222 181 96 239 235 54 134 183 245 120 184 214 129 110 95 43 12 126 29 250 252 90 116 111 182 192 125 96 7 233 17 162 208 120 37 88 208 155 205 136 9 104 88 209 191 172 198 187 47 155 244 139 125 232 221 210 66 243 74 137 95 71 189 38 131 124 81 8 197 114 45 156 251 54 220 28 201 65 222 131 12 69 76 208 226 172 161 92 1 27 253 85 51 58 87 85 104 91 145 67 54 43 138 9 4 54 46 26 102 202 32 157 42 198 192 27 29 244 75 205 184 220 157 70 197 4 138 113 254 161 247 189 11 253 111 117 52 220 132 63 29 241 100 17 20 243 124 88 252 195 200 210 165 30 198 4 77 118 222 225 68 96 12 218 13 18 42 95 253 137 2 210 91 13 171 127 8 233 29 236 35 65 189 173 156 50 250 180 48 108 105 208 244 82 8 241 124 5 120 214 27 113 96 52 119 61 92 244 251 212 232 242 222 195 5 117 242 81 9 226 177 18 197 109 43 1 71 192 2 217 124 37 36 222 210 31 53 31 23 136 156 28 212 185 139 225 216 53 227 82 79 42 216 247 89 71 77 20 154 139 24 85 79 11 131 164 71 128 113 106 52 214 176 40 88 235 140 38 10 115 49 177 99 194 29 203 173 40 28 76 86 158 102 196 13 82 249 163 2 162 100 232 106 164 209 81 9 39 45 49 250 218 65 206 84 65 62 85 9 227 106 27 28 52 44 180 112 192 86 177 34 52 76 36 28 101 206 64 46 65 24 114 66 249 3 153 232 89 32 97 126 109 128 121 195 0 141 183 17 89 93 41 81 56 116 28 78 184 76 215 244 153 204 220 158 116 50 187 243 34 149 161 73 9 167 181 159 13 159 111 61 67 157 83 177 200 100 229 41 230 95 183 241 95 243 29 65 70 203 31 0 40 211 193 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: ''!
backPng
	| cache |
	cache := #(nil) beMutable.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 0 235 73 68 65 84 56 203 99 252 255 255 63 3 37 128 137 129 66 48 200 12 40 61 145 201 6 196 187 73 49 128 5 141 127 245 239 159 191 50 164 24 192 8 139 5 160 205 23 197 217 36 244 254 252 249 195 240 240 253 67 134 95 63 127 51 252 250 1 194 191 24 126 2 49 152 254 142 96 131 228 46 244 95 101 100 129 106 62 41 198 42 174 167 192 173 196 240 231 223 31 6 25 110 57 48 253 251 239 95 32 254 205 240 251 31 16 255 253 3 21 3 209 191 25 86 175 92 139 240 2 208 217 191 255 48 254 97 248 245 247 23 88 209 31 160 162 223 96 197 191 17 52 212 0 144 220 159 255 64 177 95 127 80 189 144 185 51 238 188 48 155 136 1 7 51 39 195 195 151 15 25 94 191 127 131 213 217 32 175 129 52 255 249 253 135 225 254 194 71 140 140 200 41 49 118 85 200 77 160 66 57 160 6 199 13 105 59 78 144 28 141 64 205 186 64 205 7 137 213 140 226 133 17 156 23 0 227 161 187 188 122 90 211 201 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: ''!
choosePng
	| cache |
	cache := #(nil) beMutable.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 1 171 73 68 65 84 56 203 189 147 217 46 67 97 20 133 123 231 56 239 98 110 213 24 83 66 170 134 84 39 234 232 41 69 41 141 27 170 167 173 86 171 67 74 12 199 165 24 106 142 196 20 148 32 18 151 90 213 134 103 16 47 161 186 252 149 104 194 133 24 18 23 255 221 191 214 222 251 219 107 11 0 8 254 242 4 255 110 160 94 107 226 91 150 234 157 191 50 80 173 54 242 166 99 61 250 15 88 72 248 42 238 71 6 202 96 3 63 120 212 133 217 123 55 188 55 86 232 182 212 168 240 20 217 190 37 86 172 72 121 227 161 14 211 113 23 166 226 78 116 110 183 162 210 91 140 18 135 144 74 127 50 94 178 53 134 51 166 231 179 88 190 44 229 83 45 79 198 156 8 196 28 111 149 203 221 226 68 241 88 1 149 30 193 120 193 150 245 158 50 79 220 181 9 236 174 114 232 93 76 96 241 125 251 90 4 238 198 224 191 179 131 221 84 161 204 85 152 40 178 231 83 105 136 253 231 218 218 222 80 251 163 47 204 97 58 54 14 205 150 44 65 96 13 201 22 37 83 134 61 6 190 168 29 222 91 14 29 27 10 148 142 139 18 98 91 30 245 97 141 61 39 154 76 253 97 27 204 87 3 152 123 240 192 27 182 194 120 164 131 233 68 143 137 176 5 238 91 11 152 117 57 74 156 194 151 66 235 71 113 122 4 102 71 78 147 202 48 133 244 111 115 250 163 54 184 34 102 184 194 102 104 214 90 82 176 146 34 46 151 250 50 72 4 22 45 91 144 160 123 183 29 238 200 40 28 55 195 104 11 202 64 96 37 69 150 28 234 91 73 148 204 87 211 117 51 149 164 101 5 212 43 205 32 176 146 194 209 108 234 71 81 38 251 165 203 39 196 32 176 158 11 204 217 25 191 186 5 2 139 206 31 201 202 248 151 107 124 5 190 162 169 60 82 10 3 72 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: ''!
deletePng
	| cache |
	cache := #(nil) beMutable.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 33 73 68 65 84 56 203 149 147 235 78 19 81 20 133 137 137 201 137 207 160 86 137 134 200 145 128 196 27 66 91 6 40 173 13 8 38 208 251 133 94 164 128 180 165 237 164 77 161 54 234 15 77 124 18 159 11 68 197 222 176 210 153 118 58 211 229 174 152 74 45 37 225 199 78 206 100 206 250 246 172 181 247 12 0 24 184 76 213 215 66 215 206 62 119 95 16 51 58 42 222 87 236 15 114 217 237 141 215 108 78 67 47 160 45 206 236 162 149 206 66 139 39 123 32 117 95 128 215 3 97 52 54 182 240 235 229 202 231 234 226 210 189 127 128 191 98 228 223 161 69 165 37 68 52 55 183 59 16 217 187 198 169 59 154 209 56 144 203 163 125 62 54 91 227 229 25 211 149 83 64 42 205 90 9 81 107 237 190 1 62 126 130 150 205 181 1 104 4 66 92 246 248 57 117 135 178 29 3 232 189 236 15 224 120 254 185 90 22 230 174 118 89 208 98 9 166 190 142 169 154 152 1 222 127 128 154 74 163 30 12 131 186 67 217 138 2 217 189 63 231 138 201 66 226 89 118 110 136 205 200 38 107 132 214 213 102 116 135 236 188 5 246 242 36 204 1 153 44 100 143 15 149 57 179 90 158 158 97 253 167 112 26 22 147 92 94 13 89 178 227 246 1 14 55 32 166 81 153 157 215 74 70 129 253 127 191 7 32 57 61 237 81 1 52 13 216 156 192 138 29 216 73 146 111 11 10 19 83 252 66 128 228 112 115 201 229 129 18 142 0 73 145 132 41 32 70 118 40 64 121 213 142 178 222 136 239 99 227 252 92 64 205 238 226 146 211 13 37 180 14 208 24 37 135 11 20 150 90 156 50 104 39 139 203 64 100 3 181 23 203 40 60 124 140 195 161 97 222 5 160 205 226 212 29 74 240 21 117 77 64 162 79 167 176 212 226 164 129 21 158 76 176 163 241 71 106 213 100 6 130 33 156 88 172 56 26 25 197 193 173 65 222 1 208 102 9 53 155 3 74 32 4 105 213 1 10 75 45 62 211 119 2 251 54 50 198 190 14 223 87 127 26 5 72 214 5 252 24 125 128 253 27 58 161 203 2 109 150 80 93 88 66 201 48 173 81 88 61 105 31 222 29 98 95 6 239 168 103 197 61 33 150 244 70 161 240 116 146 245 251 153 14 116 183 217 254 245 155 194 133 99 188 108 253 6 114 187 164 199 219 237 190 20 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: ''!
detailsPng
	| cache |
	cache := #(nil) beMutable.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 70 73 68 65 84 56 203 141 210 75 72 212 65 28 192 241 239 204 170 45 150 138 75 190 67 61 216 3 13 161 67 109 210 102 117 238 80 150 16 137 27 24 41 68 151 234 16 66 167 34 194 75 7 187 36 65 132 10 101 164 166 116 182 168 164 240 160 18 244 130 74 16 140 205 30 90 238 138 187 255 121 117 217 21 109 141 252 193 48 15 248 125 102 126 51 35 156 115 0 76 222 15 7 17 178 29 124 33 33 124 1 103 45 86 169 57 173 188 81 235 233 142 186 179 253 99 172 17 18 96 178 239 84 171 144 153 67 56 42 172 151 232 244 22 163 53 222 98 172 70 39 226 157 206 82 33 68 198 208 139 155 13 173 107 1 98 226 94 115 80 200 204 33 171 189 187 178 190 171 23 168 1 202 0 3 76 3 111 99 143 194 103 192 215 162 226 137 163 135 46 61 94 117 18 233 144 237 214 152 136 172 239 234 1 14 2 91 129 13 128 31 168 2 234 54 53 244 222 182 70 71 28 180 167 149 32 144 33 167 212 32 80 13 228 37 119 78 53 149 92 171 210 113 61 40 16 161 116 64 200 128 209 182 31 40 1 116 50 41 213 167 160 34 171 76 63 66 6 254 6 50 172 117 88 99 89 145 228 86 36 166 198 218 24 131 212 38 253 21 180 231 205 97 93 99 242 194 116 178 165 128 212 60 226 12 141 42 161 230 210 0 227 169 81 231 196 49 224 3 240 125 69 9 41 104 30 152 146 89 25 151 173 167 167 210 129 132 234 176 142 146 133 129 230 54 96 12 248 4 68 129 88 114 60 30 27 58 61 85 82 189 205 239 247 204 158 225 243 251 79 174 250 7 206 57 158 221 56 210 42 125 242 170 86 38 98 61 61 104 148 233 183 214 129 113 141 217 129 220 43 5 59 182 203 156 226 74 84 60 198 212 211 231 252 250 242 173 248 248 173 151 179 203 0 192 200 245 195 65 160 29 33 67 2 2 206 58 148 167 163 25 190 204 188 202 250 125 228 20 110 65 72 201 239 153 143 188 126 48 98 141 77 148 158 184 51 54 187 12 252 43 134 47 28 8 231 151 151 246 148 7 131 248 115 243 73 196 162 204 190 153 224 201 192 171 207 21 69 27 107 255 11 0 12 158 11 133 243 74 11 123 202 118 237 196 33 249 249 233 61 95 223 77 207 121 75 170 98 93 0 192 195 182 189 97 181 164 123 54 87 21 176 48 51 31 241 60 85 219 212 61 254 99 221 0 64 95 203 238 64 44 174 47 102 103 137 107 77 221 19 113 128 63 41 169 43 251 29 137 72 245 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: ''!
diskCriticalPng
	| cache |
	cache := #(nil) beMutable.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 217 7 23 16 42 29 150 64 87 240 0 0 4 27 73 68 65 84 56 17 1 16 4 239 251 1 54 107 188 113 0 0 0 31 0 0 0 60 0 0 0 34 0 0 0 12 0 0 255 4 0 0 0 1 0 255 0 0 0 0 0 0 3 2 1 0 2 2 1 0 255 255 254 0 254 254 0 240 6 5 0 220 247 249 251 137 203 151 74 172 4 0 0 0 42 155 117 58 100 0 0 1 0 39 27 7 0 255 0 0 0 255 254 255 0 250 252 255 0 250 251 254 0 3 2 1 0 9 7 2 0 1 1 0 0 244 247 254 0 244 248 253 15 222 231 244 48 161 185 221 152 0 105 181 15 2 0 0 0 61 0 255 0 0 175 202 242 0 254 255 0 0 255 255 255 0 110 147 203 0 254 254 255 0 0 1 1 0 5 4 1 0 2 2 1 0 250 252 255 0 247 251 254 0 252 254 0 1 253 0 2 4 95 71 35 19 9 7 6 149 2 0 0 0 24 255 0 0 0 254 254 255 0 251 252 254 0 251 252 255 0 0 0 0 0 251 254 255 0 4 3 0 0 5 4 1 0 254 254 255 0 247 250 254 0 251 252 255 0 0 255 255 0 192 211 243 0 6 5 3 0 247 249 252 6 4 0 0 0 10 252 254 255 0 0 0 255 0 247 250 254 0 0 0 0 0 2 1 1 0 0 255 0 0 5 4 2 0 1 0 1 0 248 251 254 0 247 249 255 0 254 255 255 0 254 255 0 0 254 255 255 0 230 237 248 0 0 255 255 1 4 0 0 255 4 253 255 255 0 255 255 0 0 249 252 255 0 0 0 0 0 125 96 48 0 5 4 2 0 4 2 0 0 251 253 255 0 246 249 254 0 252 254 254 0 254 254 0 0 255 0 255 0 255 254 254 0 251 252 253 0 255 255 254 0 4 0 0 0 1 254 253 0 0 0 255 255 0 131 160 207 0 1 1 1 0 2 1 0 0 5 4 2 0 1 0 0 0 252 254 255 0 252 252 254 0 255 0 0 0 0 0 0 0 0 0 0 0 16 16 18 0 251 252 3 0 0 255 255 0 4 0 255 0 0 254 255 254 0 254 254 253 0 22 23 27 0 0 1 0 0 1 0 255 0 0 255 0 0 0 0 255 0 254 255 0 0 255 254 251 0 14 0 234 0 8 255 242 0 252 255 1 0 240 252 12 0 251 251 3 0 0 255 254 0 4 0 0 0 0 253 253 0 0 255 255 0 0 0 0 0 0 1 255 255 0 0 0 0 0 0 1 0 0 254 254 0 0 9 255 240 0 47 3 185 0 44 2 194 0 16 1 233 0 251 255 6 0 221 4 48 0 230 14 57 0 255 255 11 0 2 0 0 0 0 252 253 254 0 0 0 255 0 0 0 255 0 255 0 255 0 0 0 0 0 0 255 255 0 0 254 253 0 47 1 185 0 58 3 175 0 23 2 225 0 19 90 203 0 12 2 242 0 45 4 195 0 45 229 182 0 31 10 232 0 4 0 0 255 0 253 254 255 0 0 255 0 0 126 89 28 0 0 0 0 0 0 0 0 0 0 0 0 0 255 238 234 0 253 204 199 0 0 242 244 0 0 0 0 0 0 0 0 0 0 0 0 0 2 1 255 0 23 255 217 0 53 18 25 0 4 2 1 1 0 253 254 0 0 255 0 255 0 255 255 0 0 145 198 100 0 0 0 0 0 0 0 0 0 21 239 254 0 81 249 222 0 6 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4 255 250 0 32 11 235 0 4 0 1 0 0 254 254 255 0 1 0 0 0 0 0 0 0 58 28 93 0 0 0 0 0 0 0 0 0 6 5 234 0 1 230 217 0 0 252 244 0 0 0 0 0 244 167 45 0 0 0 0 0 0 0 0 0 255 0 1 0 243 251 7 0 4 255 255 255 255 253 254 255 1 0 0 255 0 0 0 0 0 198 228 163 0 0 0 0 0 0 0 0 0 5 254 253 0 5 5 7 0 37 252 244 0 2 0 0 0 12 89 211 0 244 167 45 0 0 0 0 0 242 255 18 0 208 238 29 255 4 254 255 0 224 250 252 254 33 51 35 10 0 1 1 0 0 112 59 156 0 0 0 0 0 0 0 0 0 0 0 0 0 250 220 203 0 3 230 156 0 255 237 209 0 244 167 45 0 0 0 2 0 240 254 17 0 204 249 64 0 204 234 31 240 1 54 106 186 143 255 255 255 38 0 0 255 57 0 255 255 17 0 0 254 0 255 255 255 0 0 255 254 0 255 255 254 0 0 255 254 0 31 10 232 0 53 18 220 0 31 11 236 0 243 250 8 0 210 240 28 255 206 237 31 244 248 255 7 210 207 105 102 184 17 111 31 197 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: ''!
diskOverPng
	| cache |
	cache := #(nil) beMutable.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 217 7 21 11 55 46 108 134 222 224 0 0 4 27 73 68 65 84 56 17 1 16 4 239 251 1 54 107 188 113 0 0 0 31 0 0 0 60 0 0 0 34 0 0 0 12 0 0 255 4 0 0 0 1 0 255 0 0 0 0 0 0 3 2 1 0 2 2 1 0 255 255 254 0 254 254 0 240 6 5 0 220 247 249 251 137 203 151 74 172 4 0 0 0 42 155 117 58 100 0 0 1 0 39 27 7 0 255 0 0 0 255 254 255 0 250 252 255 0 250 251 254 0 3 2 1 0 9 7 2 0 1 1 0 0 244 247 254 0 244 248 253 15 222 231 244 48 161 185 221 152 0 105 181 15 2 0 0 0 61 0 255 0 0 175 202 242 0 254 255 0 0 255 255 255 0 110 147 203 0 254 254 255 0 0 1 1 0 5 4 1 0 2 2 1 0 250 252 255 0 247 251 254 0 252 254 0 1 253 0 2 4 95 71 35 19 9 7 6 149 2 0 0 0 24 255 0 0 0 254 254 255 0 251 252 254 0 251 252 255 0 0 0 0 0 251 254 255 0 4 3 0 0 5 4 1 0 254 254 255 0 247 250 254 0 251 252 255 0 0 255 255 0 192 211 243 0 6 5 3 0 247 249 252 6 4 0 0 0 10 252 254 255 0 0 0 255 0 247 250 254 0 0 0 0 0 2 1 1 0 0 255 0 0 5 4 2 0 1 0 1 0 248 251 254 0 247 249 255 0 254 255 255 0 254 255 0 0 254 255 255 0 232 233 243 0 0 255 255 1 4 0 0 255 4 253 255 255 0 255 255 0 0 249 252 255 0 0 0 0 0 125 96 48 0 7 243 241 0 6 219 227 0 250 40 43 0 246 250 1 0 252 254 254 0 254 254 0 0 255 0 255 0 45 231 210 0 37 233 236 0 27 251 7 0 4 0 0 0 1 254 253 0 0 0 255 255 0 131 160 207 0 1 1 1 0 22 253 245 0 102 244 206 0 15 252 241 0 200 3 201 0 164 15 49 0 255 0 0 0 0 0 0 0 70 233 207 0 84 241 210 0 2 8 8 0 80 247 12 0 2 0 255 0 0 254 255 254 0 254 254 253 0 22 23 27 0 21 23 26 0 33 13 8 0 30 248 237 0 255 11 11 0 60 250 227 0 109 236 198 0 18 19 22 0 82 240 212 0 79 240 209 0 6 19 19 0 253 242 241 0 0 250 250 0 4 0 0 0 0 253 253 0 0 255 255 0 0 0 0 0 0 1 255 255 0 223 12 28 0 189 17 46 0 65 235 206 0 2 16 17 0 40 238 228 0 123 192 135 0 5 4 2 0 6 22 20 0 248 228 228 0 227 255 9 0 147 16 56 0 2 0 0 0 0 252 253 254 0 0 0 255 0 0 0 255 0 255 0 255 0 0 0 0 0 191 28 58 0 204 6 29 0 250 231 230 0 5 15 15 0 14 25 22 0 9 23 21 0 248 227 227 0 227 243 252 0 180 79 108 0 0 254 253 0 4 0 0 255 0 253 254 255 0 0 255 0 0 126 89 28 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 108 0 253 101 101 0 0 247 249 0 0 219 218 0 0 26 25 0 250 235 236 0 147 79 137 0 29 252 253 0 255 0 255 0 4 2 1 1 0 253 254 0 0 255 0 255 0 255 255 0 0 145 198 100 0 0 0 0 0 0 0 0 0 56 203 252 0 55 0 4 0 0 255 254 0 0 23 23 0 0 4 4 0 5 12 11 0 84 193 154 0 195 76 97 0 0 255 255 0 4 0 1 0 0 254 254 255 0 1 0 0 0 0 0 0 0 58 28 93 0 0 0 0 0 24 194 208 0 31 211 210 0 6 19 18 0 248 228 227 0 247 233 233 0 4 8 9 0 13 28 27 0 50 227 222 0 8 175 147 0 174 15 71 0 4 255 255 255 255 253 254 255 1 0 0 255 0 0 0 0 0 198 228 163 0 38 219 253 0 54 193 0 0 5 18 17 0 247 229 229 0 230 253 236 0 172 126 30 0 57 169 227 0 46 214 217 0 16 34 33 0 40 222 223 0 103 237 183 0 4 254 255 0 224 250 252 254 33 51 35 10 0 1 1 0 0 112 59 156 0 254 5 202 0 255 198 155 0 247 227 228 0 250 23 23 0 28 147 165 0 111 255 255 0 1 59 1 0 243 121 120 0 238 193 193 0 2 11 12 0 241 4 10 246 1 54 106 186 143 255 255 255 38 0 0 255 57 0 255 255 17 0 0 254 0 255 255 255 0 61 244 219 0 42 244 227 0 152 21 60 0 255 255 254 0 0 255 254 0 0 254 254 0 255 0 0 0 87 224 189 255 2 4 4 250 167 29 63 204 75 62 121 113 17 192 250 162 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: ''!
diskPng
	| cache |
	cache := #(nil) beMutable.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 1 254 73 68 65 84 24 25 5 193 61 139 93 85 24 6 208 181 207 236 59 67 130 146 168 96 132 68 68 3 10 86 1 101 32 241 163 21 127 130 133 104 145 42 66 208 34 165 54 86 86 34 162 8 99 161 216 10 118 130 98 97 149 34 22 22 193 78 197 66 180 18 197 12 222 153 123 246 126 31 215 106 135 111 124 247 22 30 195 243 120 2 247 145 142 38 192 222 210 44 75 147 148 42 255 236 111 252 188 61 93 223 187 243 241 203 95 118 60 125 116 235 218 117 154 167 46 30 8 82 177 27 177 91 203 222 210 156 57 88 180 198 241 182 28 159 204 115 191 254 121 124 229 243 111 126 249 228 240 198 215 231 22 188 32 124 117 231 95 21 146 184 249 225 15 170 66 107 54 189 89 150 102 55 98 187 150 81 218 180 244 215 94 186 252 208 153 131 253 143 22 60 18 84 197 58 202 58 2 214 138 190 199 166 55 85 177 221 149 117 132 196 247 119 239 217 223 236 217 158 142 253 142 179 163 130 216 238 10 44 173 17 54 125 209 52 39 107 217 158 70 37 42 84 226 143 191 78 72 90 39 125 38 18 78 71 192 219 175 95 177 233 139 190 176 206 248 239 180 140 42 85 68 164 202 58 166 164 116 180 154 72 188 251 217 143 90 107 150 198 166 47 26 70 197 24 37 0 56 127 254 65 235 216 35 209 133 74 169 154 30 190 112 145 70 19 2 81 161 170 36 81 137 170 162 53 235 58 72 233 48 39 9 208 18 160 81 69 18 68 130 68 75 36 101 93 155 164 116 24 179 16 16 209 52 18 73 164 74 68 18 85 83 42 162 156 174 33 165 19 179 66 120 231 149 75 0 0 0 0 224 214 209 79 198 136 164 244 165 53 179 136 72 248 224 246 117 0 0 0 112 243 234 145 57 135 221 8 137 174 81 21 13 112 237 210 171 0 0 0 0 106 150 185 6 165 39 201 172 52 2 110 255 254 5 0 0 0 120 246 209 23 205 57 173 51 146 164 87 252 182 27 245 248 51 151 207 106 141 55 159 251 20 0 0 0 192 133 251 203 156 129 191 219 225 141 111 223 79 242 36 185 42 121 128 146 132 148 164 72 73 138 20 137 36 72 200 61 109 185 251 63 33 124 110 139 109 16 176 162 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: ''!
editPng
	| cache |
	cache := #(nil) beMutable.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 1 84 73 68 65 84 56 203 173 147 63 72 2 113 24 134 93 91 11 131 150 112 169 150 64 4 155 92 228 104 136 134 20 90 114 48 140 6 43 146 134 160 173 165 166 16 202 144 192 224 220 178 212 72 130 108 72 168 72 139 238 188 224 42 36 58 212 226 50 44 194 26 236 196 83 146 183 188 225 32 42 251 65 13 239 246 61 207 7 223 31 13 0 205 95 66 92 120 31 211 55 165 195 150 167 164 215 90 99 60 3 184 244 235 111 111 214 122 218 136 5 66 208 138 235 192 4 202 34 11 57 199 33 185 66 33 62 103 136 144 118 135 148 218 128 44 158 160 146 59 83 82 78 239 131 245 88 106 68 176 252 156 128 124 23 68 54 50 9 137 15 40 169 11 56 239 96 153 8 126 147 118 80 18 198 240 202 79 225 220 111 67 118 115 26 236 178 5 13 135 248 9 206 56 32 93 245 162 250 178 136 124 212 14 97 201 132 134 91 32 133 191 21 28 122 186 136 225 47 130 189 133 78 20 243 7 196 176 42 240 141 234 116 117 88 228 182 193 132 156 196 176 42 240 186 218 81 20 25 84 31 46 176 59 107 68 98 213 128 204 177 11 60 221 143 211 121 35 126 61 229 186 160 242 113 93 133 240 8 30 125 102 196 157 90 132 29 173 136 206 116 131 232 23 108 84 51 82 180 29 37 126 29 5 62 132 35 119 31 17 172 10 134 204 45 24 166 180 160 199 59 20 48 230 54 109 253 251 55 254 148 119 85 92 247 38 28 31 157 2 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: ''!
emailPng
	| cache |
	cache := #(nil) beMutable.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 19 73 68 65 84 24 25 165 193 203 78 19 97 24 128 225 247 251 231 239 244 64 167 7 57 84 41 133 88 19 226 214 107 240 2 92 123 5 110 189 1 247 174 221 186 51 113 33 59 19 77 136 46 48 145 133 26 221 179 192 4 108 165 82 218 2 29 74 59 211 153 255 147 98 162 238 251 60 162 170 204 195 48 39 251 228 249 231 157 92 33 184 215 11 167 11 23 147 196 56 5 135 146 58 197 169 146 170 226 156 146 58 37 117 74 234 84 145 116 58 189 60 239 181 246 246 247 237 114 181 220 120 244 96 179 20 77 85 114 89 143 255 9 255 8 87 4 4 24 71 137 55 142 210 213 135 79 163 137 233 14 147 102 156 56 121 185 211 161 213 139 25 69 202 97 223 209 26 56 218 103 142 206 185 163 27 42 189 145 50 77 161 221 143 121 246 166 195 233 40 50 193 114 227 142 25 69 169 100 51 134 250 173 18 239 190 117 57 187 152 82 43 9 25 15 124 79 240 173 224 91 168 228 133 254 48 102 107 247 152 202 141 18 139 149 44 87 196 92 78 18 102 154 55 139 172 213 74 108 127 237 114 26 78 89 42 26 124 11 190 7 229 156 48 8 99 182 118 187 44 45 150 104 214 139 136 114 205 140 38 41 51 214 131 230 106 145 229 106 129 87 31 90 12 194 152 114 78 8 114 66 63 140 121 241 190 69 185 92 160 185 90 36 111 249 203 140 198 9 51 34 144 76 19 114 214 177 94 175 240 246 75 151 118 111 66 187 55 225 245 167 46 141 122 133 192 79 49 154 224 91 254 16 176 151 81 138 2 113 156 112 60 8 105 212 2 124 63 67 103 144 227 227 222 16 3 108 54 170 212 22 243 140 38 49 157 94 200 82 53 64 21 80 193 94 70 137 166 78 165 219 15 105 44 7 228 115 25 80 184 189 82 96 125 165 128 0 162 224 80 108 193 199 174 4 28 157 12 25 87 242 160 78 237 104 240 243 32 138 147 141 187 107 121 41 230 141 136 73 49 128 8 136 8 51 2 8 87 132 43 150 141 106 224 14 126 133 241 240 164 125 100 227 139 147 195 251 143 183 171 217 96 97 193 102 61 177 214 195 120 130 103 192 24 193 88 16 64 132 107 2 154 38 113 60 62 63 237 159 124 111 253 16 85 101 30 134 57 25 230 244 27 253 73 249 123 240 200 177 91 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: ''!
groupPng
	| cache |
	cache := #(nil) beMutable.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 131 73 68 65 84 56 203 141 209 77 76 210 113 28 6 112 235 208 150 30 58 117 232 237 128 100 29 210 214 139 206 57 182 136 240 208 88 186 230 64 134 168 200 66 76 201 161 34 25 6 100 130 165 91 138 254 193 63 90 41 148 232 223 82 12 205 17 235 162 7 109 166 226 123 88 107 131 67 10 221 154 57 107 203 240 137 216 50 155 204 60 60 167 223 190 159 61 123 126 81 0 162 118 138 154 123 88 60 111 142 91 89 234 60 2 175 149 182 110 145 199 182 165 39 199 238 251 243 190 227 177 156 115 148 237 235 160 5 151 187 14 97 107 90 101 244 198 93 1 109 162 131 196 114 95 34 252 174 124 124 27 171 135 223 206 192 50 117 12 11 102 250 151 93 1 36 247 64 125 96 198 133 149 81 18 235 51 79 176 250 134 196 210 180 19 67 186 179 190 93 1 25 156 76 169 199 86 182 241 117 182 23 193 197 62 172 45 56 16 24 38 80 157 123 209 30 17 144 178 226 196 205 226 75 43 68 14 11 100 30 123 189 144 159 48 73 84 200 126 4 236 10 124 234 191 139 192 128 6 35 45 55 112 58 255 148 51 73 25 31 243 15 32 98 28 103 55 139 83 131 141 66 22 182 166 221 32 135 177 85 143 58 147 6 119 30 40 209 255 206 134 154 161 106 36 104 79 90 207 40 78 68 111 2 6 254 185 145 135 133 87 209 87 117 13 158 46 53 58 21 60 16 57 108 180 20 164 194 50 163 134 121 170 2 13 238 82 212 186 203 208 243 190 13 37 142 98 164 20 38 145 155 128 137 79 239 249 56 68 109 27 140 170 100 193 48 117 11 117 110 37 116 19 37 184 61 81 4 213 219 34 136 201 60 120 201 244 255 15 86 167 227 194 52 173 66 67 168 129 97 234 38 154 66 41 31 148 33 203 144 5 255 163 43 127 129 189 231 155 84 38 85 241 182 193 226 121 229 144 216 178 113 189 91 128 2 74 0 73 71 38 46 232 25 62 165 180 170 202 107 17 8 195 199 123 24 221 146 12 133 123 117 248 51 112 239 185 29 154 118 10 74 194 138 199 227 223 161 52 45 97 127 74 183 53 134 217 26 29 233 171 163 104 156 22 30 79 62 184 54 176 24 132 222 3 228 143 3 185 195 64 230 32 192 167 0 98 20 16 106 60 136 99 215 144 17 129 57 125 226 207 201 94 35 20 47 2 16 185 0 145 99 3 66 106 3 60 107 16 105 102 32 205 24 196 83 203 203 240 96 17 1 95 19 211 223 91 83 10 129 118 12 210 215 128 248 85 168 129 3 200 25 0 178 127 183 168 245 66 171 184 31 30 44 34 240 161 163 32 197 89 157 81 153 204 179 57 18 75 38 192 210 206 133 50 15 150 122 22 204 74 55 232 151 159 249 140 229 146 240 96 145 128 95 65 127 178 0 144 183 124 65 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: ''!
leavePng
	| cache |
	cache := #(nil) beMutable.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 217 7 23 18 49 16 66 67 52 185 0 0 4 27 73 68 65 84 56 17 1 16 4 239 251 1 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 213 157 110 137 254 254 253 114 253 253 252 243 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 215 159 113 219 254 254 253 36 6 21 24 0 223 224 213 0 18 2 6 252 4 0 0 0 0 0 0 0 0 129 129 129 255 254 254 254 0 254 254 254 0 254 254 254 0 253 253 253 0 254 254 254 0 253 253 253 0 98 44 255 0 2 0 254 0 6 20 24 0 12 33 36 0 254 253 254 0 255 223 211 0 251 251 249 0 4 0 0 0 0 0 0 0 0 253 253 253 0 28 28 28 0 0 0 0 0 1 1 1 0 0 0 0 0 1 1 1 0 0 0 0 0 255 255 212 0 17 52 59 0 0 0 1 0 249 244 237 0 253 251 249 0 255 255 254 0 251 251 252 0 2 0 0 0 0 0 0 0 0 253 253 253 0 0 0 0 0 83 109 109 0 255 0 255 0 1 1 1 0 1 1 1 0 1 1 1 0 253 253 253 0 254 253 253 0 248 240 228 0 251 246 241 0 254 251 250 0 255 254 253 0 251 251 249 0 2 0 0 0 0 0 0 0 0 253 253 253 0 1 1 1 0 0 0 0 0 83 108 109 0 1 1 1 0 1 1 1 0 1 1 1 0 252 252 250 0 254 253 251 0 253 252 250 0 254 252 250 0 254 252 249 0 255 254 254 0 250 250 248 0 4 237 7 7 255 0 0 0 0 117 0 0 0 0 0 0 0 0 60 60 0 0 0 0 0 80 106 106 0 178 152 152 0 0 0 0 0 253 252 250 0 255 252 252 0 254 251 250 0 253 252 250 0 0 255 1 0 255 254 254 0 252 251 248 0 4 0 0 0 0 254 132 132 0 0 0 0 0 0 0 0 0 0 0 0 0 3 229 229 0 255 0 0 0 78 104 104 0 179 153 153 0 251 252 250 0 254 252 250 0 253 251 249 0 255 252 248 0 23 21 234 0 220 255 252 0 250 250 249 0 2 0 0 0 0 0 0 0 0 3 229 229 0 3 229 229 0 3 229 229 0 0 0 0 0 1 45 45 0 0 60 60 0 77 103 103 0 251 251 250 0 253 252 252 0 253 250 249 0 11 9 239 0 18 16 237 0 5 3 247 0 251 251 248 0 4 0 0 0 0 0 0 0 0 253 27 27 0 0 0 0 0 0 0 0 0 0 0 0 0 2 184 184 0 228 199 199 0 209 155 155 0 25 227 171 0 254 252 249 0 253 251 249 0 240 238 3 0 254 252 20 0 249 250 232 0 251 251 249 0 4 0 0 0 0 237 126 126 0 249 1 1 0 0 0 0 0 28 57 57 0 0 0 0 0 228 199 199 0 209 152 152 0 1 1 1 0 250 250 249 0 254 252 251 0 254 251 249 0 253 251 251 0 237 249 4 0 0 254 254 0 251 251 250 0 4 19 249 249 1 19 0 0 0 97 97 97 255 64 64 64 0 0 105 105 0 0 0 0 0 210 153 153 0 1 0 0 0 1 1 1 0 252 251 248 0 254 252 250 0 253 252 251 0 253 252 249 0 1 1 4 0 254 254 254 0 252 252 250 0 4 0 0 0 0 0 0 0 0 252 252 252 0 1 1 1 0 0 0 0 0 209 152 151 0 2 1 1 0 0 0 0 0 1 1 1 0 250 251 249 0 253 252 251 0 253 251 249 0 254 251 250 0 1 1 254 0 255 255 254 0 252 252 250 0 4 0 0 0 0 0 0 0 0 252 252 252 0 1 1 1 0 210 153 153 0 2 1 1 0 1 1 1 0 0 0 0 0 1 1 1 0 251 251 249 0 254 252 251 0 10 17 29 0 254 252 251 0 252 249 246 0 0 255 232 0 253 253 252 0 1 153 153 153 255 216 216 216 0 227 227 227 0 253 253 253 0 254 254 254 0 253 253 253 0 254 254 254 0 253 253 253 0 254 254 254 0 88 34 224 0 11 13 13 0 7 8 11 0 6 8 10 0 5 6 7 0 243 244 240 0 226 217 206 235 1 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 156 100 30 22 253 253 252 35 253 253 251 41 253 253 252 38 254 254 253 28 2 4 6 88 253 251 249 241 236 202 118 155 98 198 180 57 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'uploaded' stamp: ''!
logPng
	| cache |
	cache := #(nil) beMutable.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 27 73 68 65 84 56 203 141 83 207 107 19 81 16 158 253 65 233 218 212 67 186 187 241 144 244 40 133 162 224 169 228 84 16 17 61 10 66 240 80 108 15 237 169 255 129 8 69 232 201 171 130 151 178 133 30 74 14 189 136 166 82 148 232 69 60 136 73 91 108 150 34 38 164 44 36 45 65 170 198 252 216 221 183 206 188 237 190 108 232 37 143 29 246 189 217 249 102 190 55 223 172 20 4 1 148 203 229 123 127 222 191 220 245 90 14 120 205 42 220 181 236 57 24 109 157 74 165 82 233 166 239 251 159 153 219 157 80 192 135 179 87 43 112 103 227 251 72 104 85 85 231 212 124 62 111 103 179 217 213 241 163 130 149 152 66 111 0 224 186 238 80 32 99 12 136 105 252 172 105 90 152 36 151 203 205 32 131 23 204 92 0 5 60 248 253 169 120 169 146 44 203 28 20 45 73 146 68 66 193 96 236 160 96 77 154 232 100 97 0 173 103 59 77 32 28 133 114 0 227 15 172 61 212 7 215 16 12 12 100 32 121 112 254 225 163 72 64 224 217 140 118 145 32 180 253 90 155 127 67 204 48 3 117 255 173 117 85 15 120 37 145 0 247 135 181 127 188 106 192 240 27 243 209 23 246 0 175 197 239 52 80 161 143 42 32 3 231 249 50 220 207 31 241 68 241 123 211 217 243 60 225 71 107 39 147 201 249 1 131 111 111 172 73 35 228 25 5 61 217 110 224 219 71 186 1 248 193 133 18 168 208 90 206 36 6 19 152 87 137 245 224 49 87 225 215 94 81 116 122 253 209 53 14 34 67 205 5 155 110 183 11 213 106 21 20 69 145 101 98 224 56 206 106 179 176 9 127 191 110 1 22 20 18 69 114 69 13 139 192 149 74 5 82 169 20 249 89 140 193 34 200 200 160 181 91 140 169 192 132 145 175 211 233 128 109 219 144 201 100 64 215 245 97 21 228 47 175 173 132 137 77 243 47 79 32 49 160 202 4 78 167 211 96 24 198 96 168 226 42 16 131 218 211 37 120 176 247 131 131 9 72 157 239 245 122 208 104 52 120 85 211 52 227 19 25 254 11 24 116 227 86 229 221 207 43 73 141 15 11 53 136 128 100 17 11 26 103 74 82 175 215 249 190 223 239 135 73 162 134 45 93 159 154 159 78 140 221 118 218 238 201 198 113 235 96 212 223 249 63 187 234 124 213 62 200 182 149 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'rendering' stamp: 'sebh 7/14/2009 00:53'!
selectorsToInclude

	^ #(styleCss).! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'martin 7/24/2009 17:59'!
styleCss
	^'
body {
	font-family: "Trebuchet MS",sans-serif;
	font-size: 0.85em;
	padding: 0 0 0 0;
	margin: 0 0 0 0;
}

a {
	color:#A62940;
	text-decoration:none;
}

#lightbox {
	background-color: #fff;
	padding: 10px;
	-moz-border-radius: 5px;
	-webkit-border-radius: 5px;
	overflow:auto;
	max-height:92%;
	min-width:40%;
	max-width:92%;
}

#lightbox form dl {
	margin-bottom: 5px;
	padding-bottom:5px;
}

.errors {
	border: 1px solid #F00;
}

.error {
	color: #F00;
}

.header {
	width: 100%;
	background-color: #df6824;
	height:100px;
	border-bottom: 5px solid #dfa27f;
}

.header img {
	padding:5px;
	float:left;
}

.footer {
	width:100%;
	height:20px;
	position:fixed;
	bottom:0px;
}

li.active a {
	background-color: #000 !!important;
}

.menu {
	float:left;
	margin-top: 5px;
}

.menu ul {
	clear: both;
}

.menu li {
	float: left;
	list-style:none;
	padding: 0 2px 0 2px;
}

.menu a {
	background-color: #fff;
	text-decoration: none;
	font-weight: bold;
	line-height: 30px;
	padding: 3px;
	color: #df6824;
}

.component {
	margin-bottom: 10px;
	border-bottom: 2px dotted #eee;
}


table caption, h2, h3 {
	font-size: 18pt;
}

.odd { background-color: #fadbab; }
.even{ background-color: #fff }

dl{
	margin:15px 0px 0px 0px;
	padding:0px;
	width:auto;
	clear:both;
}
	
dt{
	float:left;
	width:190px;
	margin:0px 0px 5px 0px;
}
	
dd {
	margin:0px 0px 10px 190px;
	color:#666666;
}

dd:empty:after {
	content:".";
	color:#fff;
}

dd label{
	vertical-align:top;
	margin:0px 8px 0px 0px;
	line-height:1.6em;
	}
	
caption {
	width: 600px;
}

.helptext:before {
	content:".";
	color:#fff;
}

.buttons {
	float:left;
}

.warning, 
.over {
}

.warning {
	background-color: #fc0;
}

.over { background-color: #df2424; }
.over a { color: #fff; padding:3px; }

.content {
	margin-top: 25px;
	margin-bottom: 50px;
	margin-left: 90px;
}

.content td, .content th {
	padding: 3px;
}

.content dt.required {
	font-weight: bold;
}

.helptext {
	font-size: 10px;
	color: #777;
}
.graph { 
        position: relative;
        width: 275px; 
        border: 1px solid #B1D632; 
        padding: 2px; 
    }
.graph .bar { 
        display: block;
        position: relative;
        background: #B1D632; 
        text-align: center; 
        color: #333; 
        height: 2em; 
        line-height: 2em;            
    }
.graph .bar span { position: absolute; left: 1em; }

.Admin a {
	background-color: FireBrick;
	color: white;
}

.iconstring {
	display: inline;
	margin: 0 0 0 5px;
	color: #F29B30;
	vertical-align: middle;
}

.iconpic {
	display: inline;
	margin: 0 0 0 2px;
	vertical-align: middle;
}

tr {
	vertical-align: middle;
}

.deletionDescription {
	float: left;
	min-width: 130px;
}

.deletionItem {
	float: left;
	margin: 0 0 0 5px;
}

.clearFloat {
	clear: both;
}
'! !

!DLFileLibrary methodsFor: 'uploaded' stamp: ''!
togglePng
	| cache |
	cache := #(nil) beMutable.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 217 7 23 18 23 1 235 45 151 111 0 0 4 27 73 68 65 84 56 17 1 16 4 239 251 1 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 129 172 233 0 127 170 233 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 0 254 0 0 0 117 163 227 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 249 252 252 0 49 31 7 0 19 14 6 0 97 150 222 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 255 255 255 0 0 0 0 0 127 71 16 255 18 10 2 0 12 7 2 0 18 10 2 0 21 12 3 0 22 12 2 0 11 10 9 0 2 10 18 0 2 10 18 0 2 7 12 0 1 5 9 0 0 0 0 245 20 92 163 12 0 0 0 0 4 0 0 0 0 0 0 0 0 240 247 254 156 61 34 7 100 46 50 54 0 1 6 11 0 2 7 12 0 1 6 11 0 1 6 11 0 2 8 14 0 1 5 9 0 0 2 4 0 249 222 195 255 0 0 0 147 0 0 0 0 0 0 0 0 1 255 255 255 0 0 0 0 0 0 0 0 0 116 65 15 160 75 42 9 95 43 51 59 0 255 252 249 0 1 1 1 0 1 8 15 0 3 13 23 0 3 12 21 0 252 236 220 0 252 242 232 136 23 102 180 121 0 0 0 0 0 0 0 0 1 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 122 68 15 162 76 43 10 93 37 50 63 0 255 252 249 0 2 7 12 0 3 16 29 0 251 232 213 0 252 240 228 143 26 116 205 114 0 0 0 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 188 52 196 94 189 218 247 170 225 209 193 0 2 7 12 0 1 6 11 0 248 217 186 0 242 223 204 159 26 116 205 114 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 238 247 251 0 252 96 210 87 188 163 47 3 75 4 189 83 14 8 2 0 215 233 251 165 72 153 233 98 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 247 244 252 0 247 251 254 0 245 245 254 88 190 219 248 175 12 7 2 47 99 168 236 92 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 25 90 197 0 35 24 8 0 218 212 237 0 234 186 70 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 254 245 252 0 217 208 235 0 235 190 72 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 135 106 130 208 82 213 176 98 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DLFileLibrary methodsFor: 'requestHandling' stamp: 'sebh 7/2/2009 21:50'!
updateRoot:	anHtmlRoot
	anHtmlRoot stylesheet url: 'http://yui.yahooapis.com/2.7.0/build/reset/reset-min.css'.
	super updateRoot: anHtmlRoot.
	! !

MAFileUploadComponent subclass: #DLMADeliverableFileUploadComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMADeliverableFileUploadComponent methodsFor: 'accessing' stamp: 'sebh 6/17/2009 02:35'!
isMultipart
	^ true! !

!DLMADeliverableFileUploadComponent methodsFor: 'rendering' stamp: 'sebh 6/17/2009 02:36'!
renderEditorOn: html
	self value isNil
		ifTrue:  [ self renderUploadOn: html ]
		ifFalse: [ self renderReplaceOn: html ]! !

!DLMADeliverableFileUploadComponent methodsFor: 'rendering' stamp: 'Marik 7/23/2009 20:59'!
renderReplaceOn: html
	html anchor
		url: (self value urlOn: html);
		with: self value filename.
	html text: ' ('; render: self value filesize asFileSize; text: ') '.
	
	html fileUpload
		id: self labelId;
		on: #replace of: self.! !

!DLMADeliverableFileUploadComponent methodsFor: 'rendering' stamp: 'Marik 7/23/2009 20:59'!
renderUploadOn: html
	html fileUpload
		id: self labelId;
		on: #upload of: self.! !

!DLMADeliverableFileUploadComponent methodsFor: 'rendering' stamp: 'Marik 7/23/2009 20:40'!
renderViewerOn: html
	html anchor
		url: (self value urlOn: html);
		with: self value filename.! !

!DLMADeliverableFileUploadComponent methodsFor: 'accessing' stamp: 'sebh 6/17/2009 02:36'!
replace: aFile
	aFile notNil ifTrue:[ 
		self value finalize.
		self value: nil.
		self upload: aFile.
	].
	! !

!DLMADeliverableFileUploadComponent methodsFor: 'accessing' stamp: 'Marik 7/14/2009 16:09'!
upload: aFile
	self value: (aFile isNil ifFalse: [
		self description kind new
			mimetype: aFile contentType;
			filename: aFile fileName;
			location: {
				memento model delivery deadline lecture semester canonicalName. 
				memento model delivery deadline lecture lectureName. 
				memento model delivery deadline canonicalName. 
				memento model delivery group canonicalName
				};
			contents: aFile contents;
			yourself ])! !

MAStringDescription subclass: #DLMAMailDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAMailDescription methodsFor: 'accessing' stamp: 'Marik 7/13/2009 16:05'!
isSortable

	^ false! !

MAReport subclass: #DLMAGroupedReport
	instanceVariableNames: 'groupField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAGroupedReport methodsFor: 'accessing' stamp: 'sebh 6/21/2009 00:26'!
groupField

	^ groupField! !

!DLMAGroupedReport methodsFor: 'accessing' stamp: 'sebh 6/21/2009 00:26'!
groupField: anObject

	groupField := anObject.! !

!DLMAGroupedReport methodsFor: 'rendering' stamp: 'Marik 7/24/2009 12:55'!
renderTableBodyOn: html 
	self visible isEmpty 
		ifTrue: [ 
			html tableRow
				class: 'empty';
				with: [ 
					html tableData
						colSpan: self visibleColumns size;
						with: self tableEmpty ] ]
		ifFalse: [
			| grouping |
			grouping := Dictionary new.
			self visible keysAndValuesDo: [ :index :row |
				| groupstring |
				groupstring := (row perform: self groupField) asString.
				grouping at: groupstring ifAbsentPut: OrderedCollection new.
				(grouping at: groupstring) add: row.
				].
			
			grouping keysAndValuesDo: [ :head :groupedrows |
				html tableRow class:'grouping'; with: [ html tableData: head].
				groupedrows keysAndValuesDo: [ :index :row | 
				html tableRow
					class: (self rowStyleForNumber: index);
					with: [ 
						self visibleColumns do: [ :col | 
							col 
								renderCell: row
								index: index
								on: html ] ] ] ] ]! !

MAReport subclass: #DLMAReport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAReport methodsFor: 'style' stamp: 'sebh 7/23/2009 20:06'!
cssStyle: aString
	properties at: #cssStyle put: aString! !

!DLMAReport methodsFor: 'rendering' stamp: 'sebh 7/23/2009 20:11'!
renderContentOn: html
	html table
		id: self ajaxId; 
		class: 'report';
		style: (properties at: #cssStyle ifAbsent: ['']);
		with: [ self renderTableOn: html ]! !
